﻿using System;
using System.Data.Objects;
using System.Linq;
using System.Web.UI.WebControls.Expressions;
using WWWings35_GO.EF;
namespace ASPNET4Demos.EDS
{
  public partial class EDSdemo_QE : System.Web.UI.Page
  {
    
    /// <summary>
    ///  Sorgt dafür, dass es keine Flüge aus der Vergangenheit angezeigt werden
    /// </summary>
    /// <param name="query"></param>
    /// <returns></returns>
    public static IQueryable<Flug> FlugFilter_Datum(ObjectQuery<Flug> q)
    {
      return from p in q.Cast<Flug>()
             where p.Datum >= DateTime.Now
             select p;
    }


    /// <summary>
    /// Filtern für Datum und Zeit
    /// </summary>
    protected void FlugFilter_Zeit(object sender, CustomExpressionEventArgs e)
    {

      // Filter nach Datum
      if (!this.C_KeinDatum.Checked)
      {
        e.Query = from p in e.Query.Cast<Flug>()
                  where p.Datum >= this.C_Datum.SelectedDate
                  select p;
      }


      // Filtern nach Raucherflug
      e.Query = from p in e.Query.Cast<Flug>()
                where p.NichtRaucherFlug != this.C_Raucherfluege.Checked
                select p;

      // Filtern nach Tageszeit
      if (this.C_Tageszeit.Text == "Morgens")
        e.Query = from p in e.Query.Cast<Flug>()
                  where p.Datum.Hour >= 0 && p.Datum.Hour < 12
                  select p;
      if (this.C_Tageszeit.Text == "Nachmittags")
        e.Query = from p in e.Query.Cast<Flug>()
                  where p.Datum.Hour >= 12 && p.Datum.Hour < 18
                  select p;
      if (this.C_Tageszeit.Text == "Abends")
        e.Query = from p in e.Query.Cast<Flug>()
                  where p.Datum.Hour >= 18 && p.Datum.Hour <= 23
                  select p;

      //int Plaetze;
      //if (Int32.TryParse(this.C_Plaetze.Text, out Plaetze))
      //{
      //    e.Query = from p in e.Query.Cast<Flug>()
      //              where p.FreiePlaetze >= Plaetze
      //              select p;
      //}

      //e.Query = from p in e.Query.Cast<Flug>()
      //          where p.FlugNr <= 110
      //          select p;
    }

    protected void C_Suchen_Click(object sender, EventArgs e)
    {
      this.DataBind();
    }

    protected void C_KeinDatum_CheckedChanged(object sender, EventArgs e)
    {
      this.C_Datum.Enabled = !this.C_KeinDatum.Checked;
    }

  }
}