SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[ADMIN_SkinkLog]
	/*
	(
	@parameter1 int = 5,
	@parameter2 datatype OUTPUT
	)
	*/
AS

alter database WWWings6 set recovery simple 
dbcc shrinkfile (WWWings6_Log, 1) 
alter database WWWings6 set recovery full

	RETURN

GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[ADMIN_EnableBroker]

AS

select name, is_broker_enabled from sys.databases

ALTER DATABASE WORLDWIDEWINGS SET ENABLE_BROKER;

		RETURN

GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Metadaten](
	[Name] [nvarchar](20) COLLATE Latin1_General_CI_AS NOT NULL,
	[Value] [text] COLLATE Latin1_General_CI_AS NULL,
	[Timestamp] [timestamp] NOT NULL,
 CONSTRAINT [PK_MD_Metadata] PRIMARY KEY CLUSTERED 
(
	[Name] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON)
)

GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Protokoll](
	[ID] [int] IDENTITY(1,1) NOT NULL,
	[Text] [text] COLLATE Latin1_General_CI_AS NOT NULL,
	[Zeit] [datetime] NOT NULL,
 CONSTRAINT [PK_Protokoll] PRIMARY KEY CLUSTERED 
(
	[ID] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON)
)

GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Person](
	[PersonID] [int] NOT NULL,
	[Name] [nvarchar](50) COLLATE Latin1_General_CI_AS NOT NULL,
	[Vorname] [nvarchar](50) COLLATE Latin1_General_CI_AS NOT NULL,
	[Land] [nvarchar](2) COLLATE Latin1_General_CI_AS NULL,
	[Geburtstag] [datetime] NULL,
	[Foto] [varbinary](max) NULL,
	[EMail] [nvarchar](50) COLLATE Latin1_General_CI_AS NULL,
	[Stadt] [nvarchar](30) COLLATE Latin1_General_CI_AS NULL,
	[Memo] [text] COLLATE Latin1_General_CI_AS NULL,
 CONSTRAINT [PK_PE_Person] PRIMARY KEY CLUSTERED 
(
	[PersonID] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON)
)

GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Passagier](
	[PersonID] [int] NOT NULL,
	[KundeSeit] [datetime] NULL,
	[KundenStatus] [nchar](1) COLLATE Latin1_General_CI_AS NULL,
 CONSTRAINT [PK_PS_Passagier] PRIMARY KEY CLUSTERED 
(
	[PersonID] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON)
)

GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Mitarbeiter](
	[PersonID] [int] NOT NULL,
	[MitarbeiterNr] [int] NULL,
	[Einstellungsdatum] [date] NULL,
	[VorgesetzterPersonID] [int] NULL,
 CONSTRAINT [PK_MI_Mitarbeiter_1] PRIMARY KEY CLUSTERED 
(
	[PersonID] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON)
)

GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Pilot](
	[PersonID] [int] NOT NULL,
	[FlugscheinSeit] [date] NULL,
	[Flugscheintyp] [nchar](1) COLLATE Latin1_General_CI_AS NULL,
	[Flugstunden] [int] NULL,
	[Flugschule] [nvarchar](50) COLLATE Latin1_General_CI_AS NULL,
 CONSTRAINT [PK_PI_Pilot] PRIMARY KEY CLUSTERED 
(
	[PersonID] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON)
)

GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW dbo.AllePassagiere
AS
SELECT        dbo.Passagier.PersonID, dbo.Passagier.KundeSeit, dbo.Passagier.KundenStatus, dbo.Person.Name, dbo.Person.Vorname, dbo.Person.Land, 
                         dbo.Person.Geburtstag, dbo.Person.Foto, dbo.Person.EMail
FROM            dbo.Passagier INNER JOIN
                         dbo.Person ON dbo.Passagier.PersonID = dbo.Person.PersonID

GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW dbo.AlleMitarbeiter
AS
SELECT        dbo.Mitarbeiter.PersonID, dbo.Mitarbeiter.Einstellungsdatum, dbo.Mitarbeiter.MitarbeiterNr, dbo.Mitarbeiter.VorgesetzterPersonID, dbo.Person.Name, 
                         dbo.Person.Vorname, dbo.Person.Land, dbo.Person.Geburtstag, dbo.Person.Foto, dbo.Person.EMail
FROM            dbo.Mitarbeiter INNER JOIN
                         dbo.Person ON dbo.Mitarbeiter.PersonID = dbo.Person.PersonID

GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Flug](
	[FlugNr] [int] NOT NULL,
	[Abflugort] [nvarchar](20) COLLATE Latin1_General_CI_AS NOT NULL,
	[Zielort] [nvarchar](20) COLLATE Latin1_General_CI_AS NOT NULL,
	[Datum] [datetime] NOT NULL,
	[NichtRaucherFlug] [bit] NOT NULL,
	[Plaetze] [smallint] NOT NULL,
	[FreiePlaetze] [smallint] NULL,
	[Pilot_PersonID] [int] NULL,
	[Ankunft] [datetime] NULL,
	[Memo] [text] COLLATE Latin1_General_CI_AS NULL,
	[Test] [text] COLLATE Latin1_General_CI_AS NULL,
 CONSTRAINT [PK_FL_Fluege] PRIMARY KEY CLUSTERED 
(
	[FlugNr] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON)
)

GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE dbo.UpdateFlug
(
	@FlugNr int,
	@Abflugort nvarchar(20),
	@Zielort nvarchar(20),
	@Datum datetime,
	@NichtRaucherFlug bit,
	@Plaetze smallint,
	@FreiePlaetze smallint,
	@Pilot_PersonID int,
	@Ankunft datetime,
	@Memo text,
	@Original_FlugNr int,
	@Original_Abflugort nvarchar(20),
	@Original_Zielort nvarchar(20),
	@Original_Datum datetime,
	@Original_NichtRaucherFlug bit,
	@Original_Plaetze smallint,
	@IsNull_FreiePlaetze Int,
	@Original_FreiePlaetze smallint,
	@IsNull_Pilot_PersonID Int,
	@Original_Pilot_PersonID int,
	@IsNull_Ankunft Int,
	@Original_Ankunft datetime
)
AS
	SET NOCOUNT OFF;
UPDATE [Flug] SET [FlugNr] = @FlugNr, [Abflugort] = @Abflugort, [Zielort] = @Zielort, [Datum] = @Datum, [NichtRaucherFlug] = @NichtRaucherFlug, [Plaetze] = @Plaetze, [FreiePlaetze] = @FreiePlaetze, [Pilot_PersonID] = @Pilot_PersonID, [Ankunft] = @Ankunft, [Memo] = @Memo WHERE (([FlugNr] = @Original_FlugNr) AND ([Abflugort] = @Original_Abflugort) AND ([Zielort] = @Original_Zielort) AND ([Datum] = @Original_Datum) AND ([NichtRaucherFlug] = @Original_NichtRaucherFlug) AND ([Plaetze] = @Original_Plaetze) AND ((@IsNull_FreiePlaetze = 1 AND [FreiePlaetze] IS NULL) OR ([FreiePlaetze] = @Original_FreiePlaetze)) AND ((@IsNull_Pilot_PersonID = 1 AND [Pilot_PersonID] IS NULL) OR ([Pilot_PersonID] = @Original_Pilot_PersonID)) AND ((@IsNull_Ankunft = 1 AND [Ankunft] IS NULL) OR ([Ankunft] = @Original_Ankunft)));
	
SELECT FlugNr, Abflugort, Zielort, Datum, NichtRaucherFlug, Plaetze, FreiePlaetze, Pilot_PersonID, Ankunft, Memo FROM Flug WHERE (FlugNr = @FlugNr)
GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE dbo.InsertFlug
(
	@FlugNr int,
	@Abflugort nvarchar(20),
	@Zielort nvarchar(20),
	@Datum datetime,
	@NichtRaucherFlug bit,
	@Plaetze smallint,
	@FreiePlaetze smallint,
	@Pilot_PersonID int,
	@Ankunft datetime,
	@Memo text
)
AS
	SET NOCOUNT OFF;
INSERT INTO [Flug] ([FlugNr], [Abflugort], [Zielort], [Datum], [NichtRaucherFlug], [Plaetze], [FreiePlaetze], [Pilot_PersonID], [Ankunft], [Memo]) VALUES (@FlugNr, @Abflugort, @Zielort, @Datum, @NichtRaucherFlug, @Plaetze, @FreiePlaetze, @Pilot_PersonID, @Ankunft, @Memo);
	
SELECT FlugNr, Abflugort, Zielort, Datum, NichtRaucherFlug, Plaetze, FreiePlaetze, Pilot_PersonID, Ankunft, Memo FROM Flug WHERE (FlugNr = @FlugNr)
GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[GetRoute]
	(
	@von nvarchar(50),
	@nach nvarchar(50)
	)
AS
	select * from Flug where Abflugort = @von and Zielort = @nach
	RETURN

GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE dbo.GetFlug
(
	@FlugNr int
)
AS
	SET NOCOUNT ON;
Select * from Flug
where     (FlugNr = @FlugNr)
GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE dbo.GetFluege

AS
	SET NOCOUNT ON;
Select * from Flug

GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE dbo.DeleteFlug
(
	@Original_FlugNr int,
	@Original_Abflugort nvarchar(20),
	@Original_Zielort nvarchar(20),
	@Original_Datum datetime,
	@Original_NichtRaucherFlug bit,
	@Original_Plaetze smallint,
	@IsNull_FreiePlaetze Int,
	@Original_FreiePlaetze smallint,
	@IsNull_Pilot_PersonID Int,
	@Original_Pilot_PersonID int,
	@IsNull_Ankunft Int,
	@Original_Ankunft datetime
)
AS
	SET NOCOUNT OFF;
DELETE FROM [Flug] WHERE (([FlugNr] = @Original_FlugNr) AND ([Abflugort] = @Original_Abflugort) AND ([Zielort] = @Original_Zielort) AND ([Datum] = @Original_Datum) AND ([NichtRaucherFlug] = @Original_NichtRaucherFlug) AND ([Plaetze] = @Original_Plaetze) AND ((@IsNull_FreiePlaetze = 1 AND [FreiePlaetze] IS NULL) OR ([FreiePlaetze] = @Original_FreiePlaetze)) AND ((@IsNull_Pilot_PersonID = 1 AND [Pilot_PersonID] IS NULL) OR ([Pilot_PersonID] = @Original_Pilot_PersonID)) AND ((@IsNull_Ankunft = 1 AND [Ankunft] IS NULL) OR ([Ankunft] = @Original_Ankunft)))
GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE dbo.CountFlugByOrt
(
	@Ort nvarchar(20)
)
AS
	SET NOCOUNT ON;
SELECT     COUNT(FlugNr) AS Expr1, Abflugort
FROM         Flug
GROUP BY Abflugort
HAVING      (Abflugort = @Ort)
GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[GetAbflugorte]
	/*
	(
	@parameter1 int = 5,
	@parameter2 datatype OUTPUT
	)
	*/
AS
SELECT DISTINCT Abflugort FROM Flug AS t0 ORDER BY Abflugort
	RETURN

GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Flug_Passagier](
	[Flug_FlugNr] [int] NOT NULL,
	[Passagier_PersonID] [int] NOT NULL,
 CONSTRAINT [PK_FLPS_Flug_Passagier] PRIMARY KEY CLUSTERED 
(
	[Flug_FlugNr] ASC,
	[Passagier_PersonID] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON)
)

GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW dbo.AlleBuchungen
AS
SELECT     dbo.Flug.FlugNr, dbo.Flug.Abflugort, dbo.Flug.Zielort, dbo.Flug.Datum, dbo.Passagier.PersonID
FROM         dbo.Flug INNER JOIN
                      dbo.Flug_Passagier ON dbo.Flug.FlugNr = dbo.Flug_Passagier.Flug_FlugNr INNER JOIN
                      dbo.Passagier ON dbo.Flug_Passagier.Passagier_PersonID = dbo.Passagier.PersonID

GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
Create PROCEDURE [dbo].[GetAlleBuchungen]
as
	select * from AlleBuchungen
	RETURN

GO
ALTER TABLE [dbo].[Protokoll] ADD  CONSTRAINT [DF_Protokoll_Zeit]  DEFAULT (getdate()) FOR [Zeit]
GO
ALTER TABLE [dbo].[Passagier]  WITH CHECK ADD  CONSTRAINT [FK_PS_Passagier_PE_Person] FOREIGN KEY([PersonID])
REFERENCES [dbo].[Person] ([PersonID])
GO
ALTER TABLE [dbo].[Passagier] CHECK CONSTRAINT [FK_PS_Passagier_PE_Person]
GO
ALTER TABLE [dbo].[Mitarbeiter]  WITH CHECK ADD  CONSTRAINT [FK_MI_Mitarbeiter_PE_Person] FOREIGN KEY([PersonID])
REFERENCES [dbo].[Person] ([PersonID])
GO
ALTER TABLE [dbo].[Mitarbeiter] CHECK CONSTRAINT [FK_MI_Mitarbeiter_PE_Person]
GO
ALTER TABLE [dbo].[Mitarbeiter]  WITH CHECK ADD  CONSTRAINT [FK_Mitarbeiter_Mitarbeiter] FOREIGN KEY([VorgesetzterPersonID])
REFERENCES [dbo].[Mitarbeiter] ([PersonID])
GO
ALTER TABLE [dbo].[Mitarbeiter] CHECK CONSTRAINT [FK_Mitarbeiter_Mitarbeiter]
GO
ALTER TABLE [dbo].[Pilot]  WITH CHECK ADD  CONSTRAINT [FK_PI_Pilot_MI_Mitarbeiter] FOREIGN KEY([PersonID])
REFERENCES [dbo].[Mitarbeiter] ([PersonID])
GO
ALTER TABLE [dbo].[Pilot] CHECK CONSTRAINT [FK_PI_Pilot_MI_Mitarbeiter]
GO
ALTER TABLE [dbo].[Flug]  WITH CHECK ADD  CONSTRAINT [FK_FL_Flug_PI_Pilot] FOREIGN KEY([Pilot_PersonID])
REFERENCES [dbo].[Pilot] ([PersonID])
GO
ALTER TABLE [dbo].[Flug] CHECK CONSTRAINT [FK_FL_Flug_PI_Pilot]
GO
ALTER TABLE [dbo].[Flug_Passagier]  WITH CHECK ADD  CONSTRAINT [FK_FLPS_Flug_Passagier_FL_Flug] FOREIGN KEY([Flug_FlugNr])
REFERENCES [dbo].[Flug] ([FlugNr])
ON DELETE CASCADE
GO
ALTER TABLE [dbo].[Flug_Passagier] CHECK CONSTRAINT [FK_FLPS_Flug_Passagier_FL_Flug]
GO
ALTER TABLE [dbo].[Flug_Passagier]  WITH CHECK ADD  CONSTRAINT [FK_FLPS_Flug_Passagier_PS_Passagier] FOREIGN KEY([Passagier_PersonID])
REFERENCES [dbo].[Passagier] ([PersonID])
GO
ALTER TABLE [dbo].[Flug_Passagier] CHECK CONSTRAINT [FK_FLPS_Flug_Passagier_PS_Passagier]
GO
