﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="Flugplan_FilterEdit_DataContext_ADS.aspx.cs"
    Inherits="Flugplan_FilterEdit_DataView_ADS2" MasterPageFile="WWWings.Einfach.master" %>



<asp:Content ID="P1" ContentPlaceHolderID="P_Head" runat="server">
 <!-- Basisbausteine der ASP.NET AJAX Library -->
 <script src="/Scripts/MicrosoftAjax/Start.debug.js" type="text/javascript"></script>
 <script type="text/javascript" src="/Scripts/MicrosoftAjax/MicrosoftAjax.debug.js"></script>


    <style type="text/css">
        .sys-template
        {
            visibility: hidden;
            font-size: 10;
        }
        .myselected
        {
            color: white;
            font-weight: bold;
            background-color: Silver;
        }
        .commandbutton
        {
            cursor: pointer;
            background-color: #0201E1;
            border: none;
            color: white;
 
        }
        .flugdetail
        {
            display: block;
            background-color: #cedfef;
            height: 500;
        }
        .flugdetail img
        {
            position: relative;
            left: 120;
            margin-top: 0;
            display: inline-block;
        }
        .flugdetail .fields
        {
            position: relative;
            width: 100%;
            left: 0%;
            display: block;
            margin-top: 0;
            border: none;
            display: inline-block;
        }
        .flugdetail .fields .detailtitle
        {
            font-weight: bold;
            font-size: 15px;
            color: black;
            position: relative;
        }
        .flugdetail .fields div
        {
            margin-top: 12px;
            display: block;
        }
        .flugdetail .fields label
        {
            color: black;
            font-weight: bold;
            padding: 3px;
            font-size: 15px;
        }
        .flugdetail .fields input[type=text]
        {
            position: absolute;
            color: black;
            background-color: #ccffff;
            border-color: #777777;
            padding: 3px;
            width: 400;
        }
    </style>

    <script type="text/javascript">

        // Aktivieren des DOM verzögern
        Sys.activateDom = false;
        
        // Laden der notwendigen Bibliotheken
        Sys.require([Sys.components.dataView, Sys.components.adoNetDataContext]);
        
        // ============== Globale Variablen
        var Tabelle, Daten;

         
       
        // Parameter für Data Service
        var Parameter = { $filter: "Abflugort eq ''" }
        
        // Data Service festlegen
        Sys.onReady(function () {
            dataContext = Sys.create.adoNetDataContext({
                serviceUri: "/Webservice/WWWingsFlugplanDataService.svc",
            });

            Sys.Application.activateElement(document.documentElement);
        });
        
        
        // ============== Fehlerfall
        function Fehler(sender, error) {
            ///<summary>Zeigt den Fehler anstelle der Tabelle an</summary>
            ///<param name="error" type="Error Object">Fehlerinformation</param>
            ///<returns>string</returns>
            var text = "Fehler bei der AJAX-Verarbeitung auf dem Server: " + error.get_error().get_message();
            alert(text);
        }

        // ===================== Datenhandhabung

        // Anzeigen der Daten
        function NeuLaden(sender, args) {
            Tabelle = $find("C_Fluege");
            Parameter.$filter = "Abflugort eq '" + $get("C_Orte").value + "'";
            Tabelle.fetchData(null, null, Sys.Data.MergeOption.overwriteChanges); // Daten laden
        }

        // Nach dem Laden Daten anzeigen
        function Anzeigen(sender, args) {
            Daten = args.get_data();
            if ($get("C_Orte").value != "") {
                $get("C_Fluege_Label").innerText = "Flüge von " + $get("C_Orte").value + ":";
            }
            else {
                $get("C_Fluege_Label").innerText = "";
            }
            //Tabelle = sender;
            
            Sys.Observer.makeObservable(Daten);
        }


        // ===================== Aktionen
        // Aktionen in der Detailansicht
        function ExecCommand(sender, args) {
            switch (args.get_commandName()) {
                case "StartLaden":
                    StartLaden(null, null);
                    alert("Daten neu geladen!");
                    break;
                case "Save":
                    dataContext.saveChanges();
                    alert("Daten gespeichert!");
                    break;
                case "Delete":
                    var index = Tabelle.get_selectedIndex();
                    var deletedFlug = Daten[index];

                    dataContext.removeEntity(deletedFlug);
                    Daten.remove(deletedFlug);

                    if (index >= Daten.length) index--;
                    Tabelle.set_selectedIndex(index);
                    dataContext.saveChanges();
            }
        }
    </script>

</asp:Content>
<asp:Content ID="P2" ContentPlaceHolderID="P_MainContent" runat="server">
    <p>
        Abflugort:
        <select id="C_Orte" name="D1" onchange="NeuLaden();">
         
             <option value="" selected="on">Bitte wählen</option>
            <option value="Rom">Rom</option>
            <option value="Paris">Paris</option>
            <option value="London">London</option>
            <option value="Berlin">Berlin</option>
        </select><br />
    </p>
    <hr />
    <!-- ################################################################################# -->
    <!-- Hauptansicht -->
    <!-- ################################################################################# -->
    <div id="C_Fluege_Label">
        Flüge:</div>
    <div id="c1" style="float: left; width: 50%;    font-size: 11px;">
        <table border="0" id="C_Fluege" class="sys-template" 
            sys:attach="dataview" 
            dataview:autofetch="true"
            dataview:dataprovider="{{ dataContext }}" 
            dataview:fetchfailed="{{ Fehler }}"
            dataview:fetchoperation="Flug" 
            dataview:fetchparameters="{{ Parameter }}" 
            dataview:onrendering="{{ Anzeigen }}" 
           >
            <tr style="background-color: #F7F7F7" sys:if="$index%2 == 0">
                <td>
                    {{ $index +1}}
                </td>
                <td>
                    <span sys:command="Select" class="" id="Span2">
                        <input type="button" class="commandbutton" value="Edit" />
                    </span>
                </td>
                <td>
                <!-- one time binding -->
                    {{ FlugNr }}
                </td>
                <td>
                 <!-- one way binding -->
                    { binding Abflugort }
                </td>
                <td>
                    { binding Zielort }
                </td>
                <td>
                    {{ Datum.format('dd.MM.yyyy') }}
                </td>
                <td>
                    { binding FreiePlaetze } <span>&nbsp;freie Plätze</span>
                </td>
            </tr>
            <tr style="background-color: #E7E7FF" sys:if="$index%2 == 1">
                <td>
                    {{ $index +1}}
                </td>
                <td>
                    <span sys:command="Select" class="" id="Span1">
                        <input type="button" class="commandbutton" value="Edit" />
                    </span>
                </td>
                <td>
                    {{ FlugNr }}
                </td>
                <td>
                    { binding Abflugort }
                </td>
                <td>
                    { binding Zielort }
                </td>
                <td>
                    {{ Datum.format('dd.MM.yyyy') }}
                </td>
                <td>
                   { binding FreiePlaetze } <span>&nbsp;freie Plätze</span>
                </td>
            </tr>
        </table>
    </div>
    <div id="c2" style="margin-left: 50%">
        <!-- ################################################################################# -->
        <!-- Detailansicht / Live Binding (Zwei-Wege)-->
        <!-- ################################################################################# -->
        <div id="Div1" class="sys-template flugdetail" 
        sys:attach="dataview" 
        dataview:oncommand="{{ ExecCommand }}"
        dataview:data="{binding selectedData, source=$C_Fluege }">
            <div>
                <div>
                <!-- Aktionen --> 
                    <input type="button" sys:command="StartLaden" class="commandbutton" value="Neu laden" />
                    <input type="button" sys:command="Save" class="commandbutton" value="Speichern" />
                    <input type="button" sys:command="Delete" class="commandbutton" value="Löschen" /></div>
                   <!-- Felder --> 
                <div class="fields">
                    
                                <span class="detailtitle">Flug: </span> <span class="detailtitle">{binding FlugNr}</span>
                    <div>
                        <label for="name">
                            Abflugort:
                        </label>
                        <!--Live Binding / Zwei-Wege -->
                        <input id="name" type="text" sys:value="{binding Abflugort}" />
                    </div>
                    <div>
                        <label for="description">
                            Zielort:
                        </label>
                        <input id="description" type="text" sys:value="{binding Zielort}" />
                    </div>
                   
                    <div>
                        <label for="uri">
                            FreiePlaetze:
                        </label>
                        <input id="uri" type="text" sys:value="{binding FreiePlaetze}" />
                    </div>
                </div>
                <br />     <br />  
            </div>
        </div>
</asp:Content>
