﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="Flugplan_FilterEdit_DataView_ADS.aspx.cs"
    Inherits="Flugplan_FilterEdit_DataView_ADS" MasterPageFile="WWWings.Einfach.master" %>

<asp:Content ID="P1" ContentPlaceHolderID="P_Head" runat="server">
    <style type="text/css">
        .sys-template
        {
            display: none;
            visibility: hidden;
        }
    </style>
    <style type="text/css">
        .sys-template
        {
            visibility: hidden;
        }
        .myselected
        {
            color: white;
            font-weight: bold;
            background-color: Silver;
        }
        .commandbutton
        {
            cursor: pointer;
            background-color: black;
            border: none;
            color: #FFD200;
            font-style: italic;
            text-decoration: underline;
        }
        .flugdetail
        {
            display: block;
            background-color: #cedfef;
        }
        .flugdetail img
        {
            position: relative;
            left: 0%;
            margin-top: 0;
            display: inline-block;
        }
        .flugdetail .fields
        {
            position: relative;
            width: 100%;
            left: 0%;
            display: block;
            margin-top: 0;
            border: none;
            display: inline-block;
        }
        .flugdetail .fields .detailtitle
        {
            font-weight: bold;
            font-size: 20px;
            color: #bbbbbb;
            position: relative;
        }
        .flugdetail .fields div
        {
            margin-top: 15px;
            display: block;
        }
        .flugdetail .fields label
        {
            color: #999999;
            font-weight: bold;
            padding: 3px;
            font-size: 1.1em;
        }
        .flugdetail .fields input[type=text]
        {
            position: absolute;
            color: white;
            background-color: #444444;
            border-color: #777777;
            padding: 3px;
            width: 400;
        }
    </style>

    <script type="text/javascript">

        // ============== Globale Variablen
        var Tabelle, Daten;

        // Parameter für Data Service
        var Parameter = { $filter: "Abflugort eq ''" }

        // Data Service festlegen
        var dataContext = $create(
            Sys.Data.AdoNetDataContext,
            {
                serviceUri: "/Webservice/WWWingsFlugplanDataService.svc",
                mergeOption: Sys.Data.MergeOption.appendOnly
            }
        );

        // ====================== INIT
        function pageLoad() {
            Tabelle = $find("C_Fluege");
            Tabelle.add_fetchFailed(Fehler);
        }


        // ============== Fehlerfall
        function Fehler(sender, error) {
            ///<summary>Zeigt den Fehler anstelle der Tabelle an</summary>
            ///<param name="error" type="Error Object">Fehlerinformation</param>
            ///<returns>string</returns>
            var text = "Fehler bei der AJAX-Verarbeitung auf dem Server: " + error.get_error().get_message();
            alert(text);
        }

        // ===================== Datenhandhabung

        // Neuladen
        function StartLaden(sender, args) {
            Parameter.$filter = "Abflugort eq '" + $get("C_Orte").value + "'";
            Tabelle.fetchData(null, null, Sys.Data.MergeOption.overwriteChanges); // Daten laden

        }

        // Nach dem laden Daten anzeigen
        function EndeLaden(sender, args) {
            $get("C_Fluege_Label").innerText = "Flüge von " + $get("C_Orte").value + ":";
            Tabelle = sender;
            Daten = args.get_data();
            Sys.Observer.makeObservable(Daten);
        }


        // ===================== Aktionen
        // Aktionen in der Detailansicht
        function ExecCommand(sender, args) {
            switch (args.get_commandName()) {
                case "StartLaden":
                    StartLaden(null, null);
                    alert("Daten neu geladen!");
                    break;
                case "Save":
                    dataContext.saveChanges();
                    alert("Daten gespeichert!");
                    break;
                case "Delete":
                    var index = Tabelle.get_selectedIndex();
                    var deletedFlug = Daten[index];

                    dataContext.removeEntity(deletedFlug);
                    Daten.remove(deletedFlug);

                    if (index >= Daten.length) index--;
                    Tabelle.set_selectedIndex(index);
                    dataContext.saveChanges();
            }
        }
    </script>

</asp:Content>
<asp:Content ID="P2" ContentPlaceHolderID="P_MainContent" runat="server">
    <p>
        Abflugort:
        <select id="C_Orte" name="D1" onchange="StartLaden();">
            <option value="">Bitte wählen</option>
            <option value="Rom" selected>Rom</option>
            <option value="Paris">Paris</option>
            <option value="London">London</option>
            <option value="Berlin">Berlin</option>
        </select><br />
    </p>
    <hr />
    <!-- ################################################################################# -->
    <!-- Hauptansicht -->
    <!-- ################################################################################# -->
    <div id="C_Fluege_Label">
        Flüge:</div>
    <div id="c1" style="float: left; width: 50%">
        <table border="0" id="C_Fluege" class="sys-template" 
        sys:attach="dataview" 
        dataview:autofetch="true"
            dataview:dataprovider="{{ dataContext }}" 
            dataview:fetchfailed="{{ Fehler }}"
            dataview:fetchoperation="Flug" 
            dataview:fetchparameters="{{ Parameter }}" 
            dataview:selecteditemclass="selecteditem"
            dataview:ondataloading="{{ EndeLaden }}" 
            dataview:initialselectedindex="0" 
            dataview:sys-key="master">
            <tr style="background-color: #F7F7F7" code:if="$index%2 == 0">
                <td>
                    {{ $index +1}}
                </td>
                <td>
                    <span sys:command="Select" class="" id="Span2">
                        <input type="button" class="commandbutton" value="Edit" />
                    </span>
                </td>
                <td>
                    {{ FlugNr }}
                </td>
                <td>
                    { binding Abflugort }
                </td>
                <td>
                    { binding Zielort }
                </td>
                <td>
                    {{ Datum.localeFormat('d') }}
                </td>
                <td>
                    { binding FreiePlaetze }
                </td>
            </tr>
            <tr style="background-color: #E7E7FF" code:if="$index%2 == 1">
                <td>
                    {{ $index +1}}
                </td>
                <td>
                    <span sys:command="Select" class="" id="Span1">
                        <input type="button" class="commandbutton" value="Edit" />
                    </span>
                </td>
                <td>
                    {{ FlugNr }}
                </td>
                <td>
                    { binding Abflugort }
                </td>
                <td>
                    { binding Zielort }
                </td>
                <td>
                    {{ Datum.localeFormat('d') }}
                </td>
                <td>
                    { binding FreiePlaetze }
                </td>
            </tr>
        </table>
    </div>
    <div id="c2" style="margin-left: 50%">
        <!-- ################################################################################# -->
        <!-- Detailansicht / Live Binding (Zwei-Wege)-->
        <!-- ################################################################################# -->
        <div id="Div1" class="sys-template flugdetail" sys:attach="dataview" dataview:oncommand="{{ ExecCommand }}"
            dataview:data="{binding selectedData, source={{master}} }">
            <div>
                <div>
                <!-- Aktionen --> 
                    <input type="button" sys:command="StartLaden" class="commandbutton" value="Neu laden" />
                    <input type="button" sys:command="Save" class="commandbutton" value="Speichern" />
                    <input type="button" sys:command="Delete" class="commandbutton" value="Löschen" /></div>
                   <!-- Felder --> 
                <div class="fields">
                    <br />
                    <span class="detailtitle">Flug</span> <span class="detailtitle">{binding FlugNr}</span>
                    <div>
                        <label for="name">
                            Abflugort:
                        </label>
                        <!--Live Binding / Zwei-Wege -->
                        <input id="name" type="text" value="{binding Abflugort}" />
                    </div>
                    <div>
                        <label for="description">
                            Zielort:
                        </label>
                        <input id="description" type="text" value="{binding Zielort}" />
                    </div>
                    <div>
                        <label for="contributor">
                            Datum:
                        </label>
                        <input id="contributor" type="text" value="{binding Datum}" />
                    </div>
                    <div>
                        <label for="uri">
                            FreiePlaetze:
                        </label>
                        <input id="uri" type="text" value="{binding FreiePlaetze}" />
                    </div>
                </div>
            </div>
        </div>
</asp:Content>
