﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace WWWings_GL
{
 public class BuchungsBLManager
 {

  // Verweise auf Datenzugriffsschicht
  WWWings35_DZ.BuchungsDataManager DZS = new WWWings35_DZ.BuchungsDataManager();
  WWWings35_DZ.FlugDataManager FlugDZS = new WWWings35_DZ.FlugDataManager();

  /// <summary>
  /// Erstellen einer Buchung
  /// Die Aktion besteht aus einem Eintrag in der Buchungstabelle
  /// sowie der Reduzierung der Platzanzahl in der Flugtabelle
  /// </summary>
  /// <param name="FNummer"></param>
  /// <param name="PNummer"></param>
  /// <returns></returns>
  public int NewBuchung(int FNummer, int PNummer)
  {
   int Buchungscode = Convert.ToInt32(FNummer.ToString() + PNummer.ToString());

   // Transaktion, nur erfolgreich wenn Platzanzahl reduziert und Buchung erstellt!
   using (System.Transactions.TransactionScope t = new System.Transactions.TransactionScope())
   {
    if (FlugDZS.ReducePlatzAnzahl(FNummer, 1))
    {
     if (DZS.NewBuchung(PNummer, FNummer, Buchungscode))
     {
      t.Complete();
      return Buchungscode;
     }
    }
   }
   return 0;
  }
 }
}