﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using WWWings35_GO;
using WWWings35_GO.LTS;
using WWWings35_DZ;

namespace WWWings35_BL
{

 /// <summary>
 /// Geschäftslogik-Manager-Objekt für Entität "Flug"
 /// Implementierung mit .NET 3.5 und LINQ-to-SQL im Untergrund
 /// </summary>
 public class FlugBLManager
 {

  FlugDataManager DAL = new FlugDataManager();

  public List<Flug> HoleAlle()
  {
   return DAL.HoleAlle();
  }

  public List<Flug> HoleAlle(string Ort)
  {
   if (Ort == "") return null;
   return DAL.HoleAlle(Ort);
  }

  public Flug HoleFlug(long Nr)
  {
   return DAL.HoleFlug(Nr);
  }

  public Flug GetFlug(int FlugNummer)
  {
   return DAL.GetFlug(FlugNummer);
  }

  public List<Flug> GetFluege(string Abflugort, int Anzahl, int Start)
  {
   return DAL.GetFluege(Abflugort, Anzahl, Start);
  }

  public Int32 CountFluege(string Abflugort)
  {
   return DAL.CountFluege(Abflugort);
  }

  public List<Flug> GetFluege(string Abflugort, string Zielort, DateTime? Start, DateTime? Ende)
  {

   if (Abflugort == null || Abflugort == "")
   {
    if (Start == null)
    {
     return DAL.GetFluege();
    }
    else
    {
     return DAL.GetFluege("", "", Start.Value, Ende.Value);
    }
   }
   else
   {
    if (Start == null)
    {
     return DAL.GetFluege(Abflugort, Zielort);
    }
    else
    {
     return DAL.GetFluege(Abflugort, Zielort, Start.Value, Ende.Value);
    }
   }
  }
 }
}
