﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using WWWings35_GO;
using WWWings35_GO.LTS;


namespace WWWings35_DZ
{
 public class FlugDataManager : WWWings35_DZ.IFlugDataManager
 {

  LTSModellDataContext db = new LTSModellDataContext();

  public List<Flug> HoleAlle()
  {
   LTSModellDataContext db = new LTSModellDataContext();

   List<Flug> fluege = (from f in db.Flug select f).ToList();
   db.Dispose();

   return fluege;
  }


  public List<Flug> HoleAlle(string Ort)
  {
   LTSModellDataContext db = new LTSModellDataContext();

   List<Flug> fluege = (from f in db.Flug where f.Abflugort == Ort select f).ToList();
   db.Dispose();

   return fluege;
  }


  public List<Flug> HoleAlle(string Ort, int Anzahl, int Start)
  {
   LTSModellDataContext db = new LTSModellDataContext();

   List<Flug> fluege = (from f in db.Flug where f.Abflugort == Ort select f).Skip(Start).Take(Anzahl).ToList();
   db.Dispose();

   return fluege;
  }

  public Flug HoleFlug(long Nr)
  {
   LTSModellDataContext db = new LTSModellDataContext();
   // Flug flug = (from f in db.Flugs where f.FlugNr == Nr select f).SingleOrDefault();

   // für Unit Test Demos: Single() statt SingleOrDefault()
   Flug flug = (from f in db.Flug where f.FlugNr == Nr select f).SingleOrDefault();

   return flug;
  }

  public List<Flug> GetFluege(string AbflugOrt, string Zielort, DateTime ZeitraumStart, DateTime ZeitraumEnde)
  {

   var Fluege = from f in db.Flug where f.Abflugort == AbflugOrt && f.Zielort == Zielort && f.Datum >= ZeitraumStart && f.Datum <= ZeitraumEnde select f;

   return Fluege.ToList();
  }

  public Flug GetFlug(int FlugNummer)
  {

   var Flug = from f in db.Flug where f.FlugNr == FlugNummer select f;
   return Flug.SingleOrDefault();
  }


  public List<Flug> GetFluege()
  {
   return db.Flug.ToList();
  }


  public List<Flug> GetFluege(string Abflugort, string Zielort)
  {
   LTSModellDataContext db = new LTSModellDataContext();
   IEnumerable<Flug> Fluege = from Flug in db.Flug where Flug.Abflugort == Abflugort select Flug;
   return Fluege.ToList();
  }


  public List<Flug> GetFluege(string Abflugort, int Anzahl, int Start)
  {
   LTSModellDataContext db = new LTSModellDataContext();
   return (from f in db.Flug where f.Abflugort == Abflugort orderby f.FlugNr select f).Skip(Start).Take(Anzahl).ToList();

  }

  public Int32 CountFluege(string Abflugort)
  {
   LTSModellDataContext db = new LTSModellDataContext();
   return (from f in db.Flug where f.Abflugort == Abflugort orderby f.FlugNr select f).Count();

  }


  public bool ReducePlatzAnzahl(int FlugNummer, short Platzanzahl)
  {

   var EinzelnerFlug = HoleFlug(FlugNummer);

   if (EinzelnerFlug != null)
   {
    if (EinzelnerFlug.FreiePlaetze >= Platzanzahl && EinzelnerFlug.FreiePlaetze - Platzanzahl <= EinzelnerFlug.Plaetze)
    {
     EinzelnerFlug.FreiePlaetze -= Platzanzahl;
     db.SubmitChanges(); // Speichern!!!
     return true;
    }
    else
    {
     return false;
    }
   }
   else
   {
    return false;
   }
  }


  public bool IncreaePlatzAnzahl(int FlugNummer, short Platzanzahl)
  {
   return ReducePlatzAnzahl(FlugNummer, (short)-Platzanzahl);
  }

 }
}
