﻿using System;
using System.ComponentModel.DataAnnotations;

namespace WWWings35_GO.LTS
{


 [ScaffoldTable(false)] // Klassen ausschliessen!
 public partial class Fluege_Backup
 {

 }

 [DisplayColumn("PersonID")]
 [MetadataType(typeof(PilotUIMetaData))]
 public partial class Pilot
 {


 }

 public class PilotUIMetaData
 {

  [StringLength(1, ErrorMessage = "Bitte nur ein Zeichen!")]
  public string Flugscheintyp;
 }



 [DisplayColumn("GanzerName")]
 [MetadataType(typeof(PersonUIMetaData))]
 public partial class Person
 {


  
 }

 public partial class PersonUIMetaData
 {
  //[DisplayFormat(DataFormatString = "#{0:000,000}")]
  //public long PersonalausweisNr;

  [DataType(DataType.EmailAddress)]
  [RegularExpression(@"\w+([-+.']\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*", ErrorMessage = "Keine gültige E-Mail-Adresse!")]
  public string EMail;

 }


 //}

 //[UIHint("PS_KundenstatusSeit","")]
 //[DisplayFormat("PS_Kundenstatus", NullDisplayText = "keine Angabe")]
 //[DisplayFormat("PS_KundenstatusSeit", NullDisplayText = "keine Angabe")]
 public partial class PS_Passagier
 {

 }
 [MetadataType(typeof(FlugUIMetaData))]
 public partial class Flug
 {

  partial void OnFreiePlaetzeChanging(short? value)
  {
   if (value > this.Plaetze) throw new ApplicationException("Freie Plätze müssen kleine sein als Gesamtanzahl der Plätze!");
  }
 }

 public partial class FlugUIMetaData
 {
  [UIHint("Ort")]
  //[Filter(FilterControl = "Default")]
  public string Abflugort;
  [UIHint("Ort")]
  public string Zielort;

  //[ScaffoldColumn(false)]
  //public long CreationDate;

  [DisplayFormat(DataFormatString = "{0:dd.MM.yyyy HH:mm}", ApplyFormatInEditMode = true, NullDisplayText = "Keine Angabe", ConvertEmptyStringToNull = true)]
  public DateTime Datum;

  //[Range(0,250, ErrorMessage="Platzanzahl muss zwischen 0 und 250 liegen!")]
  [Range(0, 250, ErrorMessage = "Zahl für {0} muss zwischen {1} und {2} liegen!")]
  [Required]
  public int Plaetze;
  //[Range(0, 250, ErrorMessageResourceName = "PlatzWerteBereich", ErrorMessageResourceType = typeof(Resources.Fehlermeldungen))]
  //[Required]
  [Range(0, 250, ErrorMessage = "Zahl für {0} muss zwischen {1} und {2} liegen!")]
  public int FreiePlaetze;
 }



 //[UIHint("FL_NichtRaucherFlug","Text")]
 //[UIHint("FL_FreiePlaetze", "Slider")]


}

