using System;
using System.ServiceModel;

namespace de.WWWings.Dienste
{
 /// <summary>
 /// WCF-Dienst fr Flugplan im REST-Stil. 
 /// Mglich ab .NET 3.5
 /// Wird aufgerufen ber URL localhost:88/...
 /// PerCall == Zustandlosigkeit
 /// Verwendet noch die Geschftslogik ohne Entity Framework
 /// </summary>
 [ServiceBehavior(InstanceContextMode = InstanceContextMode.PerCall)]
 public class FlugplanServiceREST : de.WWWings.Vertraege.IFlugplanServiceREST 
 {
  public FlugplanServiceREST()
  {
   // Ausgaben nur zu Testzwecken!!!
   Console.WriteLine("Neue Instanz der Fassade FlugplanServiceREST!");
  }

  public de.WWWings.Flug HoleFlug(string FlugNr)
  {
   System.Console.WriteLine("GetFlug wird aufgerufen mit Nr " + FlugNr);
   Int32 FlugNrInt;
   if (Int32.TryParse(FlugNr, out FlugNrInt)) return de.WWWings.FlugBLManager.HoleFlug(FlugNrInt);
   else return null;
  }

  public de.WWWings.FlugMenge HoleAlle()
  {
   return de.WWWings.FlugBLManager.HoleAlle();
  }

  public de.WWWings.FlugMenge HoleAlleRoute(string von, string nach)
  {
   return de.WWWings.FlugBLManager.HoleAlle(von, nach);
  }
 }
}
