﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel.Description;
using System.ServiceModel;

namespace de.WWWings.Dienste
{
 [ServiceContract]
 public interface IZustandsdienst
 {
  [OperationContract]
  void Clear();
  [OperationContract]
  int Count();

  System.Collections.Generic.List<int> GetData();
  [OperationContract]
  DateTime GetLastAccess();
  [OperationContract]
  void SendData(int NewValue);
 }


 [DurableService]
 public class Zustandsdienst : IZustandsdienst
 {
  private DateTime LastAccess;
  private List<int> Data = new List<int>();
  private int Counter = 0;

  [DurableOperation()]
  public void SendData(int NewValue)
  {
   Counter++;
   LastAccess = DateTime.Now;
   Data.Add(NewValue);
  }

  [DurableOperation(CanCreateInstance = true)]
  public List<int> GetData()
  {
   return Data;
  }

  [DurableOperation(CanCreateInstance = true)]
  public void Clear()
  {
   LastAccess = DateTime.Now;
   Data.Clear();
  }

  [DurableOperation()]
  public int Count()
  {
   return Data.Count;
  }

  [DurableOperation(CanCreateInstance = true)]
  public DateTime GetLastAccess()
  {
   return LastAccess;
  }

 }
}
