using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Collections;
using System.Drawing;
using System.Workflow.ComponentModel.Compiler;
using System.Workflow.ComponentModel.Serialization;
using System.Workflow.ComponentModel;
using System.Workflow.ComponentModel.Design;
using System.Workflow.Runtime;
using System.Workflow.Activities;
using System.Workflow.Activities.Rules;

namespace de.WWWings.Workflow.CodeWorkflows
{
    public sealed partial class BuchungsStateWorkflow : StateMachineWorkflowActivity
    {
        public BuchungsStateWorkflow()
        {
            InitializeComponent();
        }


     long FlugZaehler = 0;
     long AktuelleFlugNr = 0;
     long AktuellePassagierNr = 0;

      private string _Aufrufer;

  public string Aufrufer
  {
   get { return _Aufrufer; }
   set
   {
    _Aufrufer = value;
    Console.WriteLine("Aufgerufen von: " + _Aufrufer.ToString());
   }
  }

  private long _Buchungcode;

  public long Buchungscode
  {
   get { return _Buchungcode; }
  }


     public static DependencyProperty PersonendatenProperty = DependencyProperty.Register("Personendaten", typeof(de.WWWings.Workflow.PersonenDaten), typeof(de.WWWings.Workflow.CodeWorkflows.BuchungsStateWorkflow));

     [DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible)]
     [BrowsableAttribute(true)]
     [CategoryAttribute("Parameters")]
     public PersonenDaten Personendaten
     {
      get
      {
       return ((de.WWWings.Workflow.PersonenDaten)(base.GetValue(de.WWWings.Workflow.CodeWorkflows.BuchungsStateWorkflow.PersonendatenProperty)));
      }
      set
      {
       base.SetValue(de.WWWings.Workflow.CodeWorkflows.BuchungsStateWorkflow.PersonendatenProperty, value);
      }
     }

     public static DependencyProperty FlugdatenProperty = DependencyProperty.Register("Flugdaten", typeof(de.WWWings.Workflow.FlugDaten), typeof(de.WWWings.Workflow.CodeWorkflows.BuchungsStateWorkflow));

     [DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible)]
     [BrowsableAttribute(true)]
     [CategoryAttribute("Parameters")]
     public FlugDaten Flugdaten
     {
      get
      {
       return ((de.WWWings.Workflow.FlugDaten)(base.GetValue(de.WWWings.Workflow.CodeWorkflows.BuchungsStateWorkflow.FlugdatenProperty)));
      }
      set
      {
       base.SetValue(de.WWWings.Workflow.CodeWorkflows.BuchungsStateWorkflow.FlugdatenProperty, value);
      }
     }

     private void Condition_Schleife_Flugnummern(object sender, ConditionalEventArgs e)
     {
      if (this.Flugdaten.FlugNummern.Length > this.FlugZaehler)
      {
       e.Result = true;
       this.AktuelleFlugNr = this.Flugdaten.FlugNummern[this.FlugZaehler];
       Trace("Aktueller Flug: " + this.AktuelleFlugNr);
       this.FlugZaehler++;
      }
      else
      {
       e.Result = false;
      }

     }

     private void Condition_If_Verfuegbarkeit(object sender, ConditionalEventArgs e)
     {
      de.WWWings.Flug f = de.WWWings.FlugBLManager.HoleFlug(this.AktuelleFlugNr);
      Trace("Freie Pltze: " + f.FreiePlaetze);
      // Linker Ast = True = Nicht ausreichend Plaetze
      e.Result = (f.FreiePlaetze < this.Flugdaten.Plaetze);
     }

 
   

  #region Hilfsroutinen
  private void Trace(string s)
  {
   Console.ForegroundColor = ConsoleColor.Green;
   Console.Write("Workflow {0} in Thread {1}: ", this.WorkflowInstanceId, System.Threading.Thread.CurrentThread.ManagedThreadId);
   Console.ForegroundColor = ConsoleColor.White;
   Console.WriteLine(s);
   this.TrackData(s);
  }

  private void TraceError(string s)
  {
   Console.ForegroundColor = ConsoleColor.Red;
   Console.Write("Workflow {0} in Thread {1}: ", this.WorkflowInstanceId, System.Threading.Thread.CurrentThread.ManagedThreadId);
   Console.ForegroundColor = ConsoleColor.White;
   Console.WriteLine(s);
   this.TrackData(s);
  }

     private void Code_KeinPlatz(object sender, EventArgs e)
     {
      Trace("Kein Platz in Flug " + this.AktuelleFlugNr);
     }

     private void Code_Buchen(object sender, EventArgs e)
     {
      Trace(String.Format("Buche Pltze auf Flug {0}...", this.AktuelleFlugNr));

      de.WWWings.PassagierSystem.Passagier p;
      p = new de.WWWings.PassagierSystem.Passagier(AktuellePassagierNr);

      long b = p.Buchen(this.AktuelleFlugNr);
      this._Buchungcode = b;

      Trace("Buchung erfolgt. Buchungscode: " + b);
     }

     private void codeActivity1_ExecuteCode(object sender, EventArgs e)
     {
      AktuellePassagierNr = de.WWWings.Passagier_BLManager.HolePassagierNummer(this.Personendaten.Name);

      if (AktuellePassagierNr != 0)
      {
       Trace(String.Format("Passagier {0} mit schon vorhanden unter ID: {1}", this.Personendaten.Name, AktuellePassagierNr));
      }
      else
      {
       Trace(String.Format("Passagier {0} mit E-Mail {1} wird angelegt...", this.Personendaten.Name, this.Personendaten.EMail));
       de.WWWings.Passagier_BLManager.NeuerPassagier(this.Personendaten.Name, this.Personendaten.EMail);
      }
     }

     private void Code_FehlerTrace_ExecuteCode(object sender, EventArgs e)
     {
      TraceError("Buchung nicht erfolgreich!");
     }

     public ZahlungsDaten Zhalungsdaten = default(de.WWWings.Workflow.ZahlungsDaten);

     private void Code_BetragAbbuchen_ExecuteCode(object sender, EventArgs e)
     {
      Trace("Buche Betrag ab!");
     }

     private void codeActivity1_ExecuteCode_1(object sender, EventArgs e)
     {
      Trace("Neuer State Workflow gestartet!");
     }


 }
  #endregion
}
