﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Controls;
using System.Windows.Data;
using de.WWWings.GO_STE;


namespace de.WWWings.WPF
{

 /// <summary>
 /// Überprüfungsregel für Flug im DataGrid
 /// </summary>
 class FlugValidationRule : ValidationRule
 {
  public override ValidationResult Validate(object value, System.Globalization.CultureInfo cultureInfo)
  {
   string err = "";

   BindingGroup bg = (BindingGroup)value;

   if (bg.Items.Count == 0) return ValidationResult.ValidResult;

   // Regel 1: Datum >= DateTime.Now
   de.WWWings.GO_STE.Flug flug = (de.WWWings.GO_STE.Flug)bg.Items[0];
   object odatum;
   DateTime Datum;

   bool Geaendert1 = bg.TryGetValue(flug, "Datum", out odatum);
   if (Geaendert1 && odatum is DateTime)
   {
    Datum = (DateTime)odatum;
    if (Datum < DateTime.Now)
    {
     err += "Datum muss in der Zukunft liegen!";
    }
   }

   // Regel 2: FreiePlaetze < Plaetze
   object oFreiePlaetze;
   short FreiePlaetze;
   object oPlaetze;
   short Plaetze;
   bool Geaendert2 = bg.TryGetValue(flug, "FreiePlaetze", out oFreiePlaetze);
   bool Geaendert3 = bg.TryGetValue(flug, "Plaetze", out oPlaetze);

   if (Geaendert2) 
   {
   if (!Int16.TryParse(oFreiePlaetze.ToString(), out FreiePlaetze)) err += (err != "" ? "\n" : "") + "Eingabe ist keine Zahl!";
   }
    else
    {
     FreiePlaetze = flug.FreiePlaetze.GetValueOrDefault();
    }

   if (Geaendert3) 
   {
   if (!Int16.TryParse(oPlaetze.ToString(), out Plaetze)) err += (err != "" ? "\n" : "") + "Eingabe ist keine Zahl!";
   }
    else
    {
     Plaetze = flug.Plaetze;
    }



   if ((Geaendert2 || Geaendert3))
   {
     if (flug.FreiePlaetze > flug.Plaetze)
     {
      err += (err != "" ? "\n" : "") + "Es darf nicht mehr freie Pläetze als Plätze geben!";
    }
   }

   if (err == "") return ValidationResult.ValidResult;
   else return new ValidationResult(false, err);

  }
 }
}
