﻿using System.Windows;
using System.Windows.Input;

namespace WWWings_WPF
{
 /// <summary>
 /// Logik für Hauptfenster
 /// </summary>
 public partial class MainWindow : Window
 {

  // Daten
  public LetztePersonenListe LetztePersonen = new LetztePersonenListe();
  // Befehle
  public static RoutedCommand C_Flugbuchung = new RoutedCommand();
  public static RoutedCommand C_Flugverwaltung = new RoutedCommand();
  public static RoutedCommand C_Beenden = new RoutedCommand();
  public static RoutedCommand C_MenuWechsel = new RoutedCommand();

  F_Flugbuchung f_Flugbuchung;
  F_Flugverwaltung f_Flugverwaltung;

  public MainWindow()
  {
   InitializeComponent();

   LetztePersonen.Add(new de.WWWings.GO.Person() { Name = "Meier", Vorname = "Max" });

   this.Title += " Version: " + System.Reflection.Assembly.GetExecutingAssembly().GetName().Version.ToString();

   // User Constrols erstellen und unsichtbar machen
   f_Flugbuchung = new F_Flugbuchung();
   f_Flugverwaltung = new F_Flugverwaltung();
   this.C_Inhalt.Children.Add(f_Flugbuchung);
   this.C_Inhalt.Children.Add(f_Flugverwaltung);

   f_Flugbuchung.Visibility = System.Windows.Visibility.Collapsed;
   f_Flugverwaltung.Visibility = System.Windows.Visibility.Collapsed;
   ZeigeRibbon();

   // Befehlsbindungen
   CommandBinding CB_Beenden = new System.Windows.Input.CommandBinding(C_Beenden);
   this.CommandBindings.Add(CB_Beenden);
   CB_Beenden.Executed += new System.Windows.Input.ExecutedRoutedEventHandler(CB_Beenden_Executed);
   CB_Beenden.CanExecute += new System.Windows.Input.CanExecuteRoutedEventHandler(CB_Beenden_CanExecute);

   CommandBinding CB_Flugverwaltung = new System.Windows.Input.CommandBinding(C_Flugverwaltung);
   this.CommandBindings.Add(CB_Flugverwaltung);
   CB_Flugverwaltung.Executed += new System.Windows.Input.ExecutedRoutedEventHandler(CB_Flugverwaltung_Executed);
   CB_Flugverwaltung.CanExecute += new System.Windows.Input.CanExecuteRoutedEventHandler(CB_Flugverwaltung_CanExecute);

   CommandBinding CB_Flugbuchung = new System.Windows.Input.CommandBinding(C_Flugbuchung);
   this.CommandBindings.Add(CB_Flugbuchung);
   CB_Flugbuchung.Executed += new System.Windows.Input.ExecutedRoutedEventHandler(CB_Flugbuchung_Executed);
   CB_Flugbuchung.CanExecute += new System.Windows.Input.CanExecuteRoutedEventHandler(CB_Flugbuchung_CanExecute);

   CommandBinding CB_MenuWechsel = new System.Windows.Input.CommandBinding(C_MenuWechsel);
   this.CommandBindings.Add(CB_MenuWechsel);
   CB_MenuWechsel.Executed += new System.Windows.Input.ExecutedRoutedEventHandler(CB_MenuWechsel_Executed);
   CB_MenuWechsel.CanExecute += new System.Windows.Input.CanExecuteRoutedEventHandler(CB_MenuWechsel_CanExecute);

 
  }

  void CB_MenuWechsel_CanExecute(object sender, System.Windows.Input.CanExecuteRoutedEventArgs e)
  { e.CanExecute = true; }
  void CB_MenuWechsel_Executed(object sender, System.Windows.Input.ExecutedRoutedEventArgs e)
  {
   if (this.C_MenuKlassisch.Visibility == System.Windows.Visibility.Collapsed || this.C_Menuwahl.SelectedValue == "Klassisch")
   {
    ZeigeKlassischesMenu();
   }
   else
   {
    ZeigeRibbon();
   }

  }

  private void ZeigeRibbon()
  {
   this.C_MenuKlassisch.Visibility = System.Windows.Visibility.Collapsed;
   this.C_Ribbon.Visibility = System.Windows.Visibility.Visible;
  }

  private void ZeigeKlassischesMenu()
  {
   this.C_MenuKlassisch.Visibility = System.Windows.Visibility.Visible;
   this.C_Ribbon.Visibility = System.Windows.Visibility.Collapsed;
  }

  // Befehl "Schließen"
  void CB_Beenden_CanExecute(object sender, System.Windows.Input.CanExecuteRoutedEventArgs e)
  { e.CanExecute = true; }
  void CB_Beenden_Executed(object sender, System.Windows.Input.ExecutedRoutedEventArgs e)
  { this.Close(); }

  // Befehl "Flugverwaltung"
  void CB_Flugverwaltung_CanExecute(object sender, System.Windows.Input.CanExecuteRoutedEventArgs e)
  { e.CanExecute = (f_Flugverwaltung.Visibility != System.Windows.Visibility.Visible); }
  void CB_Flugverwaltung_Executed(object sender, System.Windows.Input.ExecutedRoutedEventArgs e)
  {
   f_Flugbuchung.Visibility = System.Windows.Visibility.Collapsed;
   f_Flugverwaltung.Visibility = System.Windows.Visibility.Visible;
   if (this.C_MenuKlassisch.Visibility == System.Windows.Visibility.Visible) f_Flugverwaltung.Height = 500;
   else f_Flugverwaltung.Height = 400;
  }


  // Befehl "Flugbuchungen"
  void CB_Flugbuchung_CanExecute(object sender, System.Windows.Input.CanExecuteRoutedEventArgs e)
  { e.CanExecute = (f_Flugbuchung.Visibility != System.Windows.Visibility.Visible); }
  void CB_Flugbuchung_Executed(object sender, System.Windows.Input.ExecutedRoutedEventArgs e)
  {
   f_Flugverwaltung.Visibility = System.Windows.Visibility.Collapsed;
   f_Flugbuchung.Visibility = System.Windows.Visibility.Visible;

  }

  private void C_Ende_Click(object sender, RoutedEventArgs e)
  {
   // TODO: this.Close();
  }
  private void C_Steuerelementhierarchie_Click(object sender, RoutedEventArgs e)
  {
   MessageBox.Show("Bisher nicht verfügbar.");
  }

  private void C_FesteGroesse_Click(object sender, RoutedEventArgs e)
  {
   if (this.C_FesteGroesse.IsChecked.GetValueOrDefault()) this.ResizeMode = System.Windows.ResizeMode.NoResize;
   else this.ResizeMode = System.Windows.ResizeMode.CanResize;
  }
 }
}
