﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Management.Automation;
using System.Collections.ObjectModel;

namespace de.WWWings.WPS
{
 class PowerShellHosting
 {

  public static void Run1()
  {
   PowerShell ps = PowerShell.Create();

   // Einzelbefehl
   //ps.AddCommand("Get-Process");
   ps.AddScript("Get-Process | where { $_.workingset64 -gt 100000000} ");

   // Kopfzeile
   Console.WriteLine("Prozess                 ID        Speicher");
   Console.WriteLine("------------------------------------------");

   // Ausführung
   Collection<PSObject> ErgebnisMenge = ps.Invoke();

   // Ergebnismenge darstellen
   foreach (PSObject Ergebnis in ErgebnisMenge)
   {
    Console.WriteLine(
            "{0,-24}{1,-10}{2}",
            Ergebnis.Members["ProcessName"].Value,
            Ergebnis.Members["Id"].Value,
            Ergebnis.Members["WorkingSet64"].Value);
   }
  }

  public static void Run2()
  {
   PowerShell ps = PowerShell.Create();

   // Einzelbefehl
   //ps.AddCommand("Get-Process");
   ps.AddScript("Get-Process | where { $_.workingset64 -gt 100000000} ");

   // Ausführung
   Collection<PSObject> ErgebnisMenge = ps.Invoke();

   // Ergebnismenge darstellen (generische Lösung)
   Print(ErgebnisMenge);
  }


  const byte Spalten = 5;
  const byte ZeichenProSpalte = 15;
  /// <summary>
  /// Generische Ausgaben für Mengen von PSObject-Objekten
  /// </summary>
  /// <param name="Menge">Auszugebende Menge</param>
  public static void Print(Collection<PSObject> Menge)
  {
   bool HeaderPrinted = false;

   foreach (PSObject result in Menge)
   {

    if (!HeaderPrinted)
    {
     HeaderPrinted = true;
     byte hcount = 0;
     foreach (PSMemberInfo p in result.Properties)
     {
      hcount++;
      if (hcount > Spalten) break;
      Print(p.Name);
     }
     Console.WriteLine();
     Console.WriteLine("---------------------------------------------------------------------------");
    }

    byte count = 0;
    foreach (PSMemberInfo p in result.Properties)
    {
     count++;
     if (count > Spalten) break;
     string value = "";
     try
     {
      value = p.Value.ToString();
     }
     catch (Exception)
     {
     }
     Print(value);
    }

    Console.WriteLine("");
   }
  }

  /// <summary>
  /// Ausgabe einer auf 15 Zeichen begrenzten Zeichenkette
  /// </summary>
  /// <param name="s">Zeichenkette</param>
  public static void Print(string s)
  {
   if (s.Length > ZeichenProSpalte) s = s.Substring(0, ZeichenProSpalte-3) + "...";
   Console.Write(string.Format("{0," + ZeichenProSpalte +"}", s));
  }
 }
}
