﻿using System;
using System.Data.Services.Client;
using System.Linq;

using de.WWWings.ConsoleClient;
using de.WWWings.ConsoleClient.DatenDienst;

namespace WWWings_35SP1_ConsoleClient
{
 partial class DataServiceClientDemo
  {

    public static void WDS_DataServiceCollection()
    {
     Console.WriteLine("WCF Data Services - DataServiceCollection");
     de.WWWings.ConsoleClient.DatenDienst.WWWings6Entities proxy = new de.WWWings.ConsoleClient.DatenDienst.WWWings6Entities(new Uri("http://localhost:88/Webservice/WWWingsDataService.svc/"));
     var q = (from f in proxy.Flug where f.Abflugort == "Rom" select f);
     DataServiceCollection<Flug> fluege =
      new DataServiceCollection<Flug>(q);

     foreach (var f in q)
     {
      Console.WriteLine(f.FlugNr + ": " + f.FreiePlaetze);
      // Ändern
      f.FreiePlaetze--;
     }

     // Löschen, wenn vorhanden
     if (fluege.Where(f => f.FlugNr == 2).FirstOrDefault() != null) fluege.Remove(fluege.Where(f => f.FlugNr == 2).FirstOrDefault());

     // Anfügen
     Flug fneu = new Flug();
     fneu.FlugNr = 2;
     fneu.Abflugort = "Rom";
     fneu.Zielort = "Essen/Mülheim";
     fneu.Datum = DateTime.Now;
     fneu.FreiePlaetze = 100;
     fneu.Plaetze = 100;
     fluege.Add(fneu);

     // Speichern
     proxy.SaveChanges();
    }

    public static void WDS_Projektion()
    {
      Console.WriteLine("WCF Data Services - Projektion mit Speichern");
      de.WWWings.ConsoleClient.DatenDienst.WWWings6Entities proxy = new de.WWWings.ConsoleClient.DatenDienst.WWWings6Entities(new Uri("http://localhost:88/Webservice/WWWingsDataService.svc/"));

      var q = (from f in proxy.Flug where f.Abflugort == "Rom" select new Flug { FlugNr = f.FlugNr, Abflugort = f.Abflugort, Zielort = f.Zielort, FreiePlaetze = f.FreiePlaetze, Datum = f.Datum });
      Console.WriteLine(q);
      foreach (var f in q)
      {
        Console.WriteLine(f.FlugNr + ": " + f.FreiePlaetze);
        f.FreiePlaetze--;
        proxy.UpdateObject(f);
      }
      // ACHTUNG ACHTUNG: Nicht geladene Werte werden mit "null" überschrieben!!!!
      proxy.SaveChanges();
    }

    public static void WDS_Count()
    {
     de.WWWings.ConsoleClient.DatenDienst.WWWings6Entities proxy = new de.WWWings.ConsoleClient.DatenDienst.WWWings6Entities(new Uri("http://localhost:88/Webservice/WWWingsDataService.svc/"));

      var q = (from f in proxy.Flug where f.Abflugort == "Rom" select f).Count();
      Console.WriteLine(q);
    }

    public static void WDS_ServerSidePaging()
    {
      Console.WriteLine("Data Service Client - Server Side Paging");


      de.WWWings.ConsoleClient.DatenDienst.WWWings6Entities proxy = new de.WWWings.ConsoleClient.DatenDienst.WWWings6Entities(new Uri("http://localhost:88/Webservice/WWWingsDataService.svc/"));
      DataServiceQueryContinuation<Flug> token = null;
      QueryOperationResponse<Flug> response = null;
      int pageCount = 0;

      // Abfrage ausführen
      response = proxy.Flug.Execute() as QueryOperationResponse<Flug>;

      do
      {
        Console.WriteLine("----------- Datenseite {0}:", pageCount++);

        // Gibt es einen "next"-Link?
        if (token != null)
        {
          // Neue Seite laden
          response = proxy.Execute<Flug>(token) as QueryOperationResponse<Flug>;
        }

        // Ausgabe
        foreach (Flug f in response)
        {
          Console.WriteLine("FlugNr: {0}", f.FlugNr);
        }
      }

      // Nächster Link
      while ((token = response.GetContinuation()) != null);
    }

   
  }
}
