﻿using System;
using System.ServiceModel;

namespace de.WWWings.WCF
{

 /// <summary>
 /// Selbsterstellte Proxy-Klasse für REST-basierten WCF-Dienst
 /// </summary>
 class FlugplanServiceRestClient : ClientBase<de.WWWings.Vertraege.IFlugplanServiceREST>, de.WWWings.Vertraege.IFlugplanServiceREST
 {
  public FlugplanServiceRestClient()
   : base(new WebHttpBinding(), new EndpointAddress("http://localhost:88"))
  {
   // WICHTIG !!!
   this.Endpoint.Behaviors.Add(new System.ServiceModel.Description.WebHttpBehavior());
  }

  public FlugMenge HoleAlle()
  {
   return this.Channel.HoleAlle();
  }

  public FlugMenge HoleAlleRoute(string von, string nach)
  {
   return this.Channel.HoleAlleRoute(von, nach);
  }

  public Flug HoleFlug(string FlugNr)
  {
   return this.Channel.HoleFlug(FlugNr);
  }

 }


 /// <summary>
 /// Test-Client für REST-basierten WCF-Dienst
 /// </summary>
 public class RESTServiceClient
 {

  public static void Run()
  {
   string FlugNr = "101";
   var client = new FlugplanServiceRestClient();
   var Flug = client.HoleFlug(FlugNr);
   Console.WriteLine("Flug geladen: " + Flug.ToString());
   client.Close();
  }
 }
}
