﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using System.ServiceModel.Channels;
using de.WWWings.WCF;
using System.Diagnostics;

namespace de.WWWings.ConsoleClient.WCFClientDemos
{
 public class Szenario
 {
  public int ID { get; set; }
  public string URI { get; set; }
  public Binding Binding { get; set; }
  public string Bemerkung { get; set; }
  public bool IsOneWay { get; set; }

  public Szenario()
  {
   IsOneWay = false;
  }
 }

 public class RouterClient
 {

  public static void Run()
  {
   string RouterURL = "http://localhost:1111/router/";

   var TCPUnsicher = new NetTcpBinding();
   TCPUnsicher.Security.Mode = SecurityMode.None;


   var Liste = new List<Szenario>() 
   {
   new Szenario() { ID = 1, URI="http://localhost:1111/router/", Bemerkung="Router via HTTP", Binding = new BasicHttpBinding(), IsOneWay = false },
   new Szenario() { ID = 2, URI="http://localhost:1111/srouter/", Bemerkung="Router via HTTP/WS", Binding = new WSHttpBinding(), IsOneWay = false},
   new Szenario() { ID = 3, URI="net.tcp://localhost:1112/router/", Bemerkung="Router via TCP", Binding = new NetTcpBinding(), IsOneWay = false},
   new Szenario() { ID = 4, URI="net.tcp://localhost:1113/router/", Bemerkung="Session-Router", Binding = new NetTcpBinding(), IsOneWay = true},
   new Szenario() { ID = 5, URI="http://localhost:1111/mrouter/", Bemerkung="Multicast-Router", Binding = new BasicHttpBinding(), IsOneWay = true},

   new Szenario() { ID = 20, URI="http://localhost:1111/router/pipe", Bemerkung="Über Router zu Server 1", Binding = new BasicHttpBinding()},
   new Szenario() { ID = 21, URI="http://localhost:1111/router/tcp", Bemerkung="Über Router zu Server 2", Binding = new BasicHttpBinding()},
   new Szenario() { ID = 22, URI="http://localhost:1111/router/http", Bemerkung="Über Router zu Server 3", Binding = new BasicHttpBinding()},
   new Szenario() { ID = 31, URI="http://localhost:1111/router/1", Bemerkung="Über Router zu Server 1", Binding = new BasicHttpBinding()},
   new Szenario() { ID = 32, URI="http://localhost:1111/router/2", Bemerkung="Über Router zu Server 2", Binding = new BasicHttpBinding()},
   new Szenario() { ID = 33, URI="http://localhost:1111/router/3", Bemerkung="Über Router zu Server 3", Binding = new BasicHttpBinding()},

   new Szenario() { ID = 40, URI="net.pipe://localhost/WWWings/Pipes/Flugplanservice", Bemerkung="Named Pipes ohne Router", Binding = new NetNamedPipeBinding()},
   new Szenario() { ID = 41, URI="net.tcp://localhost:1236/WWWings/Flugplanservice", Bemerkung="TCP ohne Router", Binding = TCPUnsicher},
   new Szenario() { ID = 42, URI="http://localhost:89/Webservices/Flugplanservice.svc", Bemerkung="HTTP ohne Router", Binding = new BasicHttpBinding()}
   };



   var form = new RouterClientForm(Liste);

   form.ShowDialog();
   return;

   var GefilterteListe = Liste.Where(x => x.ID == 4);

   Console.WriteLine("Warte 2 sek...");
   System.Threading.Thread.Sleep(2000);




   while (true)
   {

    foreach (var Szenario in GefilterteListe)
    {
     Console.WriteLine("Rounter-URL: " + Szenario.URI + " / " + Szenario.Bemerkung);
     FlugplanServiceClient c = new FlugplanServiceClient(Szenario.Binding, new EndpointAddress(Szenario.URI));

     Stopwatch sw = new Stopwatch();
     sw.Start();


     for (int i = 110; i < 120; i++) // 610 für Leistungstest
     {
      using (OperationContextScope ocs = new OperationContextScope((c.InnerChannel)))
      {
       //Header setzen. Damit lassen sich die Custom-Filter beeinflussen und zu einer Auswahl zwingen!
       //if (i % 2 == 0)
       //{
       // MessageHeaders messageHeadersElement = OperationContext.Current.OutgoingMessageHeaders;
       // messageHeadersElement.Add(MessageHeader.CreateHeader("RouterZiel", "http://world-wide-wings.de", 1));
       //}
       //else
       //{
       //MessageHeaders messageHeadersElement = OperationContext.Current.OutgoingMessageHeaders;
       //messageHeadersElement.Add(MessageHeader.CreateHeader("RouterZiel", "http://world-wide-wings.de", 2));
       //}
       // Aufruf
       try
       {
        Flug f = c.HoleFlug(i);
        Console.WriteLine(f.FlugNr + " fliegt  nach " + f.ZielOrt + " und hat " + f.FreiePlaetze + "Plätze!");
        Console.ForegroundColor = ConsoleColor.Yellow;
        Console.WriteLine(f.AbflugOrt);
        Console.ForegroundColor = ConsoleColor.White;

      //  c.SetZustand("Test i=" + i);

        // string Zustand = c.GetZustand();

       }
       catch (Exception ex)
       {
        Console.ForegroundColor = ConsoleColor.Red;
        Console.WriteLine("Fehler bei Abruf von " + i + ": " + ex.Message);
        Console.ForegroundColor = ConsoleColor.Gray;
       }
      }

     } // Ende Schleife über 10 Flüge
     if (c.State != CommunicationState.Faulted) c.Close();
     sw.Stop();

     Console.WriteLine("Dauer= " + sw.ElapsedMilliseconds + " ms");
    } // Ende eines Szenarios

    Console.WriteLine("Space=Ende");
    var key = Console.ReadKey();
    if (key.KeyChar == ' ') return;


   } // Ende manuelle Gesant-Wiederholungsschleife
  }

 }
}
