using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Workflow.Runtime;
using System.Threading;

namespace de.WWWings.WWWings_Testcode
{
 public partial class FormWorkflowHost13 : Form
 {
  public FormWorkflowHost13()
  {
   InitializeComponent();
  }

  private void FormWorkflowHost_Load(object sender, EventArgs e)
  {

  }
  WorkflowRuntime workflowRuntime;
  WorkflowInstance instance;
  private void C_Starten_Click(object sender, EventArgs e)
  {
   workflowRuntime = new WorkflowRuntime();
   {
    AutoResetEvent waitHandle = new AutoResetEvent(false);
    workflowRuntime.WorkflowCompleted += delegate(object sender1, WorkflowCompletedEventArgs e1)
    {
     Ausgabe("Workflow " + e1.WorkflowInstance.InstanceId.ToString() + " beendet!");
     waitHandle.Set();
    };
    workflowRuntime.WorkflowTerminated += delegate(object sender1, WorkflowTerminatedEventArgs e1)
    {
     Ausgabe("Fehler in Workflow " + e1.WorkflowInstance.InstanceId.ToString() + "!");
     waitHandle.Set();
    };

    workflowRuntime.WorkflowLoaded += new EventHandler<WorkflowEventArgs>(workflowRuntime_WorkflowLoaded);

    workflowRuntime.WorkflowIdled += new EventHandler<WorkflowEventArgs>(workflowRuntime_WorkflowIdled);

    workflowRuntime.WorkflowSuspended += new EventHandler<WorkflowSuspendedEventArgs>(workflowRuntime_WorkflowSuspended);

    workflowRuntime.WorkflowResumed += new EventHandler<WorkflowEventArgs>(workflowRuntime_WorkflowResumed);

    workflowRuntime.WorkflowCreated += new EventHandler<WorkflowEventArgs>(workflowRuntime_WorkflowCreated);

    // ANFANG Besonderheit in Aufgabe 13:
    Dictionary<string, object> dic = new Dictionary<string, object>();
    dic.Add("Eingabe", this.C_Wert.Text);
    instance = workflowRuntime.CreateWorkflow(System.Reflection.Assembly.GetAssembly(typeof(de.WWWings.Workflow.Buchungsworkflow)).GetType(this.C_Workflows.SelectedItem.ToString(), true),dic);
    // ENDE



    instance.Start();
   }
  }

  void workflowRuntime_WorkflowResumed(object sender, WorkflowEventArgs e)
  {
   Ausgabe("Workflow " + e.WorkflowInstance.InstanceId.ToString() + " luft weiter!");
  }

  void workflowRuntime_WorkflowSuspended(object sender, WorkflowSuspendedEventArgs e)
  {
   Ausgabe("Workflow " + e.WorkflowInstance.InstanceId.ToString() + " hlt an!");
  }
  void workflowRuntime_WorkflowLoaded(object sender, WorkflowEventArgs e)
  {
   Ausgabe("Workflow " + e.WorkflowInstance.InstanceId.ToString() + " geladen!");
  }

  void workflowRuntime_WorkflowCreated(object sender, WorkflowEventArgs e)
  {
   Ausgabe("Workflow " + e.WorkflowInstance.InstanceId.ToString() + " erzeugt!");
  }

  void workflowRuntime_WorkflowIdled(object sender, WorkflowEventArgs e)
  {
   Ausgabe("Workflow " + e.WorkflowInstance.InstanceId.ToString() + " wartet...");
  }
  public delegate void GetDataAsyncDelegate(string s);
  public void Ausgabe(string s)
  {
   GetDataAsyncDelegate d = new GetDataAsyncDelegate(Ausgabe2);
   this.Invoke(d, new object[] { s });
  }
  public void Ausgabe2(string s)
  {
   // Console.WriteLine(s);
   //System.Windows.Forms.MessageBox.Show(s);
   this.C_Protokoll.Text += s + "\n";
   Application.DoEvents();
  }

  private void C_Anhalten_Click(object sender, EventArgs e)
  {
   instance.Suspend("kein Fehler");
  }

  private void C_Weiter_Click(object sender, EventArgs e)
  {
   instance.Resume();
  }

  private void C_Abbrechen_Click(object sender, EventArgs e)
  {
   instance.Terminate("Benutzerabbruch");
  }





 }
}