using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Workflow.Runtime;
using System.Threading;
using System.Workflow.Activities;
using System.Workflow.Runtime.Hosting;
using System.Collections.Specialized;
using System.Workflow.Runtime.Tracking;

namespace de.WWWings.WWWings_Testcode
{
 public partial class FormWorkflowHost17 : Form
 {
  public FormWorkflowHost17()
  {
   InitializeComponent();
  }

  private void FormWorkflowHost_Load(object sender, EventArgs e)
  {
   this.BringToFront();

   // ANFANG Besonderheit in Aufgabe 15:
   de.WWWings.Workflow.Aufgaben.Aufgabe15_Kommunikationsklasse.HostEmpfaengtWert += new EventHandler<de.WWWings.Workflow.Aufgaben.Uebergabewert>(kom_HostEmpfaengtWert);
   // ENDE
  }
  WorkflowRuntime workflowRuntime;
  WorkflowInstance instance;

  // ANFANG Besonderheit in Aufgabe 15:
  de.WWWings.Workflow.Aufgaben.Aufgabe15_Kommunikationsklasse kom;
  // ENDE

  /// <summary>
  /// Liefert den kompletten Fehlertext aus der ganzen Exception-Hierarchie
  /// </summary>
  /// <param name="ex"></param>
  /// <returns></returns>
  public static string HoleFehlerText(Exception ex)
  {
   string ausgabe = ex.GetType().ToString() + ": " + ex.Message + "\n";
   if (ex.InnerException != null) ausgabe += HoleFehlerText(ex.InnerException);
   return ausgabe;
  }


  //Anfang Zusatz Aufgabe 17
  const string ConnectionString = (@"Data Source=.\sqlexpress;Initial Catalog=Workflow;Integrated Security=True");
  // ENDE

  private void C_Starten_Click(object sender, EventArgs e)
  {
   workflowRuntime = new WorkflowRuntime();
   {
    AutoResetEvent waitHandle = new AutoResetEvent(false);
    workflowRuntime.WorkflowCompleted += delegate(object sender1, WorkflowCompletedEventArgs e1)
    {
     Ausgabe("Workflow " + e1.WorkflowInstance.InstanceId.ToString() + " beendet!");
     waitHandle.Set();
    };
    workflowRuntime.WorkflowTerminated += delegate(object sender1, WorkflowTerminatedEventArgs e1)
    {
     Ausgabe("Fehler in Workflow " + e1.WorkflowInstance.InstanceId.ToString() + ": " + HoleFehlerText(e1.Exception));
     waitHandle.Set();
    };

    workflowRuntime.WorkflowLoaded += new EventHandler<WorkflowEventArgs>(workflowRuntime_WorkflowLoaded);

    workflowRuntime.WorkflowIdled += new EventHandler<WorkflowEventArgs>(workflowRuntime_WorkflowIdled);

    workflowRuntime.WorkflowSuspended += new EventHandler<WorkflowSuspendedEventArgs>(workflowRuntime_WorkflowSuspended);

    workflowRuntime.WorkflowResumed += new EventHandler<WorkflowEventArgs>(workflowRuntime_WorkflowResumed);

    workflowRuntime.WorkflowCreated += new EventHandler<WorkflowEventArgs>(workflowRuntime_WorkflowCreated);

    workflowRuntime.WorkflowPersisted += new EventHandler<WorkflowEventArgs>(workflowRuntime_WorkflowPersisted);

    workflowRuntime.WorkflowUnloaded += new EventHandler<WorkflowEventArgs>(workflowRuntime_WorkflowUnloaded);

    // ANFANG Besonderheit in Aufgabe 15:
    kom = new de.WWWings.Workflow.Aufgaben.Aufgabe15_Kommunikationsklasse();
    ExternalDataExchangeService edes = new ExternalDataExchangeService();
    // Reihenfolge ist WICHTIG!!!
    workflowRuntime.AddService(edes);
    edes.AddService(kom);



    // ANFANG Zusatz in Aufgabe 17

    NameValueCollection Parameter = new NameValueCollection();
    Parameter.Add("UnloadOnIdle", "false");
    Parameter.Add("ConnectionString", ConnectionString);
    SqlWorkflowPersistenceService WFPersistenzDienst = new SqlWorkflowPersistenceService(Parameter);
    workflowRuntime.AddService(WFPersistenzDienst);

    // ENDE

    // ANFANG Zusatz in Aufgabe 18
    //SqlTrackingService trackService = new SqlTrackingService(ConnectionString);
    //workflowRuntime.AddService(trackService);
    // ENDE

    instance = workflowRuntime.CreateWorkflow(System.Reflection.Assembly.GetAssembly(typeof(de.WWWings.Workflow.Buchungsworkflow)).GetType(this.C_Workflows.SelectedItem.ToString(), true));





    instance.Start();
   }
  }

  void workflowRuntime_WorkflowUnloaded(object sender, WorkflowEventArgs e)
  {
   Ausgabe("Workflow unloaded!");
  }

  void workflowRuntime_WorkflowPersisted(object sender, WorkflowEventArgs e)
  {
   Ausgabe("Workflow persistiert!");
  }
  // ANFANG Besonderheit in Aufgabe 15:
  void kom_HostEmpfaengtWert(object sender, de.WWWings.Workflow.Aufgaben.Uebergabewert e)
  {
   Ausgabe("Wert = " + e.Wert.ToString());
  }
  // ENDE



  void workflowRuntime_WorkflowResumed(object sender, WorkflowEventArgs e)
  {
   Ausgabe("Workflow " + e.WorkflowInstance.InstanceId.ToString() + " luft weiter!");
  }

  void workflowRuntime_WorkflowSuspended(object sender, WorkflowSuspendedEventArgs e)
  {
   Ausgabe("Workflow " + e.WorkflowInstance.InstanceId.ToString() + " hlt an!");
  }
  void workflowRuntime_WorkflowLoaded(object sender, WorkflowEventArgs e)
  {
   Ausgabe("Workflow " + e.WorkflowInstance.InstanceId.ToString() + " geladen!");
  }

  void workflowRuntime_WorkflowCreated(object sender, WorkflowEventArgs e)
  {
   Ausgabe("Workflow " + e.WorkflowInstance.InstanceId.ToString() + " erzeugt!");
  }

  void workflowRuntime_WorkflowIdled(object sender, WorkflowEventArgs e)
  {
   Ausgabe("Workflow " + e.WorkflowInstance.InstanceId.ToString() + " wartet...");
  }
  public delegate void GetDataAsyncDelegate(string s);
  public void Ausgabe(string s)
  {
   GetDataAsyncDelegate d = new GetDataAsyncDelegate(Ausgabe2);
   this.Invoke(d, new object[] { s });
  }
  public void Ausgabe2(string s)
  {
   // Console.WriteLine(s);
   //System.Windows.Forms.MessageBox.Show(s);
   this.C_Protokoll.Text += s + "\n";
   Application.DoEvents();
  }

  private void C_Anhalten_Click(object sender, EventArgs e)
  {
   instance.Suspend("kein Fehler");
  }

  private void C_Weiter_Click(object sender, EventArgs e)
  {
   instance.Resume();
  }

  private void C_Abbrechen_Click(object sender, EventArgs e)
  {
   instance.Terminate("Benutzerabbruch");
  }

  // ANFANG Besonderheit in Aufgabe 14:
  private void C_WertSenden_Click(object sender, EventArgs e)
  {
   if (this.instance == null) return;
   kom.SendeWertZumWorkflow(this.instance.InstanceId, Convert.ToInt32(this.C_Wert.Text));
  }


  // ANFANG Zusatz in Aufgabe 19
  private void C_ProtokolEinsehen_Click(object sender, EventArgs e)
  {
   System.Workflow.Runtime.Tracking.SqlTrackingQuery WFTrackingQuery;
   WFTrackingQuery = new System.Workflow.Runtime.Tracking.SqlTrackingQuery(ConnectionString);

   SqlTrackingWorkflowInstance t;
   bool gefunden = WFTrackingQuery.TryGetWorkflow(instance.InstanceId, out t);
   if (gefunden)
   {
    string ausgabe = "";

    foreach (WorkflowTrackingRecord r in t.WorkflowEvents)
    {
     ausgabe += String.Format("{0}: {1}: {2}  \n", r.EventDateTime, r.EventOrder, r.TrackingWorkflowEvent.ToString());
    }
    ausgabe += "-------------\n";
    foreach (ActivityTrackingRecord r in t.ActivityEvents)
    {
     ausgabe += String.Format("{0}: {1}: {2} {3} = {4}  \n", r.EventDateTime, r.EventOrder, r.ActivityType.Name, r.QualifiedName, r.ExecutionStatus);
    }
    System.Windows.Forms.MessageBox.Show(ausgabe, "Protokoll fr Workflow " + instance.InstanceId);
   }
  }
  // ENDE




 }
}