
using System;
using System.Management.Automation;
using de.ITVisions.PowerShell.Types;


namespace de.ITVisions.PowerShell.Types
{
 internal class ComputerInfo
 {
  public string ComputerName;
  public int ProcessorCount;
  public string Domain;
  public string Culture;
  public bool Connected;
 }
}
namespace de.ITVisions.PowerShell.Computer
{

 /// <summary>
 /// Commandletklasse
 /// </summary>
 [Cmdlet(VerbsCommon.Get, "ComputerInfo")]
 public class GetComputerInfoCommand : PSCmdlet
 {

  protected override void BeginProcessing()
  {
  }

  protected override void ProcessRecord()
  {
  }

  protected override void EndProcessing()
  {
   ComputerInfo i = new ComputerInfo();
   i.ComputerName = Environment.MachineName;
   i.ProcessorCount = Environment.ProcessorCount;
   i.Domain = Environment.UserDomainName;
   i.Culture = System.Globalization.CultureInfo.CurrentUICulture.ToString();
   i.Connected = System.Net.NetworkInformation.NetworkInterface.GetIsNetworkAvailable();
   this.WriteObject(i);
  }

  protected override void StopProcessing()
  {
  }

 }
}

