﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Runtime.InteropServices.Automation;

namespace ITVisions.SilverlightUtil
{

  /// <summary>
  /// Hilfsroutinen für Out-Of-Browser
  /// </summary>
  public class OOBUtil
  {
    public static void InstallOutOfBrowser()
    {
      if (Application.Current.IsRunningOutOfBrowser)
      {
        Application.Current.CheckAndDownloadUpdateAsync();
      }
      else
      {
        try
        {
          Application.Current.Install();
        }
        catch (Exception ex)
        {
          MessageBox.Show(ex.Message, "Installationsproblem", MessageBoxButton.OK);
        }
      }
    }


    /// <summary>
    /// Ausführen einer beliebigen Anwendung
    /// </summary>
    public static int Run(string cmd)
    {
      dynamic shell = AutomationFactory.CreateObject("Wscript.Shell");
      return shell.Run(cmd);       
    }

    public static void CheckAndDownloadUpdateCompleted(object sender, CheckAndDownloadUpdateCompletedEventArgs e)
    {
      if (e.UpdateAvailable)
      {
        MessageBox.Show("Ein Update wurde heruntergeladen. Bitte starten Sie die Anwendung neu!");
      }
      else if (e.Error != null &&
                  e.Error is PlatformNotSupportedException)
      {
        MessageBox.Show("Es gibt ein Update der Anwendung, dafür ist auch eine neue Version von Silverlight notwendig.");
      }
      else
      {
        MessageBox.Show("Kein Update verfügbar");
      }
    }
  }
}
