﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using ITVisions;

namespace Silverlight
{
 public partial class App : Application
 {


  public App()
  {
   this.Startup += this.Application_Startup;
   this.Exit += this.Application_Exit;
   this.UnhandledException += this.Application_UnhandledException;

   InitializeComponent();
  }

  private void Application_Startup(object sender, StartupEventArgs e)
  {
    //App.Current.CheckAndDownloadUpdateAsync();

   // this.RootVisual = new Fluege_DataServiceDomain_Designed();
  this.RootVisual = new Fluege_RiaServiceDomainDataSource_Designed();
  }

  private void Application_Exit(object sender, EventArgs e)
  {

  }

  private void Application_UnhandledException(object sender, ApplicationUnhandledExceptionEventArgs e)
  {
    if (!System.Diagnostics.Debugger.IsAttached)
    {
      e.Handled = true;
      if (Application.Current.InstallState == System.Windows.InstallState.Installed)
      {
        MessageBox.Show(e.ExceptionObject.GetWholeMessage() + " @ " + e.ExceptionObject.StackTrace, "Fehler in der Silverlight-Anwendung", MessageBoxButton.OK);
      }
      else
      {
      Deployment.Current.Dispatcher.BeginInvoke(delegate { ReportErrorToDOM(e); }); 
      }
    }
  }

  private void ReportErrorToDOM(ApplicationUnhandledExceptionEventArgs e)
  {
   try
   {
    string errorMsg = e.ExceptionObject.Message + e.ExceptionObject.StackTrace;
    errorMsg = errorMsg.Replace('"', '\'').Replace("\r\n", @"\n");

    System.Windows.Browser.HtmlPage.Window.Eval("throw new Error(\"Unhandled Error in Silverlight Application " + errorMsg + "\");");
   }
   catch (Exception)
   {
   }
  }
 }
}
