﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.Generic;
//using WWWings_Silverlight.FlugplanDataservice;
//using System.Data.Services.Client;
using System.Linq;
//using WWWings_RIAServices.Web;
//using System.Windows.Ria;
using System.Net.NetworkInformation;
using System.IO.IsolatedStorage;
using System.IO;
using System.Runtime.Serialization;
//using System.Windows.Controls.Ria;
using WWWings_Silverlight;
using SilverlightServices;
using System.ServiceModel.DomainServices.Client;
using WWWings35_GO.EF;


namespace Silverlight
{
 public partial class Fluege_RiaService_Designed : ITVSLDemoWindow
 {

  // Variablen
  FlugDomContext dc = new FlugDomContext();

  public Fluege_RiaService_Designed()
   : base()
  {
   // Required to initialize variables
   InitializeComponent();
   //this.FlugDataSource.IsLoadingData

   // Combox init
   this.C_Anzahl.ItemsSource = new List<string>() { "Alle", "5", "10", "15", "20", "50" };
   this.C_Anzahl.SelectedIndex = 0;

   // Statisch...
   //this.C_Ort.ItemsSource = new List<string>() { "Alle", "Rom", "Berlin", "Paris", "Mailand", "Moskau", "Essen/Mülheim" };
   // this.C_Ort.SelectedIndex = 1;
   // oder via Service!

   // Eigene Methode
   dc.GetOrte(GetOrteCompleted, null);


   // Generische Methode
   //var q = (from f in dc.Flugs select f.Abflugort);

   //LoadOperation<WWWings35_GO.EF.Flug> lo;
   //lo = dc.Load(q, OnOrteLoadCompleted, null);

   // nur für manuellen Start der Animation
   //this.C_LoadingGrid.Visibility = Visibility.Collapsed;

   this.C_Status.Text = ("Silverlight-Anwendung ist bereit.");

   Application.Current.CheckAndDownloadUpdateCompleted += new CheckAndDownloadUpdateCompletedEventHandler(Current_CheckAndDownloadUpdateCompleted);

   if (Application.Current.IsRunningOutOfBrowser)
   {
    this.C_Install.Content = "Update";
   }
   NetStat();
   NetworkChange.NetworkAddressChanged += (s, e) => { NetStat(); };


   this.FlugDataSource.LoadedData += new EventHandler<LoadedDataEventArgs>(FlugDataSource_LoadedData);
  }

  // nur wenn ohne Domain Data Source
  private void OnOrteLoadCompleted(LoadOperation<WWWings35_GO.EF.Flug> lo)
  {
   this.C_Fluege.ItemsSource = lo.Entities.ToList();
   List<string> Orte = new List<string>() { "Alle" };
   //Orte.AddRange(lo.AllEntities);
   this.C_Ort.ItemsSource = Orte;
   this.C_Ort.SelectedIndex = 0;
  }

  private void GetOrteCompleted(InvokeOperation<IEnumerable<string>> op)
  {
   List<string> Orte = new List<string>() { "Alle" };
   if (!op.HasError) Orte.AddRange(op.Value);
   this.C_Ort.ItemsSource = Orte;
   this.C_Ort.SelectedIndex = 0;
  }

  private void NetStat()
  {
   string s = GetNetStat();
   this.C_Network.Text = s;
  }

  // Daten laden
  private void C_Lesen_Click(object sender, System.Windows.RoutedEventArgs e)
  {

   //this.C_Fluege.ItemsSource = null;
   // nur für manuelle Start der Animation!
   //this.LoadingAnimation.Begin();
   //this.C_Fluege.Visibility = Visibility.Collapsed;
   //this.C_LoadingGrid.Visibility = Visibility.Visible;


   // Wiederherstellen der Verbindung  zu DataSource, falls durch Laden der Cache Daten verloren
   this.C_Fluege.ItemsSource = this.FlugDataSource.Data;
   this.C_Status.Text = ("Lade Flüge... (1)");

   #region Ohne DomainDataSource
   // Anfrage zusammenstellen, wenn keine DataSource eingesetzt
   EntityQuery<WWWings35_GO.EF.Flug> q = dc.GetFlugQuery();
   if (this.C_Ort.SelectedItem.ToString() != "Alle")
   {
    q = q.Where(f => f.Abflugort == this.C_Ort.SelectedItem.ToString());
    // q = dc.GetFlugByOrtQuery(C_Ort.SelectedItem.ToString());
   }
   if (this.C_Anzahl.SelectedItem.ToString() != "Alle")
   { q = q.Take(Convert.ToInt32(this.C_Anzahl.SelectedItem.ToString())); }
   this.C_Status.Text = ("Lade Flüge... (2)");
   //Laden beginnen

   //1. Entweder klassisch asynchron
   LoadOperation<WWWings35_GO.EF.Flug> lo;
   lo = dc.Load(q, OnLoadCompleted, null);

   //this.C_BusyIndicator.IsBusy = true;
   //2. oder vereinfacht asynchron
   //this.C_Fluege.ItemsSource = dc.Load(q).AllEntities; 

   #endregion

   #region Mit DomainDataSource
   //if (this.C_Ort.SelectedItem.ToString() == "Alle") this.FlugDataSource.FilterDescriptors[0].Operator = System.Windows.Data.FilterOperator.IsNotEqualTo;
   //else this.FlugDataSource.FilterDescriptors[0].Operator = System.Windows.Data.FilterOperator.Contains;

   //if (this.C_Anzahl.SelectedItem.ToString() == "Alle") this.FlugDataSource.PageSize = 0;
   //else this.FlugDataSource.PageSize = Convert.ToInt32(this.C_Anzahl.SelectedItem);

   //this.FlugDataSource.Load();
   #endregion
   this.C_Status.Text = ("Lade Flüge... (3)");
  }

  // nur mit Domain Service
  void FlugDataSource_LoadedData(object sender, LoadedDataEventArgs e)
  {

   this.C_Status.Text = ("Lade Flüge... (4)");
   //this.C_Fluege.Visibility = Visibility.Collapsed;
  }

  // nur wenn ohne Domain Data Source
  private void OnLoadCompleted(LoadOperation<WWWings35_GO.EF.Flug> lo)
  {
   if (lo.HasError)
   {
    MessageBox.Show(string.Format("Load Failed: {0}", lo.Error.Message));
    lo.MarkErrorAsHandled();
   }
   this.C_Fluege.ItemsSource = lo.Entities.ToArray(); //dc.Flugs wenn man es über lo.completed macht!;
   this.C_Status.Text = lo.Entities.Count() + " Flüge geladen.";


   // nur für manuelles Ende der Animation!
   //this.C_Fluege.Visibility = Visibility.Visible;
   //this.C_LoadingGrid.Visibility = Visibility.Collapsed;
  }

  // Speichern
  private void C_Speichern_Click(object sender, RoutedEventArgs e)
  {
   d.C_DataForm.CommitEdit();
   C_Fluege.CommitEdit();
   // bei Domain Data Source
   //EntityContainer ec = this.FlugDataSource.DomainContext.EntityContainer;
 
   // ohne Domain Service
   EntityContainer ec = dc.EntityContainer;

   if (!ec.HasChanges) { MessageBox.Show("Keine Änderungen vorhanden!"); return; }

   // bei Domain Data Source
   EntityChangeSet changset = ec.GetChanges();

   if (MessageBox.Show("Möchten Sie folgende Änderungen zum Server übertragen:\nNeu: " + changset.AddedEntities.Count + " Gelöscht: " + changset.RemovedEntities.Count + " Geändert: " + changset.ModifiedEntities.Count, "Speichern", MessageBoxButton.OKCancel) == MessageBoxResult.Cancel) return;

   // bei Domain Data Source --> geht hier aber nicht, wenn die Daten zwischenzeitlich aus dem Cache geladen wurden!!!
   //this.FlugDataSource.SubmitChanges();
   // Speichern mit unter der DomainDataSource liegende DomainContext
   //this.FlugDataSource.DomainContext.SubmitChanges();
   // ohne Domain Data Source:

   dc.SubmitChanges(OnSubmitCompleted, null);
  }


  private void OnSubmitCompleted(SubmitOperation so)
  {
   if (so.HasError)
   {
    MessageBox.Show(string.Format("Submit Failed: {0}", so.Error.Message));
    so.MarkErrorAsHandled();
   }
   else
   {
    this.C_Status.Text = "Gespeichert: Neu: " + so.ChangeSet.AddedEntities.Count + " Gelöscht: " + so.ChangeSet.RemovedEntities.Count + " Geändert: " + so.ChangeSet.ModifiedEntities.Count;
   }
  }



  #region Caching
  /// <summary>
  /// Schreibe Cache
  /// </summary>
  /// <remarks>
  /// // Nur zum testen
  /// StreamWriter writer = new StreamWriter(fileStream);
  /// writer.Write(DateTime.Now.ToString());
  /// </remarks>
  private void C_Cache_Save_Click(object sender, RoutedEventArgs e)
  {
   this.C_Status.Text = "Speichern im Cache ...";
   // Vorbereiten der Daten
   WWWings35_GO.EF.Flug[] fluege;
   if (this.C_Fluege.ItemsSource is DomainDataSourceView)
   {
   // TODO: fluege = (this.C_Fluege.ItemsSource as DomainDataSourceView);
    fluege = null;
   }
   else
   {
    fluege = this.C_Fluege.ItemsSource as WWWings35_GO.EF.Flug[];
   }

   string s = SaveInCache<Flug, Flug[]>(fluege);
   if (s != "")
   {
    // Anzeige
    MessageBox.Show(s, "Speichern im Cache", MessageBoxButton.OK);
    this.C_Status.Text = s;
   }
  }


  /// <summary>
  /// Laden aus Cache
  /// </summary>
  private void C_Cache_Load_Click(object sender, RoutedEventArgs e)
  {
   this.C_Status.Text = "Laden aus Cache ...";
   WWWings35_GO.EF.Flug[] fluege = Import();
   if (fluege != null)
   {
    // Anzeigen
    this.C_Fluege.ItemsSource = fluege;
    this.C_Status.Text = fluege.Count() + " Datensätze aus Cache geladen!";
   }
  }

  FlugDetails d = new FlugDetails();
  private void C_Details_Click(object sender, RoutedEventArgs e)
  {
   if (this.C_Fluege.SelectedItem == null) return;

   d.CurrentItem = this.C_Fluege.SelectedItem;
   d.Show();

  }
  #endregion



  /// <summary>
  /// Anzeige leeren
  /// </summary>
  public void C_Clear_Click(object sender, RoutedEventArgs e)
  {
   // geht nicht, weil es nicht wirkt, wenn die Daten aus dem Cache kommen!
   // this.FlugDataSource.Clear()
   this.C_Fluege.ItemsSource = null;
   this.C_Status.Text = "Bereit";
  }


  /// <summary>
  /// Lokale Installation
  /// </summary>
  public void C_Install_Click(object sender, RoutedEventArgs e)
  {
   InstallOutOfBrowser();
  }

  private void C_Info_Click(object sender, RoutedEventArgs e)
  {
    InfoWindow w = new InfoWindow();
    w.Show();
  }

 }
}