// ----------------------------------------------------------------------------------
// Microsoft Developer & Platform Evangelism
// 
// Copyright (c) Microsoft Corporation. All rights reserved.
// 
// THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, 
// EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES 
// OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
// ----------------------------------------------------------------------------------
// The example companies, organizations, products, domain names,
// e-mail addresses, logos, people, places, and events depicted
// herein are fictitious.  No association with any real company,
// organization, product, domain name, email address, logo, person,
// places, or events is intended or should be inferred.
// ----------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Data;


namespace Silverlight
{
  public partial class FlugListePrint : UserControl
  {
    public FlugListePrint()
    {
      InitializeComponent();
    }

    /// <summary>
    /// Befllen einer Seite (Basiert auf Beispiel von http://weblogs.asp.net/scottgu/archive/2010/04/22/silverlight-4-training-kit.aspx)
    /// </summary>
    public int PopulatePage<TYP>(IEnumerable<TYP> items, int Seitennummer, int startingPoint)
    {
      double containerWidth = Container.ActualWidth;
      double containerHeight = Container.ActualHeight;

      StackPanel Element = new StackPanel();
      Element.Width = containerWidth;
      Container.Child = Element;
      int itemsAdded = 0;
      this.UpdateLayout();
      foreach (TYP item in items.Skip(startingPoint))
      {
        FlugPrint uc = new FlugPrint();
        uc.SetData(item);
        uc.DataContext = item;
        Element.Children.Add(uc);
        this.UpdateLayout();
        Element.Measure(new Size(containerWidth, double.PositiveInfinity));
        if (Element.DesiredSize.Height > containerHeight && itemsAdded > 0)
        {
          Element.Children.Remove(uc);
          break;
        }
        itemsAdded += 1;
      }

      this.C_Seitenummer.Text = "Seite #" + Seitennummer.ToString();
      return itemsAdded;
    }
  }
}