﻿using System.Web;
using System.Web.Compilation;
using System.Web.Routing;
using System.Web.UI;
using System.Web.Security;
using System.Security;

/// <summary>
/// URL Routing für Flüge 
/// ~/Flug/101 --> "~/Fluege/RAD/Flugdetails_SDS.aspx?FlugNr=101
/// </summary>
public class Flug_RouteHandler : IRouteHandler
{
 public IHttpHandler GetHttpHandler(RequestContext requestContext)
 {
  // Auswerten der Parameter
  string FlugNr = requestContext.RouteData.GetRequiredString("FlugNr");
  // Pfad festlegen
  string Pfad = "/Fluege/RAD/Flugdetails_SDS.aspx";
  // Seite instanziieren
  Page Seite = (Page)BuildManager.CreateInstanceFromVirtualPath(Pfad, typeof(System.Web.UI.Page));
  // Parameter übergeben
  HttpContext.Current.Items.Add("FlugNr", FlugNr.ToString());
  // Seite zurückgeben
  return Seite;
 }
}


/// <summary>
/// URL Routing auf beliebige URL
/// </summary>
public class CommonRouteHandler : IRouteHandler
{
 string URL;
 public CommonRouteHandler(string URL)
 {
  this.URL = URL;
 }

 public IHttpHandler GetHttpHandler(RequestContext requestContext)
 {
  // Zugriffsrechte

  if (!UrlAuthorizationModule.CheckUrlAccessForPrincipal(URL
              , requestContext.HttpContext.User
              , requestContext.HttpContext.Request.HttpMethod))
   throw new SecurityException();


  // Seite instanziieren
  Page Seite = (Page)BuildManager.CreateInstanceFromVirtualPath(URL, typeof(System.Web.UI.Page));
  // Parameter übergeben
  foreach (var Wert in requestContext.RouteData.Values)
  {
   HttpContext.Current.Items[Wert.Key] = Wert.Value;
  }
  // Seite zurückgeben
  return Seite;
 }

}

