﻿using System;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Activation;
using System.ServiceModel.Web;
using System.Collections.Generic;

namespace DTO
{
public class Flug
{
 public Int32 FlugNr;
 public string Abflugort;
 public string Zielort;
 public short? FreiePlaetze;
 public DateTime Datum;
}
}

[ServiceContract(Namespace = "")]
[AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
public class Flugplanservice_WCFAJAX
{

 // Wird aufgerufen in der Demo!
 [OperationContract]
 public List<de.WWWings.GO.Flug> HoleFluege(string Ort)
 {
  return new de.WWWings.GL.FlugBLManager().GetFluegeVonOrt(Ort);
 }



 // Nur zum Test
 [OperationContract]
 public void DoWork()
 {
  return;
 }



 [OperationContract]
 public List<de.WWWings.GO.Flug> HoleAlleFluege()
 {
  return new de.WWWings.GL.FlugBLManager().GetFluege();
 }

 [OperationContract]
 public List<de.WWWings.GO.Flug> HoleEinigeFluege()
 {
  return new de.WWWings.GL.FlugBLManager().GetFluege().Take(20).ToList();
 }



 [OperationContract]
 public de.WWWings.Flug GetFlight(long FlightNo)
 {
  return de.WWWings.FlugBLManager.HoleFlug(FlightNo);
 }

 //[WebMethod()]
 //public System.Data.DataSet GetAllFlights()
 //{
 // //Return New Data.DataSet()
 // return de.WWWings.DAL.Flug_DataManager.AlleFluege_DS();
 //}

 [OperationContract]
 public string[] GetDestinations(string Abflugort)
 {
  return de.WWWings.FlugBLManager.Ziele_Fuer_Abflugort(Abflugort);
 }


 [OperationContract]
 public de.WWWings.FlugMenge HoleAlleVon(string Ort)
 {
  return de.WWWings.FlugBLManager.HoleAlle(Ort);
 }

 [OperationContract]
 public PagedResult<DTO.Flug> HoleAlleVon35(string Ort, int Anzahl, int Start)
 {
  de.WWWings.GL.FlugBLManager bl = new de.WWWings.GL.FlugBLManager();
  PagedResult<DTO.Flug> p = new PagedResult<DTO.Flug>();
  p.Rows = (from f in bl.GetFluegeVonOrt_Paging(Ort, "Abflugort", Anzahl, Start) select new DTO.Flug { FlugNr = f.FlugNr, Abflugort = f.Abflugort, Zielort = f.Zielort, Datum = f.Datum, FreiePlaetze = f.FreiePlaetze.Value }).ToList();
  p.Total = bl.CountFluegeVonOrt(Ort);
  return p;
 }

 [OperationContract]
 public List<DTO.Flug> GetFluegeByOrt35(string Ort)
 {
  de.WWWings.GL.FlugBLManager bl = new de.WWWings.GL.FlugBLManager();

  return (from f in bl.GetFluegeVonOrt(Ort) select new DTO.Flug { FlugNr = f.FlugNr, Abflugort = f.Abflugort, Zielort = f.Zielort, Datum = f.Datum, FreiePlaetze = f.FreiePlaetze }).ToList();

 }

 [OperationContract]
 public bool Save(de.WWWings.GO.Flug flugNeu)
 {
  de.WWWings.GL.FlugBLManager bl = new de.WWWings.GL.FlugBLManager();

  return bl.SaveFlug(flugNeu);

 }

 [OperationContract]
 public List<DTO.Flug> HoleEinigeFluege35()
 {
  de.WWWings.GL.FlugBLManager bl = new de.WWWings.GL.FlugBLManager();
  // Achtung: Holt alle, Take() findet im RAM statt!
  return (from f in bl.GetFluege().Take(20) select new DTO.Flug { FlugNr = f.FlugNr, Abflugort = f.Abflugort, Zielort = f.Zielort, Datum = f.Datum, FreiePlaetze = (short)f.FreiePlaetze }).ToList();
 
 }


 // HS 31.08.2009 
 // Webdienst für AJAX Grid und Pager von Kazi Manzur (http://dotnetslackers.com/articles/ajax/ASPNETAjaxGridAndPager.aspx)
 //[OperationContract]
 //public PagedResult<de.WWWings.GO.Flug> HoleAlleVonPaging(string Ort, int start, int max, string sortColumn, string sortOrder)
 //{

 // de.WWWings.GO.CS_EF_WWWings model = new de.WWWings.GO.CS_EF_WWWings();
 // //var fluege = (from f in model.Flug where f.Abflugort == Ort orderby f.FlugNr select f).Skip(start).Take(max);
 // var fluege = (from f in model.Flug where f.Abflugort == Ort select f).Take(1);

 // PagedResult<de.WWWings.GO.Flug> p = new PagedResult<de.WWWings.GO.Flug>();
 // p.Rows = fluege.ToList();
 // p.Total = (from f in model.Flug where f.Abflugort == Ort select f).Count();

 // model.Dispose();
 // return p;
 //}

 [OperationContract]
 public PagedResult<de.WWWings.Flug> HoleAlleVonPaging(string Ort, int start, int max, string sortColumn, string sortOrder)
 {


  PagedResult<de.WWWings.Flug> p = new PagedResult<de.WWWings.Flug>();
  p.Rows =  de.WWWings.FlugBLManager.HoleAlle(Ort, max, start).ToList();
  p.Total = de.WWWings.FlugBLManager.AnzFluege(Ort);


  return p;
 }

}
[Serializable]
public class PagedResult<T>
{
 public long Total;
 public List<T> Rows;
}
