﻿using System;
using System.Data.Services;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel.Web;
using de.WWWings.GO;
using System.Linq.Expressions;
using System.Web;
using System.Data.Services.Common;

///  Hier EF-Modell angeben
public class WWWingsFlugplanDataService : DataService<de.WWWings.GO.WWWings6Entities>
{

 public static void InitializeService(DataServiceConfiguration config)
 {
  // Neue Features aktivieren
  config.DataServiceBehavior.MaxProtocolVersion = DataServiceProtocolVersion.V2;
  // Nur zum Debuggen die Fehlerdetails ein!
  config.UseVerboseErrors = true;
  // Hier Zugriffsrechte setzen
  config.SetEntitySetAccessRule("*", EntitySetRights.All);
  config.SetServiceOperationAccessRule("*", ServiceOperationRights.All);
 }

 //protected override void OnStartProcessingRequest(ProcessRequestArgs args)
 //{
 // base.OnStartProcessingRequest(args);
 //}

 // Aufruf: http://localhost:90/Webservice/WWWingsDataService.svc/Count?Stadt='Rom'
 [WebGet]
 public int Count(string Stadt)
 {

  if (string.IsNullOrEmpty(Stadt))
  {
   throw new ArgumentNullException("Stadt",
             "Stadt darf nicht leer sein!");
  }
  return (from f in this.CurrentDataSource.Flug where f.Abflugort == Stadt select f).Count();
 }

 [WebGet]
 public int GetCount(string where)
 {
  return String.IsNullOrEmpty(where) ? CurrentDataSource.Flug.Count() : CurrentDataSource.Flug.Where(where).Count();
 } 

 [WebGet]
 public IQueryable<de.WWWings.GO.Flug> FluegeVon(string Stadt)
 {

  if (string.IsNullOrEmpty(Stadt))
  {
   throw new ArgumentNullException("Stadt",
             "Stadt darf nicht leer sein!");
  }
  return (from f in this.CurrentDataSource.Flug where f.Abflugort == Stadt select f); 
 }

 // nur Ort mit "R" zulassen
 //[QueryInterceptor("Flug")]
 //public Expression<Func<Flug, bool>> FilterFluege()
 //{
 // if (HttpContext.Current.User.Identity.Name == "HS")
 //  return o => true;
 // else
 // return o => o.Abflugort.StartsWith("R") == true;
 //}

}
