<%@ Page Language="C#" AutoEventWireup="true" CodeFile="Flugdaten_AJAX_Service_WCF_ClientGrid.aspx.cs"
 Inherits="Flugdaten_AJAX_Service_WCF_ClientGrid" MasterPageFile="~/Master/WWWings.Einfach.master"
 Title="AJAX Service via WCF" %>

<%@ Register Assembly="Ajax.Controls" Namespace="Ajax.Controls" TagPrefix="ajax" %>
<asp:Content ID="P1" runat="server" ContentPlaceHolderID="P_MainContent">
 <link href="StyleSheet.css" rel="stylesheet" type="text/css" />

 <script src="/App_Scripts/AJAX_Hilfsroutinen.js" type="text/javascript"></script>

 <script language="javascript">



 </script>

 <script type="text/javascript">
  var _message;
  var _grid;
  var _pager;

  function pageLoad() {
   // Getting the reference of the Client Components and attaching the event handlers
   _grid = $find("<%=  this.grid.ClientID %>");
   _grid.add_sort(sorted);

   _pager = $find("<%=  this.pager.ClientID %>");
   _pager.add_pageChange(pageChanged);

   //Getting the reference of the DOM elements
   _message = $get('message');
   DatenLaden();

  }

  function pageUnload() {
   //Remove the handlers in page unload-- Good Practice
   _grid.remove_sort(sorted);
   _pager.remove_pageChange(pageChanged);
  }


  function sorted(sender, e) {
   //Set the SortColum and SortOrder of the Grid so that it can properly render current sort column
   //and the associated image
   _grid.set_sortColumn(e.get_sortColumn());
   _grid.set_sortOrder(e.get_sortOrder());

   _pager.set_currentPage(1); // need to reset the current page as sorting has been changed
   DatenLaden();
  }

  function pageChanged(sender, e) {
   _pager.set_currentPage(e.get_newPage()); //Set the new page as current page
   DatenLaden();
  }

  function DatenLaden() {
   var abflug = document.getElementById('C_Abflugort').options[$get('C_Abflugort').selectedIndex].value;

   //Calculating the startindex 
   var startIndex = ((_pager.get_currentPage()) * _pager.get_rowPerPage());

   //Need to convert the sortoder which our Webservice can understand
   var sortOrder = (_grid.get_sortOrder() == Ajax.Controls.GridSortOrder.Descending) ? 'DESC' : 'ASC';

   // Status
   _message.innerHTML = '<div><img alt=\"\" src=\"Images/indicator.gif\"/>&nbsp;Lade Daten fr ' + abflug + '</div>';
   _message.style.display = '';

   // Start Webservice
   Flugplanservice_WCFAJAX.HoleAlleVon35(abflug,
                                            _pager.get_rowPerPage(), startIndex,
                                            Ausgabe,
                                            Fehler
                                        );
  }


  function Fehler(exception) {
   _message.innerHTML = '<span style=\"color:#ff0000\">' + exception.get_message() + '</span>';
  }

  // Ergebnis kommt an
  function Ausgabe(pagedResult) {
   var total = 0;
   var fluege = null;

   if (pagedResult != null) {
    total = pagedResult.Total;
    fluege = pagedResult.Rows;
   }

   _grid.set_dataSource(fluege);
   _grid.dataBind();

   _pager.set_rowCount(total);

   _message.innerHTML = '';
   _message.style.display = 'none';
  }
                                            
 </script>

 <div>
  <span class="">Alle Flge von einem bestimmten Ort<br />
   Lsung mit WCF AJAX Service und Client-Grid/Client-Pager von <a href="http://dotnetslackers.com/articles/ajax/ASPNETAjaxGridAndPager.aspx">
    Kazi Manzur</a></span></p>
  <asp:ScriptManager ID="ScriptManager1" runat="server" ScriptMode="Inherit">
   <Services>
    <asp:ServiceReference Path="/Webservice/FlugplanService_WCFAJAX.svc" />
   </Services>
  </asp:ScriptManager>
  Abflugort:
  <select id="C_Abflugort" name="C_Abflugort" onchange="DatenLaden();">
   <option value="Berlin" selected="selected">Berlin</option>
   <option value="Rom">Rom</option>
   <option value="Paris">Paris</option>
   <option value="Dallas">Essen/Mlheim</option>
  </select>
  </strong>
  <br />
  <br />
  <ajax:Grid ID="grid" runat="server" Border="0" CellPadding="5" CellSpacing="0" CssClass="grid"
   HeaderCssClass="gridHeader" RowCssClass="gridRow" AlternatingRowCssClass="gridAltRow"
   SelectedRowCssClass="gridSelectedRow" SortColumn="flugNr" SortOrderAscendingImage="Images/up.gif"
   SortOrderDescendingImage="Images/dn.gif">
   <Columns>
    <ajax:GridColumn Width="50" DataField="FlugNr" HeaderText="Flugnummer" Sortable="True"
     Nowrap="True" />
    <ajax:GridColumn Width="100" DataField="Datum" FormatString="d" HeaderText="Datum"
     Sortable="True" />
    <ajax:GridColumn Width="100" DataField="Abflugort" HeaderText="Abflugort" Sortable="True" />
    <ajax:GridColumn Width="100" DataField="Zielort" HeaderText="ZielOrt" Sortable="True" />
    <ajax:GridColumn Width="50" DataField="FreiePlaetze" HeaderText="Freie Plaetze" Sortable="True" />
   </Columns>
  </ajax:Grid>
  <ajax:Pager ID="pager" runat="server" CssClass="pager" CurrentPageCssClass="pagerCurrentPage"
   OtherPageCssClass="pagerOtherPage" ShowInfo="True" InfoCssClass="pagerInfo">
  </ajax:Pager>
  <div id="message" style="display: none">
  </div>
 </div>
</asp:Content>
