﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="Flughafenauswahl.aspx.cs" Inherits="_Default" MasterPageFile="~/Master/WWWings.master" Title="Flughafenauswahl" %>

<asp:Content ContentPlaceHolderID=P_MainContent runat="server">

  <script type="text/javascript" src="http://dev.virtualearth.net/mapcontrol/mapcontrol.ashx?v=6">
  </script>

  <script type="text/javascript">
      var map;
      
      function pageLoad(sender, e)
      {
        map = new VEMap('myMap');

        // Karte auf Auswahlflughafen zentrieren      
        map.LoadMap(getSelection(), 12);

      }

      function getSelection()
      {
        // Wert aus Dropdown-Liste
        var flughafen=$get("Select1").value;
        
        // Länge und Breite ermitteln
        var lat = Number.parseInvariant( flughafen.substr(0,7));
        var lon = Number.parseInvariant( flughafen.substr(10,8));
        
        // VELatLong-Objekt erzeugen
        var latlon=new VELatLong(lat, lon);
        
        return latlon;
      }
            
      function setLocation()
      {
        try
        {
          map.Find("Airport", "Flughafen Düsseldorf", null, null, 
            0, 1, true, true, true, true, MoreResults);
        }
        catch(e)
        {
          alert("Fehler: " + e.message);
        }
      }
      
      function FlughafenAusgewählt()
      {
        // Karte auf ausgewählten Flughafen zentrieren
        map.SetCenter(getSelection());
      }
      
      function MoreResults(layer, resultsArray, places, hasMore, veErrorMessage)
      {
//        alert("Gefunden");
      }
      
      function AnfahrtBerechnen()
      {
        // Startadresse
        var adresse = $get("textAdresse").value;
        
        // Ziel ist der ausgewählte Flughafen
        var strecke = new Array(adresse, getSelection()); 
        
        // Optionen für die Routenberechnung einstellen
        var options = new VERouteOptions;

        // Route in der Karte anzeigen
        options.DrawRoute = true;

        // Zoom-Faktor nicht verändern
        options.SetBestMapView = false;

        // Rückrufmethode (nach erfolgter Berechnung)
        options.RouteCallback = RouteAuswerten;

        // Darstellung in Kilometern, nicht in Meilen
        options.DistanceUnit = VERouteDistanceUnit.Kilometer;

        // Dialog anzeigen, wenn Adresse nicht eindeutig ist
        options.ShowDisambiguation = true;

        // Routenberechnung starten
        map.GetDirections(strecke, options);
    
      }         

      function RouteAuswerten(route)
      {
      if (route) // Wenn keine Route gefunden wurde
      {
        // Route wurde berechnet, Gesamtstrecke ermitteln
        var lbl = $get("LBLStrecke");
        lbl.innerText=Math.ceil(route.RouteLegs[0].Distance) + " km";
      }
      }
      

      
  </script>
<body>

  <b>HINWEIS: Dieses Beispiel basiert auf Virtual Earth und läuft nur im Internet Explorer korrekt!</b>
  <asp:ScriptManager ID="ScriptManager1" runat="server">
  </asp:ScriptManager>

  <div style="">
    <select id="Select1" onblur="FlughafenAusgewählt()">
      <option selected="selected" 
          label="Köln/Bonn" value="050.878, 007.1221"></option>
      <option label="Düsseldorf" value="051.279, 006.7662"></option>
      <option label="Hamburg" value="053.634, 010.0060"></option>
      <option label="Frankfurt am Main" value="050.048, 008.5669"></option>
      <option label="München" value="048.353, 011.7705"></option>
    </select>
    <br /> <br /> 
    Adresse: 
    <br />
    <input type="text" ID="textAdresse" style=" width:400px" ></input>
     <br />
    <input id="Button1" type="button" value="Anfahrt berechnen" onclick="AnfahrtBerechnen()" />
    
    <br />

  
    Fahrtstrecke: 
   <span ID="LBLStrecke"></span>
    <p></p>
    
  </div>
        <div id='myMap' style="">
  </div>
  
</body>
</asp:Content>
