﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.Linq;
using de.WWWings.Test.Modelle.LTS4;
using de.WWWings.Test.Modelle;

namespace de.WWWings.Test
{
 class DBInit_V4
 {

  /// <summary>
  /// Menge von Flügen erzeugen
  /// </summary>
  public static void Init_DB()
  {
   LTS.HeadLine("DB Version 4 Initialisieren");
   string[] Flughaefen = { "Berlin", "Frankfurt", "München", "Hamburg", "Köln/Bonn", "Rom", "London", "Paris", "Mailand", "Prag", "Moskau", "New York", "Seattle", "Essen/Mülheim", "Kapstadt", "Madrid", "Oslo", "Dallas" };
   System.Random rnd = new Random();

   DatenbankDataContext db = new DatenbankDataContext();

   Console.WriteLine("Flüge zu Beginn: " + db.FL_Flueges.Count<FL_Fluege>());
   Console.WriteLine("Buchungen zu Beginn: " + db.GF_GebuchteFlueges.Count<GF_GebuchteFluege>());
   Console.WriteLine("Passagiere zu Beginn: " + db.PS_Passagiers.Count<PS_Passagier>());
   // Alle Buchungen löschen!
   db.ExecuteCommand("Delete from GF_GebuchteFluege");
   db.ExecuteCommand("Delete from FLPS_Fluege_Passagiere");
   db.ExecuteCommand("Delete from FL_Fluege");
   db.ExecuteCommand("Delete from PS_Passagier");
   db.ExecuteCommand("Delete from PE_Person where PE_PersonalausweisNr >= 100");

   Console.WriteLine("Buchungen nach dem Löschen: " + db.GF_GebuchteFlueges.Count<GF_GebuchteFluege>());
   Console.WriteLine("Flüge nach dem Löschen: " + db.FL_Flueges.Count<FL_Fluege>());
   Console.WriteLine("Passagiere nach dem Löschen: " + db.PS_Passagiers.Count<PS_Passagier>());

   // Passagiere Anlegen
   string[] Nachnamen = { "Fischer", "Stoiber", "Koch", "Scholz", "Schröder", "Merkel", "Westerwelle", "Beck" };
   string[] Vornamen = { "Edmund", "Olaf", "Roland", "Gerhard", "Angela", "Joschka", "Guido", "Gregor", "Kurt" };


   Console.WriteLine("Erzeuge Passagiere...");
   //DBUtil.ClearTable("GF_GebuchteFluege");
   //DBUtil.ClearTable("PS_Passagier");
   int Nummer = 100;
   foreach (string Vorname in Vornamen)
   {
    foreach (string Nachname in Nachnamen)
    {

     PE_Person pe = new PE_Person();
     pe.PE_Name = Nachname;
     pe.PE_Vorname = Vorname;
     pe.PE_Geburtstag = new DateTime(1940, 1, 1).AddDays(Convert.ToInt32(new Random(DateTime.Now.Millisecond).Next(20000)));
     pe.PE_PersonalausweisNr = Nummer.ToString();
     pe.PE_Land = "DE";
     db.PE_Persons.InsertOnSubmit(pe);

     PS_Passagier ps = new PS_Passagier();
     ps.PS_PE_Personalausweisnummer = Nummer.ToString();
     ps.PS_KundenstatusSeit = pe.PE_Geburtstag.Value.AddHours(Convert.ToInt32(new Random(DateTime.Now.Millisecond).Next(5000)));
     db.PS_Passagiers.InsertOnSubmit(ps);

     db.SubmitChanges();

     System.Console.WriteLine(Nummer + ": " + Vorname + " " + Nachname);

     Nummer++;
    }

   }
   Console.WriteLine("Passagiere nach dem Anfügen: " + db.PS_Passagiers.Count<PS_Passagier>());

   Console.WriteLine("Erzeuge Flüge...");
   var Passagiere = from p in db.PS_Passagiers select p;

   var Fluege = from f in db.FL_Flueges select f;
   int Start = 100;
   int Anz = 10000;

   for (int i = Start; i < (Start + Anz); i++)
   {

    if (i % 100 == 0) Console.WriteLine(i);
    FL_Fluege FlugNeu = new FL_Fluege();
    FlugNeu.FL_FlugNr = i;
    FlugNeu.FL_Abflugort = Flughaefen[rnd.Next(0, Flughaefen.Length - 1)];
    FlugNeu.FL_Zielort = Flughaefen[rnd.Next(0, Flughaefen.Length - 1)]; ;
    FlugNeu.FL_FreiePlaetze = Convert.ToInt16(new System.Random(i).Next(250));
    FlugNeu.FL_Plaetze = 250;
    FlugNeu.FL_Datum = DateTime.Now.AddDays((double)FlugNeu.FL_FreiePlaetze).AddMinutes((double)FlugNeu.FL_FreiePlaetze * 7);
    FlugNeu.FL_NichtRaucherFlug = true;
    db.FL_Flueges.InsertOnSubmit(FlugNeu);
    try
    {
     db.SubmitChanges();
    }
    catch (Exception ex)
    {
     Console.WriteLine("   " + FlugNeu.FL_FlugNr + ":" + FlugNeu.FL_Abflugort + " -> " + FlugNeu.FL_Zielort);

    }

   }

   int k = 0;
   Console.WriteLine("Erzeuge Buchungen...");
   var Fluege2 = from f in db.FL_Flueges select f;

   foreach (FL_Fluege f in Fluege2)
   {
    k++;
    if (k % 100 == 0) Console.WriteLine(k);
    Random rnd2 = new System.Random(System.DateTime.Now.Second);
    for (int j = 1; j < 4; j++)
    {
     // Wähle Zufällig einen Passagier
     PS_Passagier p = Passagiere.ToArray()[Convert.ToInt16(rnd2.Next(Passagiere.Count()))];
     //Console.WriteLine("   " + p.PS_ID);
     // Buchung anlegen
     GF_GebuchteFluege b1 = new GF_GebuchteFluege();
     b1.FL_Fluege = f;
     b1.PS_Passagier = p;
     db.GF_GebuchteFlueges.InsertOnSubmit(b1);

     FLPS_Fluege_Passagiere FLPS = new FLPS_Fluege_Passagiere();
     FLPS.FLPS_PS_ID = p.PS_ID;
     FLPS.FLPS_FL_FlugNr = f.FL_FlugNr;
     db.FLPS_Fluege_Passagiere.InsertOnSubmit(FLPS);

     try // Weil doppelte möglich sind durch Zufallsauswahl!
     {
      db.SubmitChanges();
     }
     catch (Exception)
     {
     }
    }
   }

   Console.WriteLine("Flüge nach dem Einfügen: " + db.FL_Flueges.Count<FL_Fluege>());
   Console.WriteLine("Buchungen nach dem Einfügen: " + db.GF_GebuchteFlueges.Count<GF_GebuchteFluege>());
  }
 }
}
