﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.EntityClient;
using System.Data.Objects;
using System.Data;
using System.Data.Common;
using de.WWWings.Test.Modelle.EF4;
using de.WWWings.Test.LINQ;
using de.WWWings.Test.LINQExtensions;
using System.Linq.Expressions;
using System.Collections;
using VerschiedeneDemos_CS;
using VerschiedeneDemos_CS.FCL3;
using System.Data.SqlClient;

namespace de.WWWings.Test
{
 public class EF_Misc
 {
  const string CS = @"metadata=res://*/DBEF.WorldWideWingsEF.csdl|res://*/DBEF.WorldWideWingsEF.ssdl|res://*/DBEF.WorldWideWingsEF.msl;provider=System.Data.SqlClient;provider connection string=';Data Source=.\sqlexpress;Initial Catalog=WWWings4;Integrated Security=True;Connect Timeout=30;User Instance=True';";


  const string CS2 = @"metadata=res://*/DB.WorldWideWingsEFKompakt.csdl|res://*/DB.WorldWideWingsEFKompakt.ssdl|res://*/DB.WorldWideWingsEFKompakt.msl;provider=System.Data.SqlClient;provider connection string='Data Source=.\sqlexpress;Initial Catalog=WWWings4;Integrated Security=True;Connect Timeout=30;User Instance=True'";

  public static void EF_Test()
  {
   de.WWWings.Test.Modelle.EF4.WorldWideWings db = new de.WWWings.Test.Modelle.EF4.WorldWideWings();

   var flug = (from f in db.FL_Fluege
               where f.FL_Abflugort == "Berlin"
               select f).FirstOrDefault();

   Console.WriteLine(flug.EntityKey.EntityKeyValues[0].Value);

  }


  public static void EF_Connection_ExpliziterConnectionString()
  {

   string CS =
@"metadata=res://*/Modelle.EF6.WWWings6.csdl|res://*/Modelle.EF6.WWWings6.ssdl|res://*/Modelle.EF6.WWWings6.msl;provider=System.Data.SqlClient;provider connection string='Data Source=.\sqlexpress;Initial Catalog=WWWings6;Integrated Security=True;MultipleActiveResultSets=True'";

   de.WWWings.Test.Modelle.EF6.WWWings6Entities context = new de.WWWings.Test.Modelle.EF6.WWWings6Entities(CS);

   //  de.WWWings.Test.Modelle.EF6.WWWings6Entities context = new de.WWWings.Test.Modelle.EF6.WWWings6Entities("name=WWWings6Entities");
   //  de.WWWings.Test.Modelle.EF6.WWWings6Entities context = new de.WWWings.Test.Modelle.EF6.WWWings6Entities("name=EigeneVerbindung");
   // EntityConnection ec = new EntityConnection("name=WWWings6Entities");
   // de.WWWings.Test.Modelle.EF6.WWWings6Entities modell = new de.WWWings.Test.Modelle.EF6.WWWings6Entities(ec);

   //var flug = (from f in context.Flug
   //            where f.Abflugort == "Berlin"
   //            select f).FirstOrDefault();

   //Console.WriteLine("Key: " + flug.EntityKey.EntityKeyValues[0].Value + " : " + flug.Abflugort);
  }

  public static void EF_Connection_VerbindungVorherAufbauen()
  {

   string CS =
@"metadata=res://*/Modelle.EF6.WWWings6.csdl|res://*/Modelle.EF6.WWWings6.ssdl|res://*/Modelle.EF6.WWWings6.msl;provider=System.Data.SqlClient;provider connection string='Data Source=.\sqlexpress;Initial Catalog=WWWings6;Integrated Security=True;MultipleActiveResultSets=True'";

   EntityConnection conn = new EntityConnection(CS);

   conn.Open();



   de.WWWings.Test.Modelle.EF6.WWWings6Entities context = new de.WWWings.Test.Modelle.EF6.WWWings6Entities(conn);


   var flug = (from f in context.Flug
               where f.Abflugort == "Berlin"
               select f).FirstOrDefault();

   Console.WriteLine("Key: " + flug.EntityKey.EntityKeyValues[0].Value + " : " + flug.Abflugort);


  }


  public static void EF_Connection_VerbindungTeilen()
  {
   string CS =
@"metadata=res://*/Modelle.EF6.WWWings6.csdl|res://*/Modelle.EF6.WWWings6.ssdl|res://*/Modelle.EF6.WWWings6.msl;provider=System.Data.SqlClient;provider connection string='Data Source=.\sqlexpress;Initial Catalog=WWWings6;Integrated Security=True;MultipleActiveResultSets=True'";

   de.WWWings.Test.Modelle.EF6.WWWings6Entities context = new de.WWWings.Test.Modelle.EF6.WWWings6Entities(CS);
   // Verbindung öffnen
   SqlConnection conn = (context.Connection as EntityConnection).StoreConnection as SqlConnection;
   conn.Open();
   // klassischer Befehl
   SqlCommand cmd = new SqlCommand("Delete from Protokoll where Zeit < '1/1/2008' ", conn);
   int count = cmd.ExecuteNonQuery();
   // EF-Befehl
   var flug = (from f in context.Flug
               where f.Abflugort == "Berlin"
               select f).FirstOrDefault();

   Console.WriteLine("FlugNr: " + flug.FlugNr);

   // Verbindung schliessen
   conn.Close();
  }

  public static void EF_WhereWithObject()
  {
   de.WWWings.Test.Modelle.EF4.WorldWideWings db = new de.WWWings.Test.Modelle.EF4.WorldWideWings();

   var flug = (from f in db.FL_Fluege
               where f.FL_FlugNr == 101
               select f).FirstOrDefault();

   // falsch:
   //var Buchungen = (from b in db.GF_GebuchteFluege
   //                 where b.FL_Fluege == flug
   //                 select b);

   var Buchungen = (from b in db.GF_GebuchteFluege
                    where b.FL_Fluege.FL_FlugNr == flug.FL_FlugNr
                    select b);

   Console.WriteLine(Buchungen.Count());

  }


  /// <summary>
  /// EF Serialisieren
  /// </summary>
  public static void EF_Serialisierung()
  {
   string pfad = @"c:\temp\FlugMengeEF.xml";
   de.WWWings.Test.Modelle.EF4.WorldWideWings db = new de.WWWings.Test.Modelle.EF4.WorldWideWings();

   var flug = (from f in db.FL_Fluege.Include("GF_GebuchteFluege.PS_Passagier.PE_Person")
               where f.FL_FlugNr == 101
               select f).FirstOrDefault();

   UniversalSerialisierer.Save(SerialTyp.DATACONTRACT, flug, pfad);

   Console.WriteLine("Gespeichert: " + pfad);
  }

  /// <summary>
  /// Demo zum Kontextwechsel eines Objekts
  /// </summary>
  public static void EF_Kontextwechsel()
  {
   de.WWWings.Test.Modelle.EF6.WWWings6Entities kontext1 = new de.WWWings.Test.Modelle.EF6.WWWings6Entities();
   var flug = kontext1.Flug.Where(f => f.FlugNr == 101).SingleOrDefault();

   de.WWWings.Test.Modelle.EF6.WWWings6Entities kontext2 = new de.WWWings.Test.Modelle.EF6.WWWings6Entities();
   var pilot = kontext2.Pilot.Where(p => p.PersonID == 150).SingleOrDefault();

   // das geht nicht: Kontextwechselproblem! --> 3 Lösungen, siehe unten!
   // flug.Pilot = pilot;

   // Lösung 1;
   pilot = kontext1.Pilot.Where(p => p.PersonID == pilot.PersonID).SingleOrDefault();
   flug.Pilot = pilot;

   // Lösung 2;
   //flug.Pilot_PersonID = pilot.PersonID;

   //// Lösung 3:
   //kontext2.Detach(pilot);
   //kontext1.Attach(pilot);
   //flug.Pilot = pilot;

   kontext1.SaveChanges();

  }


  /// <summary>
  /// Caching Demo
  /// </summary>
  public static void EF_Caching()
  {
   de.WWWings.Test.Modelle.EF6.WWWings6Entities db = new de.WWWings.Test.Modelle.EF6.WWWings6Entities();

   // Laden
   var Query = (from Flug in db.Flug
                where Flug.FlugNr < 110
                select Flug); // optional .ToList(); 

   Console.WriteLine("Anzahl: " + Query.Count());
   foreach (var f in Query)
   {
    Console.WriteLine(f.FlugNr + ": " + f.FreiePlaetze);
   }

   // Ändern im RAM
   Console.WriteLine("Ändere Flug 101...");
   var Flug101 = Query.Where(f => f.FlugNr == 101).FirstOrDefault();
   Console.WriteLine("Flug 101: " + Flug101.FreiePlaetze);
   Flug101.FreiePlaetze--;
   Console.WriteLine("Flug 101: " + Flug101.FreiePlaetze);

   // Gleiche Menge nochmal laden
   var Query2 = (from Flug in db.Flug
                 where Flug.FlugNr < 110
                 select Flug); // optional .ToList(); 

   Console.WriteLine("Anzahl: " + Query.Count());

   foreach (var f in Query2)
   {
    Console.WriteLine(f.FlugNr + ": " + f.FreiePlaetze);
   }

  }



  /// <summary>
  /// Defered Execution Demo
  /// </summary>
  public static void EF_DeferedExecution()
  {
   de.WWWings.Test.Modelle.EF6.WWWings6Entities db = new de.WWWings.Test.Modelle.EF6.WWWings6Entities();

   // Wird "verspätet" ausgeführt
   var Query = (from Flug in db.Flug
                where Flug.Abflugort == "Rom" && Flug.FlugNr < 110
                select Flug);

   Console.WriteLine(((ObjectQuery)Query).ToTraceString());

   // jetzt!
   Console.WriteLine("Anzahl: " + Query.Count());

   // jetzt!
   foreach (var f in Query)
   {
    Console.WriteLine(f.FlugNr + ": " + f.FreiePlaetze);
   }


   var Query2 = (from Flug in db.Flug
                 where Flug.Abflugort == "Rom" && Flug.FlugNr < 110
                 select Flug);

   Console.WriteLine(((ObjectQuery)Query).ToTraceString());

   //Console.WriteLine("Anzahl: " + Query.Count());

   foreach (var f in Query2)
   {
    Console.WriteLine(f.FlugNr + ": " + f.FreiePlaetze);
   }

   // Wird sofort ausgeführt
   var Flug110 = (from Flug in db.Flug
                  where Flug.FlugNr == 110
                  select Flug).FirstOrDefault();


   Console.WriteLine("Flug: " + Flug110.FlugNr);

   // Wird sofort ausgeführt
   var Anzahl = (from Flug in db.Flug
                 where Flug.Abflugort == "Rom" && Flug.FlugNr < 110
                 select Flug).Count();
   Console.WriteLine("Anzahl: " + Anzahl);


  }



  /// <summary>
  /// Einfaches Beispiel Projektion
  /// </summary>
  public static object EF_Projektion()
  {

   de.WWWings.Test.Modelle.EF4.WorldWideWings db = new de.WWWings.Test.Modelle.EF4.WorldWideWings();


   //de.WWWings.Test.DB.DatenbankDataContext db = new de.WWWings.Test.DB.DatenbankDataContext();
   string Ort = "Berlin";
   var Query1 = (from f in db.FL_Fluege
                 where f.FL_Abflugort == Ort
                 select new { f.FL_FreiePlaetze, f.FL_FlugNr });

   var Query2 = (from f in db.FL_Fluege
                 join g in db.GF_GebuchteFluege on f.FL_FlugNr equals g.GF_FL_FlugNr
                 where f.FL_Abflugort == Ort
                 select new { f.FL_FreiePlaetze, f.FL_FlugNr, g.GF_Buchungscode });


   var Query = (from Flug in db.FL_Fluege
                join Buchungen in db.GF_GebuchteFluege on Flug.FL_FlugNr equals Buchungen.GF_FL_FlugNr
                where Flug.FL_Abflugort == Ort && Flug.FL_FlugNr < 110
                select new { Flug, Buchungen });

   Console.WriteLine(((ObjectQuery)Query).ToTraceString());

   Console.WriteLine("Anzahl: " + Query.Count());
   foreach (var f in Query)
   {
    Console.WriteLine(f.Flug.FL_FlugNr + ": " + f.Flug.FL_FreiePlaetze);

    if (f.Flug.FL_FlugNr == 101) f.Flug.FL_FreiePlaetze -= 1;
    Console.WriteLine("FL_FreiePlaetze = " + f.Flug.FL_FreiePlaetze);

    if (f.Flug.FL_FlugNr == 101) f.Buchungen.GF_Preis += (decimal)30.00;
    Console.WriteLine("Preis = " + f.Buchungen.GF_Preis);

    //foreach (GF_GebuchteFluege g in f.g)
    //{

    // Console.WriteLine("            " + g.GF_Buchungscode + " / " + g.GF_PS_ID + " / " + g.GF_Preis);
    // g.GF_Preis += (decimal) 100.00;
    //}
   }

   db.SaveChanges();


   // Option: Flachklopfen
   //var Daten = (from d in Query select new { d.Flug.FL_FlugNr, d.Flug.FL_Abflugort, d.Flug.FL_Zielort, d.Buchungen.GF_Buchungscode, d.Buchungen.GF_Preis } );




   return Query;

   Console.ReadLine();

   // Konvertieren in Typ Fluege
   //List<FL_Fluege> Fluege2 = new List<FL_Fluege>();

   //foreach(var f in Fluege)
   //{
   // FL_Fluege f2 = new FL_Fluege() { FL_FlugNr = f.FL_FlugNr, FL_FreiePlaetze = f.FL_FreiePlaetze };
   // db.AttachTo("FL_Fluege", f2);

   // Fluege2.Add(f2);
   //}


   //IEnumerable<FL_Fluege> Fluege2 = Query.Convert<FL_Fluege>();


   //foreach (var f in Fluege2)
   //{
   // Console.WriteLine("---- Flug: " + f.FL_FlugNr);
   // Console.WriteLine("Freie Plätze vorher: " + f.FL_FreiePlaetze);
   // f.FL_FreiePlaetze--;
   // Console.WriteLine("Freie Plätze nachher: " + f.FL_FreiePlaetze);
   //}


   //db.SaveChanges();
   //db.Dispose();
  }


  /// <summary>
  /// Anwendung des von ESQL mit ObjectServuces
  /// </summary>
  public static void EF_ObjectServices_ESQL_Basis()
  {

   // Abfrage
   string ESQL = @"SELECT value f " +
"FROM WorldWideWings.FL_Fluege AS f " +
"WHERE f.FL_Abflugort = @Ort";

   // Kontext erzeugen
   de.WWWings.Test.Modelle.EF4.WorldWideWings db = new WorldWideWings();

   // Abfrage erstellen
   IEnumerable<de.WWWings.Test.Modelle.EF4.FL_Fluege> Fluege = db.CreateQuery<de.WWWings.Test.Modelle.EF4.FL_Fluege>(ESQL, new ObjectParameter("Ort", "Berlin"));

   Console.WriteLine(Fluege.Count());

  }

  /// <summary>
  /// Anwendung des von ESQL mit ObjectServuces
  /// </summary>
  public static void EF_ObjectServices_ESQL_Anonym()
  {

   // Abfrage
   string ESQL = @"SELECT  f.FL_AbflugOrt, f.Fl_zielort " +
   "FROM WorldWideWings.FL_Fluege AS f " +
   "WHERE f.FL_Abflugort = @Ort";

   // Kontext erzeugen
   de.WWWings.Test.Modelle.EF4.WorldWideWings db = new WorldWideWings();

   // Abfrage erstellen
   IEnumerable<DbDataRecord> Fluege = db.CreateQuery<DbDataRecord>(ESQL, new ObjectParameter("Ort", "Berlin"));

   // Ausgabe
   Console.WriteLine(Fluege.Count());
   foreach (var f in Fluege)
   {
    Console.WriteLine(f["FL_AbflugOrt"].ToString() + " -> " + f["FL_ZielOrt"].ToString());


   }
  }


  /// <summary>
  /// Anwendung des von ESQL mit ObjectServuces
  /// </summary>
  public static void EF_ObjectServices_ESQL()
  {
   // ESQL-Befehl (*)
   string ESQL1 = @"SELECT value f " +
  "FROM WorldWideWings.FL_Fluege AS f " +
  "WHERE f.FL_Abflugort = @Ort";

   //// ESQL-Befehl - Projektion == Liefert MaterializedDataRecord
   string ESQL2 = @"SELECT  f.FL_AbflugOrt, f.Fl_zielort " +
   "FROM WorldWideWings.FL_Fluege AS f " +
   "WHERE f.FL_Abflugort = @Ort";

   // ESQL-Befehl
   // SELECT Flug,  Buchung FROM WorldWideWings.FL_Fluege AS Flug JOIN WorldWideWings.GF_Gebuchtefluege as Buchung on Flug.FL_FlugNr = Buchung.GF_FL_FlugNr WHERE Flug.FL_Abflugort = "Rom"

   string ESQL3 = @"SELECT Flug,  Buchung " +
   "FROM WorldWideWings.FL_Fluege AS Flug " +
   "JOIN WorldWideWings.GF_Gebuchtefluege as Buchung on Flug.FL_FlugNr = Buchung.GF_FL_FlugNr " +
   "WHERE Flug.FL_Abflugort = @Ort";

   // Kontext erzeugen
   ObjectContext db = new ObjectContext(CS);

   // Ausführen
   //var Fluege = db.CreateQuery<DbDataRecord>(ESQL3, new ObjectParameter("Ort", "Berlin"));



   //FROM C AS c [INNER] JOIN D AS d ON e 



   // Oder
   //de.WWWings.Test.Modelle.EF4.WorldWideWings db = new de.WWWings.Test.Modelle.EF4.WorldWideWings(CS);

   // Abfrageobjekt erstellen
   //ObjectQuery<de.WWWings.Test.Modelle.EF4.FL_Fluege> Fluege = db.CreateQuery<de.WWWings.Test.Modelle.EF4.FL_Fluege>(ESQL2, new ObjectParameter("Ort", "Rom"));

   var Fluege = db.CreateQuery<DbDataRecord>(ESQL3, new ObjectParameter("Ort", "Berlin"));

   //ObjectQuery<de.WWWings.Test.Modelle.EF4.FL_Fluege> Fluege = db.CreateQuery<de.WWWings.Test.Modelle.EF4.FL_Fluege>(ESQL2, new ObjectParameter("Ort", "Rom"));

   // Ausführen & Ausgabe
   foreach (var f in Fluege)
   {

    FL_Fluege Flug = f["Flug"] as FL_Fluege;
    GF_GebuchteFluege Buchung = f["Buchung"] as GF_GebuchteFluege;
    Console.WriteLine(Flug.FL_FlugNr + " : " + Buchung.GF_Buchungscode);
    //Console.WriteLine("Flug Nr {0} von {1} nach {2} hat {3} freie Plätze!", f.FL_FlugNr, f.FL_Abflugort, f.FL_Zielort, f.FL_FreiePlaetze);

    if (Flug.FL_FlugNr == 101) Flug.FL_FreiePlaetze -= 1;
    Console.WriteLine("FL_FreiePlaetze = " + Flug.FL_FreiePlaetze);

    if (Flug.FL_FlugNr == 101) Buchung.GF_Preis += (decimal)30.00;
    Console.WriteLine("Preis = " + Buchung.GF_Preis);

   }

   db.SaveChanges();
   // Kontext vernichten
   db.Dispose();
  }

  /// <summary>
  /// Dynamische Abfragen
  /// </summary>
  public static void EF_Dyn_Query()
  {
   de.WWWings.Test.Modelle.EF4.WorldWideWings db = new de.WWWings.Test.Modelle.EF4.WorldWideWings();


   // LINQ-Befehl in Abfragesyntax
   var Q1 = from f in db.FL_Fluege where f.FL_Abflugort == "Rom" select f;

   // LINQ-Befehl in Methodensyntax
   var Q2 = (from f in db.FL_Fluege select f).Where(f => f.FL_Abflugort == "Rom");

   // Zusammenbauen von LINQ-Befehlen mit der LINQ-Methodensyntax
   IEnumerable<FL_Fluege> Q3 = (from f in db.FL_Fluege select f).Where(f => f.FL_Abflugort == "Rom");
   Boolean b = false;
   if (b)
   {
    Q3 = Q3.Where(f => f.FL_Zielort == "Berlin");
   }

   //ObjectQuery<FL_Fluege> Ergebnis =
   //db.FL_Fluege.Where(f => f.FL_Abflugort == "Rom");

   // Query Builder Methods mit anonymen Typ
   ObjectQuery<DbDataRecord> Q5 =
db.FL_Fluege.Where("it.FL_Abflugort = 'Rom'").Select("it.FL_AbflugOrt,it.FL_Zielort");

   // Query Builder Methods über zwei Tabellen mit 1:n-Beziehung
   ObjectQuery<FL_Fluege> Q4 =
db.FL_Fluege.Where("it.FL_FreiePlaetze > 0 and anyelement(it.GF_GebuchteFluege).GF_Preis > 100");

   // Query Builder Methods über zwei Tabellen mit 1:1-Beziehung
   ObjectQuery<GF_GebuchteFluege> Q6 =
db.GF_GebuchteFluege.Where("it.GF_Preis < 100 and it.FL_Fluege.FL_Abflugort = 'Berlin'");

   // Query Builder Methods über frei Tabellen mit 1:n- und 1:1-Beziehung
   ObjectQuery<FL_Fluege> Q7 =
db.FL_Fluege.Where("it.FL_FreiePlaetze > 0 and set(it.GF_GebuchteFluege).GF_Preis > 100 and anyelement(it.GF_GebuchteFluege).PS_Passagier.PS_ID < 100");

   // äquivalenter LINQ-Befehl zum Prüfen, welchen ESQL-Befehl das EF erzeugt
   var Q8 = from f in db.FL_Fluege where f.FL_FreiePlaetze > 0 && f.GF_GebuchteFluege.All(g => g.GF_Preis > 100) && f.GF_GebuchteFluege.Any(g => g.PS_Passagier.PS_ID < 100) select new { f.FL_FlugNr, f.GF_GebuchteFluege };

   Console.WriteLine(((ObjectQuery)Q8).ToTraceString());



   foreach (var f in Q8)
   {
    Console.WriteLine("Flug Nr {0}!", f.FL_FlugNr);
   }


   // ESQL

   //foreach (FL_Fluege f in Q8)
   //{
   // Console.WriteLine("Flug Nr {0} von {1} nach {2} hat {3} freie Plätze!", f.FL_FlugNr, f.FL_Abflugort, f.FL_Zielort, f.FL_FreiePlaetze);
   // Console.WriteLine("ALT: " + f.FL_FlugNr + " = " + f.FL_FreiePlaetze);
   // f.FL_FreiePlaetze--;
   // Console.WriteLine("NEU: " + f.FL_FlugNr + " = " + f.FL_FreiePlaetze);
   //}

   db.SaveChanges();
   db.Dispose();
  }


  /// <summary>
  /// Beispiel für den Einsatz von Expression Trees zur Modifikation einer bestehenden LINQ-to-Entities-Abfrage
  /// </summary>
  public static void EF_Dyn_Query_ExpressionTree_Einfach()
  {

   // EF Modell
   de.WWWings.Test.Modelle.EF4.WorldWideWings db = new de.WWWings.Test.Modelle.EF4.WorldWideWings();

   // Basismenge
   var Q_Vorlaeufig = from flug in db.FL_Fluege where flug.FL_Plaetze > 100 select flug;

   // Zum Test
   Console.WriteLine("VORHER: " + ((ObjectQuery)Q_Vorlaeufig).ToTraceString());

   // Laufvariable definieren
   ParameterExpression f = Expression.Parameter(typeof(FL_Fluege), "f");

   // Bedingung 1 festlegen
   Expression left = Expression.Property(f, "FL_Zielort");
   Expression right = Expression.Constant("Rom");
   Expression Bed1 = Expression.Equal(left, right);

   // Bedingung 2 festlegen
   left = Expression.Property(f, "FL_FlugNr");
   right = Expression.Constant(200, typeof(int));
   Expression Bed2 = Expression.LessThan(left, right);

   // Menge aller Bedingungen
   Expression predicateBody = Expression.And(Bed1, Bed2);

   // Expression Tree aus beiden Bedingungen
   MethodCallExpression whereCallExpression = Expression.Call(
       typeof(Queryable),
       "Where",
       new Type[] { Q_Vorlaeufig.ElementType },
       Q_Vorlaeufig.Expression,
       Expression.Lambda<Func<FL_Fluege, bool>>(predicateBody, new ParameterExpression[] { f }));

   // Umwandeln des Expression Tree in eine Abfrage
   var Q_Endgueltig = Q_Vorlaeufig.Provider.CreateQuery<FL_Fluege>(whereCallExpression);

   // Zum Test
   Console.WriteLine("NACHHER: " + ((ObjectQuery)Q_Endgueltig).ToTraceString());


   foreach (var Flug in Q_Endgueltig)
   {
    Console.WriteLine("Flug Nr {0} von {1} nach {2}!", Flug.FL_FlugNr, Flug.FL_Abflugort, Flug.FL_Zielort);
   }


   db.SaveChanges();
   db.Dispose();
  }



  /// <summary>
  /// Beispiel für den Einsatz von Expression Trees zur Modifikation einer bestehenden LINQ-to-Entities-Abfrage
  /// </summary>
  public static void EF_Dyn_Query_ExpressionTree_Join()
  {

   // EF Modell
   de.WWWings.Test.Modelle.EF4.WorldWideWings db = new de.WWWings.Test.Modelle.EF4.WorldWideWings();

   //// Basismenge /Statischer Join/
   var Q_Ziel = from flug in db.FL_Fluege
                join buchung in db.GF_GebuchteFluege
                on flug.FL_FlugNr equals buchung.GF_FL_FlugNr
                where flug.FL_Abflugort == "Berlin" && flug.FL_FlugNr < 200
                select flug;

   Console.WriteLine("ZIEL: " + ((ObjectQuery)Q_Ziel).ToTraceString());

   var Q_Ziel_Alternativ = from x in (from flug in db.FL_Fluege select flug).Join(db.GF_GebuchteFluege, fl => fl.FL_FlugNr, b => b.GF_FL_FlugNr, (fl, b) => fl) where x.FL_Abflugort == "Berlin" && x.FL_FlugNr < 200 select x;

   Console.WriteLine("ZIEL ALTERNATIV: " + ((ObjectQuery)Q_Ziel_Alternativ).ToTraceString());


   var Q1 = from flug in db.FL_Fluege
            select flug;

   // Zum Test
   Console.WriteLine("Ausgangszustand: " + ((ObjectQuery)Q1).ToTraceString());

   // Idee von http://www.eggheadcafe.com/software/aspnet/31733266/linq-join-using-expressio.aspx

   // OuterKeySelector
   ParameterExpression TabOuter = Expression.Parameter(typeof(FL_Fluege), "flug");
   Expression TabOuterKey = MemberExpression.Property(TabOuter, "FL_FlugNr");
   var TabOuterKeys = new ParameterExpression[] { TabOuter };
   Expression<Func<FL_Fluege, int>> OuterKeySelector =
    Expression.Lambda<Func<FL_Fluege, int>>(TabOuterKey, TabOuterKeys);

   // InnerKeySelector
   ParameterExpression TabInner = Expression.Parameter(typeof(Object), "buchung");
   Expression TabInner2 = MemberExpression.Convert(TabInner,
   System.Type.GetType("de.WWWings.Test.Modelle.EF4.GF_GebuchteFluege"));
   Expression TabInnerKey = MemberExpression.Property(TabInner2, "GF_FL_FlugNr");
   var TabInnerKeys = new ParameterExpression[] { TabInner };
   Expression<Func<object, int>> InnerKeySelector =
    Expression.Lambda<Func<object, int>>(TabInnerKey, TabInnerKeys);

   //ParameterExpression TabInner = Expression.Parameter(System.Type.GetType("de.WWWings.Test.Modelle.EF4.GF_GebuchteFluege"), "buchung");
   //Expression TabInnerKey = MemberExpression.Property(TabInner, "GF_FL_FlugNr");
   //var TabInnerKeys = new ParameterExpression[] { TabInner };
   //Expression<Func<GF_GebuchteFluege, int>> InnerKeySelector =
   //Expression.Lambda<Func<GF_GebuchteFluege, int>>(TabInnerKey, TabInnerKeys);

   ParameterExpression ap1 = Expression.Parameter(typeof(FL_Fluege), "flug");
   ParameterExpression ap2 = Expression.Parameter(System.Type.GetType("de.WWWings.Test.Modelle.EF4.GF_GebuchteFluege"), "buchung");
   Expression ap3 = ap1;
   var args3 = new ParameterExpression[] { ap1, ap2 };

   Expression<Func<FL_Fluege, GF_GebuchteFluege, FL_Fluege>>
   ResultSelector = Expression.Lambda<Func<FL_Fluege, GF_GebuchteFluege, FL_Fluege>>(ap3, args3);

   // Soweit ganz gut, aber in den generischen Klassen (Func) erscheint immer noch hard-codiert der Typname der zweiten Tabelle (hier: GF_GebuchteFluege). Das müsste eigentlich dynamisch sein. Leider geht GetType() nicht, weil der Typ zur Laufzeit feststehen muss. Wenn man den Typ überall auf "Object" setzt, dann funktioniert Join nicht mehr.
   //var Q2 = Q1.AsQueryable<FL_Fluege>().Join<FL_Fluege, GF_GebuchteFluege, int, FL_Fluege>(db.GF_GebuchteFluege, OuterKeySelector, InnerKeySelector, ResultSelector);


   // hier ein Lösungsansatz, wenn alle Typisierungen bei InnerKeySelector und ResultSelector auf Object sind. Leider verweigert Join dann die Arbeit
   //List<Object> Tabelle2 = new List<object>();
   //foreach (GF_GebuchteFluege g in db.GF_GebuchteFluege)
   //{
   // Tabelle2.Add(g);
   //}


   //var Q2 = db.FL_Fluege.Join<FL_Fluege, object, int, FL_Fluege>(Tabelle2, OuterKeySelector, InnerKeySelector, ResultSelector);
   //var xx = Q2.ToList();
   var Q2 = Q1;

   //var query = people.AsQueryable().Join(pets,
   //                 person => person,
   //                 pet => pet.Owner,
   //                 (person, pet) =>
   //                     new { OwnerName = person.Name, Pet = pet.Name });
   //Expression Menge = db.GF_GebuchteFluege.AsQueryable().Expression;
   //MethodCallExpression joinCallExpression = Expression.Call(
   //    typeof(Queryable),
   //    "Join", new Type[] { Q1.ElementType, typeof(object), typeof(System.Int32),  typeof(FL_Fluege) }, 
   //         Q1.Expression, Menge, OuterKeySelector, InnerKeySelector, ResultSelector);

   // Umwandeln des Expression Tree in eine Abfrage
   //var Q2 = Q1.Provider.CreateQuery<FL_Fluege>(joinCallExpression);

   // Zum Test
   //Console.WriteLine("Nach Join: " + ((ObjectQuery)Q2).ToTraceString());


   // Laufvariable definieren
   ParameterExpression f = Expression.Parameter(typeof(FL_Fluege), "f");

   // Bedingung 1 festlegen
   Expression left = Expression.Property(f, "FL_Abflugort");
   Expression right = Expression.Constant("Berlin");
   Expression Bed1 = Expression.Equal(left, right);

   // Bedingung 2 festlegen
   left = Expression.Property(f, "FL_FlugNr");
   right = Expression.Constant(200, typeof(int));
   Expression Bed2 = Expression.LessThan(left, right);

   // Menge aller Bedingungen
   Expression predicateBody = Expression.And(Bed1, Bed2);

   // Expression Tree aus beiden Bedingungen
   MethodCallExpression whereCallExpression = Expression.Call(
       typeof(Queryable),
       "Where",
       new Type[] { Q2.ElementType },
       Q2.Expression,
       Expression.Lambda<Func<FL_Fluege, bool>>(predicateBody, new ParameterExpression[] { f }));

   // Umwandeln des Expression Tree in eine Abfrage
   var Q3 = Q2.Provider.CreateQuery<FL_Fluege>(whereCallExpression);

   // Zum Test
   Console.WriteLine("Nach Where: " + ((ObjectQuery)Q3).ToTraceString());


   foreach (var Flug in Q3)
   {
    Console.WriteLine("Flug Nr {0} von {1} nach {2}!", Flug.FL_FlugNr, Flug.FL_Abflugort, Flug.FL_Zielort);
   }


   db.SaveChanges();
   db.Dispose();
  }

  /// <summary>
  /// Beispiel für den Einsatz von Expression Trees zur Modifikation 
  /// einer bestehenden LINQ-to-Entities-Abfrage
  /// am Beispiel einer WHERE-Bedingung mit einer variablen Anzahl von Bedingungen
  /// Hintergrund: Ein Benutzer hat auf dem Bildschirm eine variable Anzahl von Filtern
  /// Annahme, um das Beispiel prägnant zu halten: Es wird immer auf Gleichzeit geprüft
  /// </summary>
  public static void EF_Dyn_Query_ExpressionTree_Variabel()
  {

   // Eingabedaten
   Type Typ = Type.GetType("FL_Fluege");
   var Filter = new SortedDictionary<string, object>() { { "FL_Abflugort", "Rom" }, { "FL_Zielort", "Berlin" }, { "FL_NichtRaucherFlug", true } };

   // EF Modell
   de.WWWings.Test.Modelle.EF4.WorldWideWings db = new de.WWWings.Test.Modelle.EF4.WorldWideWings();

   // Basismenge
   var Q_Vorlaeufig = from flug in db.FL_Fluege select flug;

   // Zum Test
   Console.WriteLine("VORHER: " + ((ObjectQuery)Q_Vorlaeufig).ToTraceString());
   // Laufvariable definieren
   ParameterExpression f = Expression.Parameter(typeof(FL_Fluege), "f");

   Expression GesamtBedingung = null;
   foreach (var filter in Filter)
   {
    // Bedingung festlegen
    Expression left = Expression.Property(f, filter.Key);
    Expression right = Expression.Constant(filter.Value);
    Expression Bed = Expression.Equal(left, right);
    // Verknpüfen mit den bisherigen Bedingungen
    if (GesamtBedingung == null) GesamtBedingung = Bed;
    else GesamtBedingung = Expression.And(GesamtBedingung, Bed); // hier: "UND"
   }

   // Expression Tree aus allen Bedingungen
   MethodCallExpression whereCallExpression = Expression.Call(
       typeof(Queryable),
       "Where",
       new Type[] { Q_Vorlaeufig.ElementType },
       Q_Vorlaeufig.Expression,
       Expression.Lambda<Func<FL_Fluege, bool>>(GesamtBedingung, new ParameterExpression[] { f }));

   // Umwandeln des Expression Tree in eine Abfrage
   var Q_Endgueltig = Q_Vorlaeufig.Provider.CreateQuery<FL_Fluege>(whereCallExpression);

   // Zum Test
   Console.WriteLine("NACHHER: " + ((ObjectQuery)Q_Endgueltig).ToTraceString());

   // Ausgabe
   foreach (var Flug in Q_Endgueltig)
   {
    Console.WriteLine("Flug Nr {0} von {1} nach {2}!", Flug.FL_FlugNr, Flug.FL_Abflugort, Flug.FL_Zielort);
   }

   db.SaveChanges();
   db.Dispose();
  }



  // --------------------------------------------

  /// <summary>
  /// Einfaches Beispiel
  /// </summary>
  public static void Demo_for_Screenshot()
  {
   de.WWWings.Test.Modelle.EF4.WorldWideWings db = new de.WWWings.Test.Modelle.EF4.WorldWideWings();

   string s = "Geben Sie alle Flüge aus, die weniger als 100 freie Plätze haben. Sortieren Sie die Liste absteigend nach Platzanzahl.";
   Util.HeadLine(s);
   var Ergebnis =
    (from n in db.FL_Fluege
     where n.FL_FreiePlaetze < 100
     orderby n.FL_FreiePlaetze descending
     select n);

   db.Dispose();
  }

  /// <summary>
  /// Einfaches Beispiel Update
  /// </summary>
  public static void Demo_NewFactory()
  {

   var flug = Modelle.EF6.Flug.CreateFlug(80, "Essen", "Rom", new DateTime(2010, 10, 10), true, 250);


  }


  /// <summary>
  /// Einfaches Beispiel Update
  /// </summary>
  public static void Demo_Update()
  {
   de.WWWings.Test.Modelle.EF4.WorldWideWings db = new de.WWWings.Test.Modelle.EF4.WorldWideWings();

   string s = "Geben Sie alle Flüge aus, die weniger als 100 freie Plätze haben. Sortieren Sie die Liste absteigend nach Platzanzahl.";
   Util.HeadLine(s);
   var Ergebnis =
    (from n in db.FL_Fluege
     where n.FL_FreiePlaetze < 100
     orderby n.FL_FreiePlaetze descending
     select n);

   foreach (FL_Fluege f in Ergebnis)
   {
    Console.WriteLine("ALT: " + f.FL_FlugNr + " = " + f.FL_FreiePlaetze);
    f.FL_FreiePlaetze--;
    Console.WriteLine("NEU: " + f.FL_FlugNr + " = " + f.FL_FreiePlaetze);
   }

   db.SaveChanges();
   db.Dispose();
  }


  /// <summary>
  /// Einfaches Beispiel Projektion mit Update
  /// Geht so nicht: "The entity or complex type 'WorldWideWingsModel.FL_Fluege' cannot be constructed in a LINQ to Entities query."
  /// </summary>
  public static void Demo_Projektion_Update()
  {
   de.WWWings.Test.Modelle.EF4.WorldWideWings db = new de.WWWings.Test.Modelle.EF4.WorldWideWings();

   var Ergebnis =
    (from n in db.FL_Fluege
     where n.FL_FreiePlaetze < 0
     orderby n.FL_FreiePlaetze descending
     select new FL_Fluege() { FL_FlugNr = n.FL_FlugNr, FL_FreiePlaetze = n.FL_FreiePlaetze });

   foreach (FL_Fluege f in Ergebnis)
   {
    Console.WriteLine("ALT: " + f.FL_FlugNr + " = " + f.FL_FreiePlaetze);
    f.FL_FreiePlaetze++;
    Console.WriteLine("NEU: " + f.FL_FlugNr + " = " + f.FL_FreiePlaetze);
   }

   Console.WriteLine("Gespeicherte Änderungen: " + db.SaveChanges());
   db.Dispose();
  }


  /// <summary>
  /// EF: Projektion mit Update 
  /// </summary>
  public static void Demo_Projektion_Update2_Person()
  {
   de.WWWings.Test.Modelle.EF4.WorldWideWings db =
    new de.WWWings.Test.Modelle.EF4.WorldWideWings();

   // Objekte in anonymen Typ holen
   var Ergebnis =
    (from n in db.PE_Person
     where n.PE_Land == "HO"
     select new { PE_PersonalausweisNr = n.PE_PersonalausweisNr, PE_Vorname = n.PE_Vorname, PE_Name = n.PE_Name, PE_Land = n.PE_Land });

   // Umkopieren in konkreten Typ
   var Ergebnis2 = from n in Ergebnis.AsEnumerable()
                   select new PE_Person() { PE_PersonalausweisNr = n.PE_PersonalausweisNr, PE_Vorname = n.PE_Vorname, PE_Name = n.PE_Name, PE_Land = n.PE_Land };

   foreach (PE_Person p in Ergebnis2)
   {
    // Anfügen an Kontext
    db.AttachTo("PE_Person", p);
    Console.WriteLine("ALT: " + p.PE_Vorname + " " + p.PE_Name + " = " + p.PE_Land);
    p.PE_Land = "NL";
    Console.WriteLine("NEU: " + p.PE_Vorname + " " + p.PE_Name + " = " + p.PE_Land);
   }

   Console.WriteLine("Gespeicherte Änderungen: " + db.SaveChanges());
   db.Dispose();
  }

  /// <summary>
  /// EF: Projektion mit Update
  /// </summary>
  public static void Demo_Projektion_Update2_Flug()
  {
   de.WWWings.Test.Modelle.EF4.WorldWideWings db =
    new de.WWWings.Test.Modelle.EF4.WorldWideWings();

   // Objekte in anonymen Typ holen
   var Ergebnis =
    (from n in db.FL_Fluege
     where n.FL_FreiePlaetze < 5
     select new { FL_FlugNr = n.FL_FlugNr, FL_FreiePlaetze = n.FL_FreiePlaetze });

   // Umkopieren in konkreten Typ
   var Ergebnis2 = from n in Ergebnis.AsEnumerable()
                   select new FL_Fluege() { FL_FlugNr = n.FL_FlugNr, FL_FreiePlaetze = n.FL_FreiePlaetze };

   foreach (FL_Fluege f in Ergebnis2)
   {
    // Anfügen an Kontext
    db.FL_Fluege.Attach(f);
    Console.WriteLine("ALT: " + f.FL_FlugNr + " = " + f.FL_FreiePlaetze);
    f.FL_FreiePlaetze++;
    Console.WriteLine("NEU: " + f.FL_FlugNr + " = " + f.FL_FreiePlaetze);
   }

   Console.WriteLine("Gespeicherte Änderungen: " + db.SaveChanges());
   db.Dispose();
  }



  /// <summary>
  /// Automatische Assoziation durch Relationship Fix Up
  /// </summary>
  public static void Demo_LazyLoadFixUp()
  {
   de.WWWings.Test.Modelle.EF4.WorldWideWings db =
    new de.WWWings.Test.Modelle.EF4.WorldWideWings();
   // Objekt normal laden
   de.WWWings.Test.Modelle.EF4.FL_Fluege flug =
    (from f in db.FL_Fluege where f.FL_FlugNr == 110 select f).FirstOrDefault();
   // Unterobjekt nicht verfügbar
   if (flug.PI_Pilot == null) Console.WriteLine("Pilot: null");
   // Lade alle Piloten ==> Automatisches Beziehungserstellung
   var Piloten = db.PI_Pilot.ToList(); // Lade alle Piloten
   // Unterobjekt jetzt verfügbar
   Console.Write("Pilot: " + flug.PI_Pilot.PI_MI_MitarbeiterNr);
   db.Dispose();
  }

  /// <summary>
  /// Kaskadierendes Löschen - geht nur, wenn in DB definiert.
  /// Kaskadierendes Löschen  im Modell geht nicht bei N:M!
  /// </summary>
  public static void Demo_KaskadierendesLöschenNM()
  {
   de.WWWings.Test.Modelle.EF6.WWWings6Entities ctx =
    new de.WWWings.Test.Modelle.EF6.WWWings6Entities();
   ctx.ContextOptions.LazyLoadingEnabled = true;

   var flug = ctx.Flug.Where(x => x.FlugNr == 173).SingleOrDefault();

   foreach (var p in flug.Passagier)
   {
    Console.WriteLine(p.PersonID + ": " + p.Person.Name);
   }

   Console.WriteLine("Delete des Flugs");

   ctx.DeleteObject(flug);
   ctx.SaveChanges();


   ctx.Dispose();
  }


  /// <summary>
  /// Kaskadierendes Löschen über Modell bei 1:0/1
  /// </summary>
  public static void Demo_KaskadierendesLöschen1_01()
  {

   int ID = 1000;

   de.WWWings.Test.Modelle.EF6.WWWings6Entities ctx1 =
 new de.WWWings.Test.Modelle.EF6.WWWings6Entities();


   // ---------- Vorbereiten: Objekte anlegen, wenn nicht da!
   if (ctx1.Person.Where(x => x.PersonID == ID).SingleOrDefault() == null)
   {
    var pneu = new de.WWWings.Test.Modelle.EF6.Person() { PersonID = ID, Vorname = "Vorname", Name = "Nachname" };
    ctx1.Person.AddObject(pneu);
    ctx1.SaveChanges();
    Console.WriteLine("Person angelegt!");
   }

   if (ctx1.Passagier.Where(x => x.PersonID == ID).SingleOrDefault() == null)
   {
    var pneu = new de.WWWings.Test.Modelle.EF6.Passagier() { PersonID = ID };
    ctx1.Passagier.AddObject(pneu);
    ctx1.SaveChanges();
    Console.WriteLine("Passagier angelegt!");
   }


   // -------------- Del ausführen
   de.WWWings.Test.Modelle.EF6.WWWings6Entities ctx2 =
new de.WWWings.Test.Modelle.EF6.WWWings6Entities();
   ctx2.ContextOptions.LazyLoadingEnabled = true;

   var pas = ctx2.Passagier.Include("Person").Where(x => x.PersonID == ID).SingleOrDefault();

   Console.WriteLine(pas.Person.Name);

   Console.WriteLine("Delete des Passagiers (mit Person!)");

   ctx2.DeleteObject(pas);
   ctx2.SaveChanges();

   // -------------- Prüfen
   de.WWWings.Test.Modelle.EF6.WWWings6Entities ctx3 =
 new de.WWWings.Test.Modelle.EF6.WWWings6Entities();

   var passagier = ctx3.Passagier.Include("Person").Where(x => x.PersonID == ID).SingleOrDefault();
   Console.WriteLine("Passagier-Eintrag vorhanden? " + (passagier!=null ));

   var person = ctx3.Person.Where(x => x.PersonID == ID).SingleOrDefault();
   Console.WriteLine("Person-Eintrag vorhanden? " + (person != null));


   ctx1.Dispose();
   ctx2.Dispose();
   ctx3.Dispose();
  }


  /// <summary>
  /// Kaskadierendes Löschen über Modell bei 1:N
  /// </summary>
  public static void Demo_KaskadierendesLöschen()
  {

   int ID = 1000;
   int FlugNr = 999999;

   de.WWWings.Test.Modelle.EF6.WWWings6Entities ctx1 =
 new de.WWWings.Test.Modelle.EF6.WWWings6Entities();


   // ---------- Vorbereiten: Objekte anlegen, wenn nicht da!
   de.WWWings.Test.Modelle.EF6.Flug fneu = ctx1.Flug.Where(x => x.FlugNr == FlugNr).SingleOrDefault();
   if (fneu == null)
   {
    fneu = de.WWWings.Test.Modelle.EF6.Flug.CreateFlug(FlugNr, "x", "y", DateTime.Now, true, 0);
    ctx1.Flug.AddObject(fneu);
    ctx1.SaveChanges();
    Console.WriteLine("Flug angelegt!");
   }


   if (ctx1.Person.Where(x => x.PersonID == ID).SingleOrDefault() == null)
   {
    var pneu = new de.WWWings.Test.Modelle.EF6.Person() { PersonID = ID, Vorname = "Vorname", Name = "Nachname" };
    ctx1.Person.AddObject(pneu);
    ctx1.SaveChanges();
    Console.WriteLine("Person angelegt!");
   }

   if (ctx1.Mitarbeiter.Where(x => x.PersonID == ID).SingleOrDefault() == null)
   {
    var pneu = new de.WWWings.Test.Modelle.EF6.Mitarbeiter() { PersonID = ID };
    ctx1.Mitarbeiter.AddObject(pneu);
    ctx1.SaveChanges();
    Console.WriteLine("Mitarbeiter angelegt!");
   }


   if (ctx1.Pilot.Where(x => x.PersonID == ID).SingleOrDefault() == null)
   {
    var pneu = new de.WWWings.Test.Modelle.EF6.Pilot() { PersonID = ID };
    ctx1.Pilot.AddObject(pneu);

    pneu.Flug.Add(fneu);
    ctx1.SaveChanges();

    Console.WriteLine("Pilot mit Flug angelegt!");
   }




   // -------------- Del ausführen
   de.WWWings.Test.Modelle.EF6.WWWings6Entities ctx2 =
new de.WWWings.Test.Modelle.EF6.WWWings6Entities();
   ctx2.ContextOptions.LazyLoadingEnabled = true;

   var pilot = ctx2.Pilot.Include("Flug").Where(x => x.PersonID == ID).SingleOrDefault(); // wenn Include("Flug") vergessen, damit Fehler, weilt nicht geladen, damit kein Cascading Delete() durch Modell

   Console.WriteLine(pilot.Mitarbeiter.Person.Name + ": Flüge = " + pilot.Flug.Count);
   Console.WriteLine("Delete des Pilot (mit allen seinen Flügen!)");
   ctx2.DeleteObject(pilot);
   ctx2.SaveChanges();

   // -------------- Prüfen
   de.WWWings.Test.Modelle.EF6.WWWings6Entities ctx3 =
 new de.WWWings.Test.Modelle.EF6.WWWings6Entities();

   var Pilot = ctx3.Pilot.Where(x => x.PersonID == ID).SingleOrDefault();
   Console.WriteLine("Pilot-Eintrag vorhanden? " + (Pilot != null));

   var Flug = ctx3.Flug.Where(x => x.FlugNr == FlugNr).SingleOrDefault();
   Console.WriteLine("Flug-Eintrag vorhanden? " + (Flug != null));


   ctx1.Dispose();
   ctx2.Dispose();
   ctx3.Dispose();
  }

  /// <summary>
  /// Bedingtes Lazy Loading durch Relationship Fix Up
  /// </summary>
  public static void Demo_BedingtesEagerLoading()
  {
   de.WWWings.Test.Modelle.EF6.WWWings6Entities ctx =
    new de.WWWings.Test.Modelle.EF6.WWWings6Entities();

   // Erzeuge anonymes Objekt
   var q =
   from pilot in ctx.Pilot.Include("Mitarbeiter.Person")
   where pilot.Mitarbeiter.Person.Name.StartsWith("M")
   select new
   {
    pilot,
    flug = from f in pilot.Flug
           where f.Abflugort == "Berlin"
           select f
   };

   // Fluge aus anonymen Typ auspacken
   List<de.WWWings.Test.Modelle.EF6.Pilot> piloten = q.AsEnumerable().Select(p => p.pilot).ToList();

   foreach (var p in piloten)
   {
    Console.WriteLine(p.PersonID);
    foreach (var f in p.Flug)
    {
     Console.WriteLine("  " + f.FlugNr + ": " + f.Abflugort + "->" + f.Zielort);
    }
   }
   ctx.Dispose();
  }


  /// <summary>
  /// Bedingtes Lazy Loading durch Relationship Fix Up
  /// Variante 2 mit zweiter Query
  /// </summary>
  public static void Demo_BedingtesEagerLoading_Variante2()
  {
   de.WWWings.Test.Modelle.EF6.WWWings6Entities ctx =
    new de.WWWings.Test.Modelle.EF6.WWWings6Entities();

 // Piloten laden
   var piloten =
   from pilot in ctx.Pilot
   where pilot.Mitarbeiter.Person.Name.StartsWith("M")
   select pilot;

   // Gewünschte Flüge laden
     var fluege =
   from flug in ctx.Flug
   where flug.Abflugort == "Berlin" && flug.Pilot.Mitarbeiter.Person.Name.StartsWith("M")
   select flug;


   foreach (var p in piloten)
   {
    Console.WriteLine(p.PersonID);
    foreach (var f in p.Flug)
    {
     Console.WriteLine("  " + f.FlugNr + ": " + f.Abflugort + "->" + f.Zielort);
    }
   }
   ctx.Dispose();
  }


  /// <summary>
  /// Verwendung einer Stub Entity für eine Assoziation
  /// Achtung: Geht nur, wenn wirklich ein anderer Pilot zugewiesen wird!
  /// </summary>
  public static void Demo_Assozation_withStub()
  {
   de.WWWings.Test.Modelle.EF4.WorldWideWings db =
    new de.WWWings.Test.Modelle.EF4.WorldWideWings();

   // Objekt normal laden
   de.WWWings.Test.Modelle.EF4.FL_Fluege flug =
    (from f in db.FL_Fluege.Include("PI_Pilot") where f.FL_FlugNr == 110 select f).FirstOrDefault();
   Console.WriteLine("Pilot vorher: " + flug.PI_Pilot.PI_MI_MitarbeiterNr);

   PI_Pilot pneu = new PI_Pilot() { PI_MI_MitarbeiterNr = 17 }; // Stub-Objekt
   db.AttachTo("PI_Pilot", pneu); // Stub an Kontext anfügen

   // Zuweisen
   flug.PI_Pilot = pneu;

   // Speichern
   Console.WriteLine("Gespeicherte Änderungen: " + db.SaveChanges());

   flug =
    (from f in db.FL_Fluege.Include("PI_Pilot") where f.FL_FlugNr == 110 select f).FirstOrDefault();


   Console.WriteLine("Pilot nachher: " + flug.PI_Pilot.PI_MI_MitarbeiterNr);

   db.Dispose();
  }


  /// <summary>
  /// Verwendung eines Entity Key für eine Assoziationen
  /// </summary>
  public static void Demo_Assozation_withEntityKey()
  {
   de.WWWings.Test.Modelle.EF4.WorldWideWings db =
    new de.WWWings.Test.Modelle.EF4.WorldWideWings();

   var xxx = from f in db.FL_Fluege where f.FL_Datum.Value.DayOfYear == 100 select f;
   Console.WriteLine(xxx.Count());

   // Objekt normal laden
   de.WWWings.Test.Modelle.EF4.FL_Fluege flug =
    (from f in db.FL_Fluege.Include("PI_Pilot") where f.FL_FlugNr == 110 select f).FirstOrDefault();
   //Console.WriteLine("Pilot vorher: " + flug.PI_Pilot.PI_MI_MitarbeiterNr);

   // Entity Key zuweisen
   flug.PI_PilotReference.EntityKey = new EntityKey("WorldWideWings.PI_Pilot", "PI_MI_MitarbeiterNr", 15);

   // Speichern
   Console.WriteLine("Gespeicherte Änderungen: " + db.SaveChanges());

   flug =
    (from f in db.FL_Fluege.Include("PI_Pilot") where f.FL_FlugNr == 110 select f).FirstOrDefault();

   Console.WriteLine("Pilot nachher: " + flug.PI_Pilot.PI_MI_MitarbeiterNr);

   db.Dispose();
  }


  /// <summary>
  /// Verwendung einer Stub Entity für Löschen
  /// Achtung: Geht nur, wenn wirklich ein anderer Pilot zugewiesen wird!
  /// </summary>
  public static void Demo_Delete_withStub()
  {

   // === NUR Vorbereitung
   de.WWWings.Test.Modelle.EF4.WorldWideWings db2 =
    new de.WWWings.Test.Modelle.EF4.WorldWideWings();

   de.WWWings.Test.Modelle.EF4.FL_Fluege f1 = new FL_Fluege();
   f1.FL_FlugNr = 50;
   f1.FL_Abflugort = "x";
   f1.FL_Zielort = "x";
   f1.FL_FreiePlaetze = 0;
   f1.FL_Plaetze = 0;
   db2.AddToFL_Fluege(f1);
   de.WWWings.Test.Modelle.EF4.FL_Fluege f2 = new FL_Fluege();
   f2.FL_FlugNr = 51;
   f2.FL_Abflugort = "x";
   f2.FL_Zielort = "x";
   f2.FL_FreiePlaetze = 0;
   f2.FL_Plaetze = 0;
   db2.AddToFL_Fluege(f2);
   // Speichern
   try
   {
    Console.WriteLine("Gespeicherte Änderungen: " + db2.SaveChanges(true));
   }
   catch (Exception)
   {
   }

   // HIER GEHT ES LOS!
   de.WWWings.Test.Modelle.EF4.WorldWideWings db =
      new de.WWWings.Test.Modelle.EF4.WorldWideWings();

   // Objekt normal laden
   de.WWWings.Test.Modelle.EF4.FL_Fluege flug1 =
    (from f in db.FL_Fluege where f.FL_FlugNr == 50 select f).FirstOrDefault();

   // Löschen
   db.DeleteObject(flug1);

   // Speichern
   Console.WriteLine("Gespeicherte Änderungen: " + db.SaveChanges());

   // Objekt nur als Stub
   de.WWWings.Test.Modelle.EF4.FL_Fluege flug2 = new FL_Fluege() { FL_FlugNr = 51 };
   db.FL_Fluege.Attach(flug2);

   // Löschen
   db.DeleteObject(flug2);

   // Speichern
   Console.WriteLine("Gespeicherte Änderungen: " + db.SaveChanges());

   db.Dispose();
  }
  /// <summary>
  /// Ein Join im EF
  /// </summary>
  public static void Demo_Join()
  {
   de.WWWings.Test.Modelle.EF4.WorldWideWings db = new de.WWWings.Test.Modelle.EF4.WorldWideWings();

   string s = "Finden Sie alle PS_Passagiere, die genauso viele Buchungen haben wie ein FL_Fluege freie Plätze.";
   var joinpass = (from f in db.FL_Fluege
                   join p in db.PS_Passagier
                   on f.FL_FreiePlaetze equals p.GF_GebuchteFluege.Count
                   select new { p.PE_Person.PE_Name, f.FL_FlugNr, p.GF_GebuchteFluege.Count, f.FL_FreiePlaetze });
   Util.HeadLine(s);

   foreach (var j in joinpass)
   {
    Console.WriteLine(j.PE_Name + " und FL_Fluege " + j.FL_FlugNr + " haben die gleiche Zahl: " + j.Count + " / " + j.FL_FreiePlaetze);
   }


   db.Dispose();
  }



  public static void OS_LINQ_Demo1()
  {
   using (de.WWWings.Test.Modelle.EF4.WorldWideWings db = new de.WWWings.Test.Modelle.EF4.WorldWideWings(CS))
   {
    var fluege = from f in db.FL_Fluege
                 where f.FL_Abflugort == "Rom"
                 select f;

    foreach (de.WWWings.Test.Modelle.EF4.FL_Fluege f in fluege)
    {
     Console.WriteLine("Flug Nr {0} von {1} nach {2} hat {3} freie Plätze!", f.FL_FlugNr, f.FL_Abflugort, f.FL_Zielort, f.FL_FreiePlaetze);
    }
   }
  }


  /// <summary>
  /// Objektnavigation im EF mit Lazy Loading
  /// </summary>
  public static void OS_LINQ_Demo1_Navigation_Lazy()
  {
   using (Modelle.EF4Kompakt.WWWIngsEntitiesKompakt db = new Modelle.EF4Kompakt.WWWIngsEntitiesKompakt(CS2))
   {
    // Lazy Loading
    var fluege = from f in db.FL_Fluege
                 where f.FL_Abflugort == "Berlin"
                 select f;

    Console.WriteLine(((ObjectQuery<Modelle.EF4Kompakt.FL_Fluege>)fluege).ToTraceString());

    foreach (Modelle.EF4Kompakt.FL_Fluege f in fluege)
    {
     Console.WriteLine("Flug Nr {0} von {1} nach {2} hat {3} freie Plätze!", f.FL_FlugNr, f.FL_Abflugort, f.FL_Zielort, f.FL_FreiePlaetze);
     // Explizites Laden der Passagiere
     if (!f.PS_Passagier.IsLoaded)
     {
      f.PS_Passagier.Load();
     }
     foreach (Modelle.EF4Kompakt.PS_Passagier p in f.PS_Passagier)
     {
      // Explizites Laden der Personendaten
      if (!p.PE_PersonReference.IsLoaded)
      {
       p.PE_PersonReference.Load();
      }
      Console.WriteLine("   " + p.PE_Person.PE_Name);
     }
    }
   }
  }

  /// <summary>
  /// Objektnavigation im EF mit Eager Loading
  /// </summary>
  public static void OS_LINQ_Demo1_Navigation_Eager()
  {
   using (Modelle.EF4Kompakt.WWWIngsEntitiesKompakt db = new Modelle.EF4Kompakt.WWWIngsEntitiesKompakt(CS2))
   {

    // Eager Loading
    var fluege = from f in db.FL_Fluege.Include("PS_Passagier.PE_Person")
                 where f.FL_Abflugort == "Berlin"
                 select f;


    Console.WriteLine(((ObjectQuery<Modelle.EF4Kompakt.FL_Fluege>)fluege).ToTraceString());

    foreach (Modelle.EF4Kompakt.FL_Fluege f in fluege)
    {
     Console.WriteLine("Flug Nr {0} von {1} nach {2} hat {3} freie Plätze!", f.FL_FlugNr, f.FL_Abflugort, f.FL_Zielort, f.FL_FreiePlaetze);

     foreach (Modelle.EF4Kompakt.PS_Passagier p in f.PS_Passagier)
     {

      Console.WriteLine("   " + p.PE_Person.PE_Name);
     }
    }
   }
  }


  /// <summary>
  /// Anwendung des Entity Clients zum Zugriff auf eine Tabelle.
  /// </summary>
  public static void EntityClient_Demo()
  {
   // ESQL-Befehl
   string ESQL = @"SELECT value fl " +
   "FROM WWWIngsEntitiesKompakt.FL_Fluege AS fl " +
   "WHERE fl.FL_Abflugort = @Ort";

   // Verbindung aufbauen
   using (EntityConnection conn = new EntityConnection(CS2))
   {
    conn.Open();
    // Befehl ausführen
    using (EntityCommand cmd = conn.CreateCommand())
    {
     cmd.CommandText = ESQL;
     cmd.Parameters.AddWithValue("Ort", "Rom");
     using (EntityDataReader f =
         cmd.ExecuteReader(CommandBehavior.SequentialAccess))
     {

      // Schleife über alle Datensätze
      while (f.Read())
      {
       Console.WriteLine("Flug Nr {0} von {1} nach {2} hat {3} freie Plätze!", f["FL_FlugNr"], f["FL_Abflugort"], f["FL_Zielort"], f["FL_FreiePlaetze"]);
      }
     }
    }
   }
  }

  /// <summary>
  /// Anwendung des Entity Clients zum Zugriff auf eine Tabelle.
  /// </summary>
  public static void EntityClient_Demo2()
  {
   // ESQL-Befehl
   string ESQL = @"SELECT VALUE fl
FROM WWWIngsEntitiesKompakt.FL_Fluege AS fl 
WHERE EXISTS(
  SELECT VALUE p 
  FROM NAVIGATE(f, WWWIngsEntitiesKompakt.PS_Passagier.PE_Person) AS p)";

   // Verbindung aufbauen
   using (EntityConnection conn = new EntityConnection(CS2))
   {
    conn.Open();
    // Befehl ausführen
    using (EntityCommand cmd = conn.CreateCommand())
    {
     cmd.CommandText = ESQL;
     cmd.Parameters.AddWithValue("Ort", "Rom");
     using (EntityDataReader f =
         cmd.ExecuteReader(CommandBehavior.SequentialAccess))
     {

      // Schleife über alle Datensätze
      while (f.Read())
      {
       Console.WriteLine("Flug Nr {0} von {1} nach {2} hat {3} freie Plätze!", f["FL_FlugNr"], f["FL_Abflugort"], f["FL_Zielort"], f["FL_FreiePlaetze"]);
      }
     }
    }
   }
  }


  /// <summary>
  /// Ausgabe des ChangeTrackers
  /// </summary>
  public static void EF_ChangeTracker()
  {

   var modell = new Modelle.EF6.WWWings6Entities();

   Modelle.EF6.Flug flug = modell.Flug.Where(x => x.FlugNr == 101).FirstOrDefault();

   flug.FreiePlaetze = flug.FreiePlaetze;

   flug.Memo = "Zuletzt geändert am: " + DateTime.Now;

   Console.WriteLine("Anzahl geänderter Objekte: " + modell.ObjectStateManager.GetObjectStateEntries(EntityState.Modified).Count());

   foreach (var obj in modell.ObjectStateManager.GetObjectStateEntries(EntityState.Modified))
   {
    Console.WriteLine("Anzahl geänderter Attribute: " + obj.GetModifiedProperties().Count());
    foreach (var attribut in modell.ObjectStateManager.GetObjectStateEntry(obj).GetModifiedProperties())
    {
     Console.WriteLine(" Alter Wert: " + obj.OriginalValues[attribut]);
     Console.WriteLine(" Neuer Wert: " + obj.CurrentValues[attribut]);
    }
   }
   int anz = modell.SaveChanges();

   Console.WriteLine("SaveChanges(): Anzahl der gespeicherten Änderungen: " + anz);

  }



  /// <summary>
  /// Buchungstransaktion
  /// </summary>
  public static void EntityClient_Save()
  {
   using (Modelle.EF4Kompakt.WWWIngsEntitiesKompakt db = new Modelle.EF4Kompakt.WWWIngsEntitiesKompakt(CS2))
   {
    Modelle.EF4Kompakt.FL_Fluege Flug;
    using (System.Transactions.TransactionScope t = new System.Transactions.TransactionScope())
    {
     Flug = (from f in db.FL_Fluege.Include("PS_Passagier.PE_Person")
             where f.FL_FlugNr == 101
             select f).FirstOrDefault();
     Console.WriteLine("Flug Nr {0} von {1} nach {2} hat {3} freie Plätze und {4} Buchungen!", Flug.FL_FlugNr, Flug.FL_Abflugort, Flug.FL_Zielort, Flug.FL_FreiePlaetze, Flug.PS_Passagier.Count);
     Console.WriteLine("Zustand des Objekts: " + Flug.EntityState);

     // === Zunächst wird in dem Flug-Objekt die Platzanzahl reduziert.
     Console.WriteLine("--- Reduzieren der Platzanzahl....");
     Flug.FL_FreiePlaetze--;
     Console.WriteLine("Zustand des Objekts: " + Flug.EntityState);

     GetStatistik(db);

     // StateManager auslesen für ein Objekt
     Console.WriteLine("Anzahl geänderter Attribute: " + db.ObjectStateManager.GetObjectStateEntry(Flug).GetModifiedProperties().Count());
     Console.WriteLine("Neuer Wert: " + db.ObjectStateManager.GetObjectStateEntry(Flug).CurrentValues["FL_FreiePlaetze"]);
     Console.WriteLine("Alter Wert: " + db.ObjectStateManager.GetObjectStateEntry(Flug).OriginalValues["FL_FreiePlaetze"]);


     // Änderungen speichern
     db.SaveChanges();

     // === Dann wird ein bestehendes Passagier-Objekt der Liste der Passagiere des Flugs angefügt
     Console.WriteLine("Zustand des Objekts: " + Flug.EntityState);
     Console.WriteLine("--- Anfügen eines Passagiers....");

     Modelle.EF4Kompakt.PS_Passagier Passagier = (from p in db.PS_Passagier.Include("PE_Person")
                                                  where p.PS_ID == 7
                                                  select p).FirstOrDefault();

     Console.WriteLine("Zustand des Objekts: " + Flug.EntityState);
     Flug.PS_Passagier.Add(Passagier);
     GetStatistik(db);

     db.SaveChanges();
     Console.WriteLine("Zustand des Objekts: " + Flug.EntityState);

     t.Complete();
     Console.WriteLine("Buchungstransaktion erfolgreich!");
    }

    Flug = (from f in db.FL_Fluege.Include("PS_Passagier.PE_Person")
            where f.FL_FlugNr == 101
            select f).FirstOrDefault();
    Console.WriteLine("Flug Nr {0} von {1} nach {2} hat {3} freie Plätze und {4} Buchungen!", Flug.FL_FlugNr, Flug.FL_Abflugort, Flug.FL_Zielort, Flug.FL_FreiePlaetze, Flug.PS_Passagier.Count);
   }

  }

  /// <summary>
  ///StateManager auslesen: Statistik über alle Objekte
  /// </summary>
  /// <param name="db">Bestehender Kontext</param>
  private static void GetStatistik(Modelle.EF4Kompakt.WWWIngsEntitiesKompakt db)
  {
   Console.ForegroundColor = ConsoleColor.Yellow;
   // StateManager auslesen: Statistik über alle Objekte
   Console.WriteLine("# Anzahl geänderter Objekte: " + db.ObjectStateManager.GetObjectStateEntries(EntityState.Modified).Count());
   Console.WriteLine("# Anzahl hinzugefügter Objekte: " + db.ObjectStateManager.GetObjectStateEntries(EntityState.Added).Count());
   Console.WriteLine("# Anzahl gelöschter Objekte: " + db.ObjectStateManager.GetObjectStateEntries(EntityState.Deleted).Count());
   Console.WriteLine("# Anzahl unveränderter Objekte: " + db.ObjectStateManager.GetObjectStateEntries(EntityState.Unchanged).Count());
   Console.ForegroundColor = ConsoleColor.Gray;
  }


  /// <summary>
  /// Serialisierung und Deserialisierung eines Flug-Objekts
  /// </summary>
  public static void EntityClient_Serialisierung()
  {
   string DATEI = "Flug.bin";

   Modelle.EF4Kompakt.FL_Fluege Flug;

   using (Modelle.EF4Kompakt.WWWIngsEntitiesKompakt db1 = new Modelle.EF4Kompakt.WWWIngsEntitiesKompakt(CS2))
   {

    Flug = (from f in db1.FL_Fluege.Include("PS_Passagier.PE_Person")
            where f.FL_FlugNr == 101
            select f).FirstOrDefault();
    PrintFlug(Flug);
    Console.WriteLine("Vor dem Entfernen aus dem Kontext:");
    GetStatistik(db1);
    Console.WriteLine("Serialisierung...");
    VerschiedeneDemos_CS.FCL3.UniversalSerialisierer.Save(VerschiedeneDemos_CS.FCL3.SerialTyp.BINARY, Flug, DATEI);
   }

   Console.WriteLine("Kontext vernichtet!");

   Console.WriteLine("Deserialisierung");
   Flug = VerschiedeneDemos_CS.FCL3.UniversalSerialisierer.Load(VerschiedeneDemos_CS.FCL3.SerialTyp.XML, DATEI) as Modelle.EF4Kompakt.FL_Fluege;
   Modelle.EF4Kompakt.FL_Fluege FlugNeu = VerschiedeneDemos_CS.FCL3.UniversalSerialisierer.Load(VerschiedeneDemos_CS.FCL3.SerialTyp.BINARY, DATEI) as Modelle.EF4Kompakt.FL_Fluege;

   PrintFlug(Flug);
   // === Zunächst wird in dem Flug-Objekt die Platzanzahl reduziert.
   Console.WriteLine("! Reduzieren der Platzanzahl");


   FlugNeu.FL_FreiePlaetze--;

   PrintFlug(FlugNeu);

   using (Modelle.EF4Kompakt.WWWIngsEntitiesKompakt db2 = new Modelle.EF4Kompakt.WWWIngsEntitiesKompakt(CS2))
   {

    Console.WriteLine("Vor dem Hinzufügen zum Kontext:");
    GetStatistik(db2);
    db2.Attach(Flug);
    Console.WriteLine("Nach dem Hinzufügen zum Kontext:");
    GetStatistik(db2);
    PrintFlug(Flug);

    db2.ApplyPropertyChanges("FL_Fluege", FlugNeu);

    Console.WriteLine("Nach dem Signalisieren der Änderungen:");
    GetStatistik(db2);
    PrintFlug(Flug);

    db2.SaveChanges();
    Console.WriteLine("Nach dem Speichern des Kontextes:");
    GetStatistik(db2);
    PrintFlug(Flug);

   }

  }

  private static void PrintFlug(Modelle.EF4Kompakt.FL_Fluege Flug)
  {
   Console.WriteLine("Flug Nr {0} von {1} nach {2} hat {3} freie Plätze und {4} Buchungen!", Flug.FL_FlugNr, Flug.FL_Abflugort, Flug.FL_Zielort, Flug.FL_FreiePlaetze, Flug.PS_Passagier.Count);
   Console.WriteLine("Zustand des Objekts: " + Flug.EntityState);
  }


  public static void Konvert()
  {
   using (Modelle.EF4Kompakt.WWWIngsEntitiesKompakt db = new Modelle.EF4Kompakt.WWWIngsEntitiesKompakt(CS2))
   {
    var fluege = from f in db.FL_Fluege
                 where f.FL_Abflugort == "Rom"
                 select f;

    Modelle.EF4Kompakt.FL_Fluege fl = fluege.ToArray()[0];
    PrintFlug(fl);

    fl.FL_FreiePlaetze--;
    PrintFlug(fl);

    db.SaveChanges();

    PrintFlug(fl);
   }
  }


  public static void SP_Demo()
  {
   using (Modelle.EF4Kompakt.WWWIngsEntitiesKompakt db = new Modelle.EF4Kompakt.WWWIngsEntitiesKompakt(CS2))
   {
    var fluege = db.GetFluege();

    Modelle.EF4Kompakt.FL_Fluege fl = fluege.ToArray()[0];
    PrintFlug(fl);

   }
  }



  /// <summary>
  /// Bulk Update // not implemented in EF 1.0
  /// </summary>
  //public static object EF_BulkUpdate()
  //{

  // de.WWWings.Test.Modelle.EF4.WorldWideWings db = new de.WWWings.Test.Modelle.EF4.WorldWideWings();


  // var q = from f in db.FL_Fluege where f.FL_Abflugort == "Rom" select f;


  //}


 }



}

