﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace de.WWWings.Test.LINQ
{
 class LINQ_Basiswissen
 {

  public static void Beispiel1a()
  {
   // Datendefinition (=Datenquelle)
   string[] AlleMonate = { "Januar", "Februar", "März", "April", "Mai", "Juni", "Juli", "August", "September", "Oktober", "November", "Dezember" };
  
   // LINQ-Abfrage in Abfragesyntax
   IEnumerable<string> Monate4 = from Monat in AlleMonate
                 where Monat.Length == 4
                 orderby Monat
                 select Monat.Substring(0, 3);

   // Nutzung des Abfrageergebnisses
   foreach (string Monat in Monate4)
   {
    Console.WriteLine(Monat);
   }
  }

  public static void Beispiel1b()
  {
   // Datendefinition (=Datenquelle)
   string[] AlleMonate = { "Januar", "Februar", "März", "April", "Mai", "Juni", "Juli", "August", "September", "Oktober", "November", "Dezember" };

   // LINQ-Abfrage in Methodensyntax
   IEnumerable<string> Monate4 = 
    AlleMonate
    .Where(Monat => Monat.Length == 4)
    .OrderBy(Monat => Monat)
    .Select(Monat => Monat.Substring(0,3));

   // Nutzung des Abfrageergebnisses
   foreach (string Monat in Monate4)
   {
    Console.WriteLine(Monat);
   }
  }


  public static void Beispiel1()
  {
   // Datendefinition (=Datenquelle)
   string[] AlleMonate = { "Januar", "Februar", "März", "April", "Mai", "Juni", "Juli", "August", "September", "Oktober", "November", "Dezember" };

   //// LINQ-Abfrage in Methodensyntax
   //IEnumerable<string> SommerMonate =
   // AlleMonate
   // .Select(Monat => Monat.Substring(0, 3))
   // .Skip(5).Take(3)
   // ;

   // LINQ-Abfrage in gemischter Syntax
   IEnumerable<string> SommerMonate =
    (from Monat in AlleMonate
    select Monat.Substring(0, 3))
    .Skip(5).Take(3);

   // Nutzung des Abfrageergebnisses
   foreach (string Monat in SommerMonate)
   {
    Console.WriteLine(Monat);
   }
  }



  public static void Beispiel2()
  {
   // LINQ-Abfrage
   var Prozesse =
   from p in System.Diagnostics.Process.GetProcesses()
   where p.WorkingSet64 < 700000
   select new { p.ProcessName, p.WorkingSet64 };

   // Nutzung des Abfrageergebnisses
   foreach (var Prozess in Prozesse)
   {
    Console.WriteLine(Prozess.ProcessName + ": " + Prozess.WorkingSet64);
   }
  }

 }
}
