﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Linq.Expressions;
using System.Data.Linq.Provider;
using System.Data.Linq;

using de.WWWings.Test.Modelle.LTS4;
using de.WWWings.Test.LINQ;

namespace de.WWWings.Test
{
 class LTS
 {
  public static void run()
  {

   LTS_Demo();
   //Demo_Flüge_Filter_MethodSyntax();
  }

  // --------------------------------------------------------------------

  public static void Print(IDictionary<string, int> gruppe, string s)
  {

   HeadLine(s);
   foreach (var x in gruppe)
   {
    Console.WriteLine(x.Key + ": " + x.Value);
   }

  }


  public static void Print(IEnumerable<FL_Fluege> lowNums, string s)
  {
   HeadLine(s);
   foreach (FL_Fluege x in lowNums)
   {
    PrintFL_Fluege(x);
   }
  }

  public static void Print(IEnumerable<PS_Passagier> lowNums, string s)
  {
   HeadLine(s);
   foreach (PS_Passagier x in lowNums)
   {
    PrintPS_Passagier(x);
   }
  }

  public static void Print(IEnumerable<string> lowNums, string s)
  {
   HeadLine(s);
   foreach (string x in lowNums)
   {
    Console.WriteLine(x);
   }
  }


  public static void Print(IEnumerable<IGrouping<string, FL_Fluege>> Gruppen, string s)
  {
   HeadLine(s);
   foreach (IGrouping<string, FL_Fluege> x in Gruppen)
   {
    Console.WriteLine("---- " + x.Key);
    foreach (FL_Fluege y in x)
    {
     PrintFL_Fluege(y);
    }
   }
  }

  public static void Print(FL_Fluege x, string s)
  {
   HeadLine(s);
   if (x == null) { Console.WriteLine("---"); return; }
   PrintFL_Fluege(x);

  }

  public static void PrintFL_Fluege(FL_Fluege x)
  {
   Console.WriteLine(x.FL_FlugNr + ": " + x.FL_Abflugort + " -> " + x.FL_Zielort + ": " + x.FL_FreiePlaetze + " freie Plätze");
  }

  public static void PrintPS_Passagier(PS_Passagier x)
  {
   Console.WriteLine(x.PE_Person.PE_Name + ": " + x.PE_Person.PE_Geburtstag + " -> " + x.GF_GebuchteFlueges.Count);
  }


  public static void Print(object x, string s)
  {
   HeadLine(s);

   Console.WriteLine(x);

  }


  public static void HeadLine(string s)
  {
   if (s == "") return;
   Console.ForegroundColor = ConsoleColor.Yellow;
   Console.WriteLine(s);
   Console.ForegroundColor = ConsoleColor.Gray;

   Log(s);

  }

  private static void Log(string s)
  {
   System.IO.StreamWriter sw = new System.IO.StreamWriter("Fragen.txt", true);
   sw.WriteLine(s);
   sw.Close();
  }




  //private static void Print(IEnumerable<int> lowNums, string s)
  //{
  // Console.ForegroundColor = ConsoleColor.Yellow;
  // Console.WriteLine(s);
  // Console.ForegroundColor = ConsoleColor.Gray;
  // foreach (var x in lowNums)
  // {
  //  Console.WriteLine(x);
  // }
  //}

  // --------------------------------------------

  public static void Demo_for_Screenshot()
  {
   DatenbankDataContext db = new DatenbankDataContext();

   string s = "Geben Sie alle Flüge aus, die weniger als 100 freie Plätze haben. Sortieren Sie die Liste absteigend nach Platzanzahl.";
   Util.HeadLine(s);
   var Ergebnis =
    from n in db.FL_Flueges
    where n.FL_FreiePlaetze < 100
    orderby n.FL_FreiePlaetze descending
    select n;


   db.Dispose();
  }

  public static void Demo_fuer_Buch()
  {
   // Datenkontext instanziieren
   DatenbankDataContext db = new DatenbankDataContext();

   var Fluege =
    from f in db.FL_Flueges
    where f.FL_Abflugort == "Rom"
    select f;

   // Daten verwenden
   foreach (FL_Fluege Flug in Fluege)
   {
    Console.WriteLine(Flug.FL_FlugNr + ": " + Flug.FL_Abflugort + " -> " + Flug.FL_Zielort + ": " + Flug.FL_FreiePlaetze + " freie Plätze");
    //Flug.GF_GebuchteFlueges[0].PS_Passagier.PE_Person.PE_Name;

   }

   db.Log = Console.Out;
   // Bedingung
   var q1 = from f in db.FL_Flueges where f.FL_Abflugort == "London" select f;

   Log(q1.ToString());
   // Zählen
   var q2 = db.FL_Flueges.Count(f => f.FL_Abflugort == "Berlin");

   Log(q2.ToString());
   // Paging
   var q3 = (from f in db.FL_Flueges where f.FL_Abflugort == "London" orderby f.FL_Zielort select f).Skip(5).Take(5);
   Log(q3.ToString());
   // Projektion
   var q4 = from f in db.FL_Flueges
            let Route = f.FL_Abflugort + " --> " + f.FL_Zielort
            where Route.StartsWith("M")
            select new { f.FL_FlugNr, Route };
   Log(q4.ToString());


   // Datenkontext vernichten
   db.Dispose();

  }


  private static void LTS_Demo()
  {

   // Datenbankverbindung
   DatenbankDataContext db = new DatenbankDataContext();

   // Benötigte Bariablen
   string s;
   long i;
   int? i2;
   FL_Fluege flug;

   double? d2;
   
   s = "Geben Sie alle Flüge von Rom aus!";
   var Ergebnis =
    from f in db.FL_Flueges
    where f.FL_Abflugort == "Rom"
    select f;
   Print(Ergebnis, s);

   s = "Geben Sie alle Flüge aus, die weniger als 100 freie Plätze haben.";
   Ergebnis =
      from n in db.FL_Flueges
      where n.FL_FreiePlaetze < 100
      select n;
   Print(Ergebnis, s);

   s = "Geben Sie alle Flüge aus, die weniger als 100 freie Plätze haben. Sortieren Sie die Liste aufsteigend nach Platzanzahl.";
   Ergebnis =
   from n in db.FL_Flueges
   where n.FL_FreiePlaetze < 100
   orderby n.FL_FreiePlaetze
   select n;
   Print(Ergebnis, s);
   
   s = "Geben Sie alle Flüge aus, die weniger als 100 freie Plätze haben. Sortieren Sie die Liste absteigend nach Platzanzahl.";
   Ergebnis =
   from n in db.FL_Flueges
   where n.FL_FreiePlaetze < 100
   orderby n.FL_FreiePlaetze descending
   select n;
   Print(Ergebnis, s);

   s = "Geben Sie Flug 101 aus.";
   flug = (from f in db.FL_Flueges
           where f.FL_FlugNr == 101
           select f).SingleOrDefault();
   Print(flug, s);
   
   s = "Geben die Routen (von x nach y aus), aber jede Route nur einmal!";
   var Strecken =
        (from n in db.FL_Flueges
         select new { n.FL_Abflugort, n.FL_Zielort }).Distinct();
   HeadLine(s);
   foreach (var f in Strecken)
   {
    Console.WriteLine(f.FL_Abflugort + " -> " + f.FL_Zielort);
   }

   s = "Geben Sie alle Ziele aus, die von Rom erreichbar sind.";
   var Ziele =
        (from n in db.FL_Flueges
         where n.FL_Abflugort == "Rom"
         select n.FL_Zielort).Distinct();
   HeadLine(s);

   foreach (string f in Ziele)
   {
    Console.WriteLine(f);
   }

   s = "Geben Sie den vierten bis achten FL_Fluege aus in der nach freien Plätzen aufsteigend sortierten Liste aller Flüge, die in Berlin landen.";
   Ergebnis =
       (from n in db.FL_Flueges
        where n.FL_Zielort == "Berlin"
        orderby n.FL_FreiePlaetze
        select n).Skip(3).Take(4);
   Print(Ergebnis, s);

   s = "Geben Sie den ersten FL_Fluege aus in der nach freien Plätzen aufsteigend sortierten Liste aller Flüge, die in Berlin landen.";
   flug =
      (from n in db.FL_Flueges
       where n.FL_Zielort == "Berlin"
       orderby n.FL_FreiePlaetze
       select n).First();
   Print(flug, s);

   // "Last" not supported in LTS!
   //s = "Geben Sie den letzten FL_Fluege aus in der nach freien Plätzen aufsteigend sortierten Liste aller Flüge, die in Berlin landen.";
   //FL_Fluege =
   //   (from n in db.FL_Flueges
   //    where n.FL_Zielort == "Berlin"
   //    orderby n.FL_FreiePlaetze
   //    select n).Last();
   ////Print(FL_Fluege, s);

   // "ElementAr" not supported in LTS!
   //s = "Geben Sie den 10. FL_Fluege aus in der nach freien Plätzen aufsteigend sortierten Liste aller Flüge, die in Berlin landen.";
   //FL_Fluege =
   //   (from n in db.FL_Flueges
   //    where n.FL_Zielort == "Berlin"
   //    orderby n.FL_FreiePlaetze
   //    select n).ElementAt(9);
   //Print(FL_Fluege, s);

   //s = "Geben Sie den 150. FL_Fluege aus in der nach freien Plätzen aufsteigend sortierten Liste aller Flüge, die in Berlin landen.";
   //FL_Fluege =
   //   (from n in db.FL_Flueges
   //    where n.FL_Zielort == "Berlin"
   //    orderby n.FL_FreiePlaetze
   //    select n).ElementAtOrDefault(149);
   //Print(FL_Fluege, s);

   s = "Geben Sie Anzahl der Flüge aus (mit einem LINQ-Statement!)";
   i =
      (from n in db.FL_Flueges
       select n).Count();
   Print(i, s);
   
   s = "Geben Sie geringste freie Platzzahl aus.";
   i2 =
      (from n in db.FL_Flueges
       select n).Min(n => n.FL_FreiePlaetze);
   Print(i2, s);

   s = "Geben Sie höchste freie Platzzahl aus.";
   i2 =
      (from n in db.FL_Flueges
       select n).Min(n => n.FL_FreiePlaetze);
   Print(i2, s);

   s = "Geben Sie durchschnittliche freie Platzzahl aus.";
   d2 =
      (from n in db.FL_Flueges
       select n).Average(n => n.FL_FreiePlaetze);
   Print(d2, s);

   s = "Geben Sie Summe aller freien Plätze aus.";
   i2 =
      (from n in db.FL_Flueges
       select n).Sum(n => n.FL_FreiePlaetze);
   Print(i, s);

   s = "Gruppieren Sie die Flüge nach FL_Abflugorten.";
   IEnumerable<IGrouping<string, FL_Fluege>> GruppeErgebnis =
       (from n in db.FL_Flueges
        group n by n.FL_Abflugort);
   Print(GruppeErgebnis, s);

   s = "Geben Sie die Häufigkeit eines jeden FL_Abflugortes aus!";
   IDictionary<string, int> GruppeHaeufigkeit =
         (from n in db.FL_Flueges
          group n by n.FL_Abflugort into g
          select new { Name = g.Key, AnzFL_Fluege = g.Count() }
          ).ToDictionary(y => y.Name, y => y.AnzFL_Fluege);
   Print(GruppeHaeufigkeit, s);

   s = "Geben Sie die Daten von dem Passagier mit der ID 1 aus!";
   PS_Passagier pass = (from p in db.PS_Passagiers
                        orderby p.PE_Person.PE_Name
                        where p.PS_ID == 2727
                        select p).FirstOrDefault();

   Console.WriteLine(pass.PS_ID + ": " + pass.PE_Person.PE_Name);
   
   s = "Erstellen Sie eine gruppierte Liste aller PS_Passagiere mit Ihren Buchungen!";
   var pass2 = from p in db.PS_Passagiers
               orderby p.PE_Person.PE_Name
               select new { p.PE_Person.PE_Name, p.GF_GebuchteFlueges };

   foreach (var p in pass2)
   {
    Console.WriteLine(p.PE_Name);
    foreach (GF_GebuchteFluege b in p.GF_GebuchteFlueges)
     Console.WriteLine("\t" + b.GF_Buchungscode);
   }
   
   s = "Erstellen Sie die Liste der 10 Passagiere mit den meisten Buchungen.";
   var pass4 = (from p in db.PS_Passagiers
                orderby p.GF_GebuchteFlueges.Count descending
                select p).Take(10);
   Print(pass4, s);
   
   s = "Geben Sie den/die Passagier(e) mit den meisten Buchungen aus.";
   pass4 = (from n in db.PS_Passagiers where n.GF_GebuchteFlueges.Count == db.PS_Passagiers.Max(x => x.GF_GebuchteFlueges.Count) select n);
   Print(pass4, s);
   
   s = "Finden Sie alle Passagiere, die nach Rom fliegen.";

   pass4 = (from p in db.PS_Passagiers
            where p.GF_GebuchteFlueges.Any(b => b.FL_Fluege.FL_Zielort == "Rom")
            select p);
   Print(pass4, s);
   
   s = "Finden Sie alle Passagiere, die genauso viele Buchungen haben wie ein FL_Fluege freie Plätze.";
   var joinpass = (from p in db.PS_Passagiers
                   join f in db.FL_Flueges
                   on p.GF_GebuchteFlueges.Count equals f.FL_FreiePlaetze
                   select new { p.PE_Person.PE_Name, f.FL_FlugNr, p.GF_GebuchteFlueges.Count, f.FL_FreiePlaetze });
   HeadLine(s);
   foreach (var j in joinpass)
   {
    Console.WriteLine(j.PE_Name + " und FL_Fluege " + j.FL_FlugNr + " haben die gleiche Zahl: " + j.Count + " / " + j.FL_FreiePlaetze);
   }


   s = "Geben Sie alle Passagiere aus und optional dazu einen FL_Fluege, der genausoviele freie Plätze hat wie der PS_Passagier Buchungen hat.";
   var joinpass2 = (from p in db.PS_Passagiers
                    join f in db.FL_Flueges
                    on p.GF_GebuchteFlueges.Count equals f.FL_FreiePlaetze
                    into Fluege
                    select new { p.PE_Person.PE_Name, Fluege });
   HeadLine(s);
   foreach (var j in joinpass2)
   {
    Console.WriteLine(j.PE_Name + " hat " + j.Fluege.Count() + " korrespondierende Flüge!");
   }

   s = "Geben Sie alle PPassagiere, die älter als 50 Jahre sind!";

   pass4 =
                  (from p in db.PS_Passagiers
                   where p.PE_Person.PE_Geburtstag.Value.AddYears(50) < DateTime.Now
                   select p);

   //db.Log = Console.Out;
   Print(pass4, s);
   
   s = "Geben Sie alle Flüge aus, mit PPassagieren älter als 50 Jahre !";
   Ergebnis =
                  (from p in db.PS_Passagiers
                   where p.PE_Person.PE_Geburtstag.Value.AddYears(50) < DateTime.Now
                   from b in p.GF_GebuchteFlueges
                   select b.FL_Fluege).Distinct();
   Print(Ergebnis, s);

   // Kontrolle:
   //foreach (FL_Fluege f in Ergebnis)
   //{
   // foreach (PS_Passagier p in f.PS_Passagiere)
   // {
   //  Console.WriteLine(p.Geburtsdatum);
   // }
   //}

   // NEU!!!

   s = "Geben Sie alle Buchungen aus von Flügen aus, die in Berlin beginnen !"; // Beispiel für SelectMany!
   var Buchungen =
                  (from f in db.FL_Flueges
                   where f.FL_Abflugort == "Berlin" select f).SelectMany(f => f.GF_GebuchteFlueges);

   foreach (var Buchung in Buchungen)
   {
    Console.WriteLine(Buchung.GF_Buchungscode);
   }


   Print(Ergebnis, s);

   
  }






 }
}
