﻿using System;
using System.Linq;
using de.WWWings.Test.Modelle.EF4;

namespace de.WWWings.Test.LINQ
{
 public class Buchungsbeispiel_DB4_EF
 {
  WorldWideWings db = new de.WWWings.Test.Modelle.EF4.WorldWideWings();

  //DatenbankDataContext db = new DatenbankDataContext();

  public int NewBuchung()
  {
   int FNummer = 222;
   int PNummer = 2730;
   int Platzanzahl = 2;
   int Buchungscode = Convert.ToInt32(FNummer.ToString() + PNummer.ToString());

   // Transaktion, nur erfolgreich wenn Platzanzahl reduziert und Buchung erstellt!
   using (System.Transactions.TransactionScope t = new System.Transactions.TransactionScope())
   {
    try
    {
     //Passagier
     PS_Passagier Passagier = (from p in db.PS_Passagier where p.PS_ID == PNummer select p).FirstOrDefault();
     Console.WriteLine(Passagier.PS_ID);
     // Flug
     FL_Fluege EinzelnerFlug = (from f in db.FL_Fluege where f.FL_FlugNr == FNummer select f).FirstOrDefault();

     Console.WriteLine("Bestehende Buchungen:");
     foreach (GF_GebuchteFluege b in EinzelnerFlug.GF_GebuchteFluege)
     {
      Console.WriteLine(b.GF_Buchungscode);
     }

     // Platzanzahl reduzieren
     Console.WriteLine("Platzanzahl reduzieren...");
     if (EinzelnerFlug != null)
     {
      if (EinzelnerFlug.FL_FreiePlaetze >= Platzanzahl)
      {
       Console.WriteLine("Platzanzahl vorher: " + EinzelnerFlug.FL_FreiePlaetze.ToString());
       EinzelnerFlug.FL_FreiePlaetze -= Platzanzahl;
       db.SaveChanges(); // Speichern!!!
       Console.WriteLine("Platzanzahl nun: " + EinzelnerFlug.FL_FreiePlaetze.ToString());
      }
      else
      {
       return 0; // Kein Platz vorhanden!
      }
      // Buchung erstellen
      // mit LINQ-to-SQL aber über SQL:
      //db.ExecuteCommand("Insert into GF_GebuchteFluege (GF_FL_FlugNr,GF_PS_ID, GF_Buchungscode) values ( " +  FNummer + "," + PNummer + "," + Buchungscode + ")");
      // mit LINQ-to-SQL;
      Console.WriteLine("Buchung erstellen...");
      GF_GebuchteFluege b = new GF_GebuchteFluege();
      //b.GF_FL_FlugNr = FNummer;
      b.FL_Fluege = EinzelnerFlug;
      //b.GF_PS_ID = PNummer;
      b.PS_Passagier = Passagier;
      b.GF_Buchungscode = Buchungscode;
      db.AddToGF_GebuchteFluege(b); // Einfügen
      db.SaveChanges(); // Speichern
     }
    } // End Try
    catch (Exception ex)
    {
     Console.WriteLine("Fehler: " + ex.Message);
     return 0;
    }
    // Transaktion erfolgreich
    t.Complete();
   } // End Transaktion
   Console.WriteLine("Abgeschlossen. Buchungscode: " + Buchungscode.ToString());
   return Buchungscode;
  }
 }
}
