﻿using System;
using System.Linq;
using de.WWWings.Test.Modelle.LTS5;

namespace de.WWWings.Test.LINQ
{

 public class Buchungsbeispiel_DB5_LTS
 {
  WWWings5DataContext db = new WWWings5DataContext();

  public int NewBuchung()
  {
   int FNummer = 221;
   int PNummer = 101;
   short Platzanzahl = 2;
   int Buchungscode = Convert.ToInt32(FNummer.ToString() + PNummer.ToString());

   // Transaktion, nur erfolgreich wenn Platzanzahl reduziert und Buchung erstellt!
   using (System.Transactions.TransactionScope t = new System.Transactions.TransactionScope())
   {
    try
    {
     //Passagier
     PS_Passagier EinPassagier = (from p in db.PS_Passagier where p.PS_PE_ID == PNummer select p).SingleOrDefault();
     Console.WriteLine(EinPassagier.PS_PE_ID);
     // Flug
     FL_Flug EinFlug = (from f in db.FL_Flug where f.FL_FlugNr == FNummer select f).SingleOrDefault();

     Console.WriteLine("Bestehende Buchungen:");
     foreach (FLPS_Flug_Passagier b in EinFlug.FLPS_Flug_Passagier)
     {
      Console.WriteLine(b.FLPS_PS_ID);
     }

     // Platzanzahl reduzieren
     Console.WriteLine("Platzanzahl reduzieren...");
     if (EinFlug != null)
     {
      if (EinFlug.FL_FreiePlaetze >= Platzanzahl)
      {
       Console.WriteLine("Platzanzahl vorher: " + EinFlug.FL_FreiePlaetze.ToString());
       EinFlug.FL_FreiePlaetze -= Platzanzahl;
       db.SubmitChanges(); // Speichern!!!
       Console.WriteLine("Platzanzahl nun: " + EinFlug.FL_FreiePlaetze.ToString());
      }
      else
      {
       Console.WriteLine("Kein Platz vorhanden!");
       return 0; // Kein Platz vorhanden!
      }
      // Buchung erstellen
      // mit LINQ-to-SQL aber über SQL:
      //db.ExecuteCommand("Insert into GF_GebuchteFluege (GF_FL_FlugNr,GF_PS_ID, GF_Buchungscode) values ( " +  FNummer + "," + PNummer + "," + Buchungscode + ")");
      // mit LINQ-to-SQL;
      Console.WriteLine("Buchung erstellen...");
      FLPS_Flug_Passagier b = new FLPS_Flug_Passagier();
      //b.GF_FL_FlugNr = FNummer;
      b.FL_Flug = EinFlug;
      //b.GF_PS_ID = PNummer;
      b.PS_Passagier = EinPassagier;
      db.FLPS_Flug_Passagier.InsertOnSubmit(b); // Einfügen
      db.SubmitChanges(); // Speichern
     }
    } // End Try
    catch (Exception ex)
    {
     Console.WriteLine("Fehler: " + ex.Message);
     return 0;
    }
    // Transaktion erfolgreich
    t.Complete();
   } // End Transaktion
   Console.WriteLine("Abgeschlossen. Buchungscode: " + Buchungscode.ToString());
   return Buchungscode;
  }
 }
}

 //public class Buchungsbeispiel_DB4_LTS
 //{
 // de.WWWings.Test.DB.DatenbankDataContext db = new de.WWWings.Test.DB.DatenbankDataContext();

 // public int NewBuchung()
 // {
 //  int FNummer = 221;
 //  int PNummer = 2730;
 //  int Platzanzahl = 2;
 //  int Buchungscode = Convert.ToInt32(FNummer.ToString() + PNummer.ToString());

 //  // Transaktion, nur erfolgreich wenn Platzanzahl reduziert und Buchung erstellt!
 //  using (System.Transactions.TransactionScope t = new System.Transactions.TransactionScope())
 //  {
 //   try
 //   {
 //    //Passagier
 //    PS_Passagier Passagier = (from p in db.PS_Passagiers where p.PS_ID == PNummer select p).SingleOrDefault();
 //    Console.WriteLine(Passagier.PS_ID);
 //    // Flug
 //    FL_Fluege EinzelnerFlug = (from f in db.FL_Flueges where f.FL_FlugNr == FNummer select f).SingleOrDefault();

 //    Console.WriteLine("Bestehende Buchungen:");
 //    foreach (GF_GebuchteFluege b in EinzelnerFlug.GF_GebuchteFlueges)
 //    {
 //     Console.WriteLine(b.GF_Buchungscode);
 //    }

 //    // Platzanzahl reduzieren
 //    Console.WriteLine("Platzanzahl reduzieren...");
 //    if (EinzelnerFlug != null)
 //    {
 //     if (EinzelnerFlug.FL_FreiePlaetze >= Platzanzahl)
 //     {
 //      Console.WriteLine("Platzanzahl vorher: " + EinzelnerFlug.FL_FreiePlaetze.ToString());
 //      EinzelnerFlug.FL_FreiePlaetze -= Platzanzahl;
 //      db.SubmitChanges(); // Speichern!!!
 //      Console.WriteLine("Platzanzahl nun: " + EinzelnerFlug.FL_FreiePlaetze.ToString());
 //     }
 //     else
 //     {
 //      return 0; // Kein Platz vorhanden!
 //     }
 //     // Buchung erstellen
 //     // mit LINQ-to-SQL aber über SQL:
 //     //db.ExecuteCommand("Insert into GF_GebuchteFluege (GF_FL_FlugNr,GF_PS_ID, GF_Buchungscode) values ( " +  FNummer + "," + PNummer + "," + Buchungscode + ")");
 //     // mit LINQ-to-SQL;
 //     Console.WriteLine("Buchung erstellen...");
 //     GF_GebuchteFluege b = new GF_GebuchteFluege();
 //     //b.GF_FL_FlugNr = FNummer;
 //     b.FL_Fluege = EinzelnerFlug;
 //     //b.GF_PS_ID = PNummer;
 //     b.PS_Passagier = Passagier;
 //     b.GF_Buchungscode = Buchungscode;
 //     db.GF_GebuchteFlueges.InsertOnSubmit(b); // Einfügen
 //     db.SubmitChanges(); // Speichern
 //    }
 //   } // End Try
 //   catch (Exception ex)
 //   {
 //    Console.WriteLine("Fehler: " + ex.Message);
 //    return 0;
 //   }
 //   // Transaktion erfolgreich
 //   t.Complete();
 //  } // End Transaktion
 //  Console.WriteLine("Abgeschlossen. Buchungscode: " + Buchungscode.ToString());
 //  return Buchungscode;
 // }
 //}

