﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace de.WWWings.Test.Modelle.EF6
{
 class EF6Demos
 {


  public static void RunAdd()
  {
   Console.WriteLine("Adding...");
   EF6.WWWings6Entities db = new WWWings6Entities();

   EF6.Protokoll p = new Protokoll();
   p.Text = "EF6";

   db.AddToProtokoll(p);
   Console.WriteLine(db.SaveChanges());

   Console.WriteLine("Saved!");
   Console.WriteLine(p.ID);
   Console.WriteLine(p.Zeit);
  }

  /// <summary>
  /// Lesezugriff auf einen unbearbeiteten View
  /// </summary>
  public static void RunViewOriginal()
  {
   Console.WriteLine("Start...");
   EF6.Entities db = new EF6.Entities(System.Configuration.ConfigurationManager.ConnectionStrings["WWWings6EntitiesViews"].ConnectionString);


   var Passagiere = db.AllePassagiere;

    foreach( var p in Passagiere) Console.WriteLine(p.Name);

   db.Dispose();

  }


  /// <summary>
  /// Beweis, dass man einen nachbearbeiteten View auch beschreiben kann
  /// </summary>
  public static void RunViewChange()
  {
   Console.WriteLine("Changing...");
   EF6.Entities db = new EF6.Entities(System.Configuration.ConfigurationManager.ConnectionStrings["WWWings6EntitiesViews"].ConnectionString);

   var Mitarbeiter = (from m in db.AlleMitarbeiter where m.PersonID == 100 select m).FirstOrDefault();

   Mitarbeiter.Name = "Bäcker";

  Console.WriteLine(db.SaveChanges());
  }
 }
}
