﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using de.WWWings.Test.Modelle.EF6Vererbung;

namespace de.WWWings.Test.Modelle.EF6Vererbung
{
 class EF6VerbungDemos
 {

  public static void Run2()
  {

   // Modell instanziieren unter Verwendung der Verbindungszeichenfolge aus Konfigurationsdatei
   using (WWWings6Entities modell = new WWWings6Entities())
   {
    string ort = "Rom";
    string name = "Müller";

    // Abfrage definieren 
    var fluege = from f in modell.Flug
                 where f.Abflugort == ort && f.Passagier.Count > 0 && f.Passagier.Any(p => p.Name == name)
                 select f;
    // Ergebnis ausgeben
    foreach (Flug f in fluege)
    {
     Console.WriteLine("Flug Nr {0} von {1} nach {2} hat {3} freie Plätze!", f.FlugNr, f.Abflugort, f.Zielort, f.FreiePlaetze);

     // Passagiere ausgeben
     foreach (Passagier ps in f.Passagier)
     {
      Console.WriteLine(" - " + ps.Name);

      // Entferne den Passagier mit gesuchtem Namen
      if (ps.Name == name) f.Passagier.Remove(ps);
     }

     // Platzanzahl erhöhen
     f.FreiePlaetze++;
    }

    // Alle Änderung speichern
    modell.SaveChanges();
   } // Ende using-Block -> Dispose() wird aufgerufen

  }


  public static void Run1()
  {
   Console.WriteLine("Get Passagier...");

   WWWings6Entities modell = new WWWings6Entities();

   var q = modell.Person.OfType<Passagier>().Take(1);

   foreach (Passagier p in q)
   {
    Console.WriteLine(p.Name);
   }


  }

  
 }
}
