﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace de.WWWings.Test.LINQ
{
 class SerialDemo
 {

  /// <summary>
  /// Serialisierung und Deserialisierung eines Flug-Objekts
  /// </summary>
  public static void EF()
  {
   const string BDATEI = "FlugEF.bin";
   const string XDatei = "flugEF.xml";
   const string JDatei = "flugEF.txt";
   Modelle.EF6.Flug Flug;

   using (Modelle.EF6.WWWings6Entities db1 = new Modelle.EF6.WWWings6Entities())
   {

    Flug = (from f in db1.Flug.Include("Passagier.Person")
            where f.FlugNr == 101
            select f).FirstOrDefault();


    //VerschiedeneDemos_CS.FCL3.UniversalSerialisierer.Save(VerschiedeneDemos_CS.FCL3.SerialTyp.BINARY, Flug, BDATEI);
    //VerschiedeneDemos_CS.FCL3.UniversalSerialisierer.Save(VerschiedeneDemos_CS.FCL3.SerialTyp.JSON, Flug, JDatei);
    VerschiedeneDemos_CS.FCL3.UniversalSerialisierer.Save(VerschiedeneDemos_CS.FCL3.SerialTyp.XML, Flug, XDatei);
   }
  }

  /// <summary>
  /// Serialisierung und Deserialisierung eines Flug-Objekts
  /// </summary>
  public static void LTS()
  {
   const string BDATEI = "FlugLTS.bin";
   const string XDatei = "FlugLTS.xml";
   const string JDatei = "flugLTS.txt";
   using (Modelle.LTS6.WWWings6DataContext db1 = new Modelle.LTS6.WWWings6DataContext())
   {

    var flug = (from f in db1.Flug
            where f.FlugNr == 101
            select f).FirstOrDefault();


    //VerschiedeneDemos_CS.FCL3.UniversalSerialisierer.Save(VerschiedeneDemos_CS.FCL3.SerialTyp.BINARY, flug, BDATEI);
    VerschiedeneDemos_CS.FCL3.UniversalSerialisierer.Save(VerschiedeneDemos_CS.FCL3.SerialTyp.JSON, flug, JDatei);
    VerschiedeneDemos_CS.FCL3.UniversalSerialisierer.Save(VerschiedeneDemos_CS.FCL3.SerialTyp.XML, flug, XDatei);

   }
  }
 }
}
