//INSTANT C# NOTE: Formerly VB.NET project-level imports:
using System;
using System.Collections;
using System.Data;
using System.Diagnostics;


using System.Globalization;
using System.Threading;


namespace ITV
{



 // ////////////////////////// Zeitmesser

 public class Timer
 {
  public string timername;
  public long anzahl;
  public double summe;
  public double RAMSumme;
  public static bool ShowProgress = true;

  public string Info
  {
   get
   {
    return anzahl + ". " + timername + ": MS = " + ((long)summe) + ", KB " + (long)(RAMSumme / anzahl);
   }
  }

  public string Total
  {
   get
   {
    return anzahl + "x " + timername + ": MS = " + (((long)summe) / anzahl) + ", KB = " + (long)(RAMSumme / anzahl);
   }

  }

  public static System.DateTime startzeit;
  public static string CurrentTimer;
  public static long RAM;
  public static System.Collections.Generic.Dictionary<string, Timer> timers = new System.Collections.Generic.Dictionary<string, Timer>();

  // === Zeitnahme beginnen
  public static void Start(string name)
  {

  RAM = GetRAMBedarf();
  CurrentTimer = name;
   startzeit = DateTime.Now;
  }

  // === Zeitnahme beenden
  public static void End()
  {
   long zeit = 0;

   zeit = (long)(DateTime.Now.Subtract(startzeit).TotalMilliseconds);
   long currentram = GetRAMBedarf() - RAM;
   if (ShowProgress) Out(CurrentTimer + ": MS = " + zeit + ", KB = " + currentram);

   if (timers.ContainsKey(CurrentTimer)) // bestehender Timer
   {
    timers[CurrentTimer].timername = CurrentTimer;
    timers[CurrentTimer].summe += zeit;
    timers[CurrentTimer].anzahl += 1;
    timers[CurrentTimer].RAMSumme += currentram;
   }
   else // Neuer Timer
   {
    Timer t = new Timer();
    t.anzahl = 1;
    t.summe = zeit;
    t.RAMSumme = currentram;
    timers.Add(CurrentTimer, t);
   }

  }

  // === Zeitauswertung
  public static void Results()
  {
   //INSTANT C# NOTE: Commented this declaration since looping variables in 'foreach' loops are declared in the 'foreach' header in C#
   //		string timername = null;
   Console.ForegroundColor = ConsoleColor.Yellow;
   Out("Auswertung (Durchschnittswerte):");
   foreach (string timername in timers.Keys)
   {
    Timer t = timers[timername] as Timer;
    Out(t.Total);
   
   }
   timers.Clear();
   Console.ForegroundColor = ConsoleColor.Gray;
  }

  public static long GetRAMBedarf()
  {
   System.Diagnostics.Process p = System.Diagnostics.Process.GetCurrentProcess();
   return ((long)(Math.Round((double)(p.WorkingSet64 / 1024), 0, MidpointRounding.ToEven)));
  }

  public static void Out(string s)
  {
   Console.WriteLine(s);
  }

 }
}
