﻿using System;
using System.Collections.Generic;
using System.Text;
using ITV;
using NHibernate;
using NHibernate.Cfg;
using WWWIngs.Core.Domain;
using System.Data.SqlClient;


namespace WWW_NHibernate
{
 class DALBarometer
 {

  public static void DataReader()
  {
   string CONNSTRING = System.Configuration.ConfigurationManager.ConnectionStrings["CS_WWings"].ConnectionString;
   SqlConnection conn = new SqlConnection(CONNSTRING);
   conn.Open();
   string SQL = "Select * from FL_Fluege";

   SqlDataReader dr = new SqlCommand(SQL, conn).ExecuteReader();

   while (dr.Read())
   {
    int nr = Convert.ToInt32(dr["FL_FlugNr"]);
   }

   dr.Dispose();
   conn.Close();

  }


  

  public static List<int> GetRandom()
  {
   List<int> Zahlen = new List<int>();
   System.Random r = new Random(1000);

   for (int i = 0; i < 10; i++)
   {
    Zahlen.Add(r.Next(100, 10000));
   }

   return Zahlen;
  }

  public static void ReadRandom()
  {

   // ------ Vorbereitung
   Configuration cfg = new Configuration();
   // Laden aller eingebetten Mapping-Dateien in dieser Assenly
   cfg.AddAssembly("WWW_NHibernate");
   ISessionFactory factory = cfg.BuildSessionFactory();
   ISession session = factory.OpenSession();

   foreach (int FlugNr in GetRandom())
   {
    //Alternative 1
    string SQL = "Select * from FL_Fluege where FL_FlugNr = " + FlugNr;
    // ------ Fluganzahl (SQL Direkt)
    IList<Flug> Menge = session.CreateSQLQuery(
     SQL)
     .AddEntity(typeof(Flug)).List<Flug>();
    Flug f = Menge[0];

    // Alternative 2  ist ein klein wenig schneller (ca. 10%)
    //Flug f = (Flug)session.Get(typeof(Flug), FlugNr);

    //Zugriff auf INT
    int? i = f.FLFreiePlaetze;
  
   }



   session.Close();
  }

  public static void ChangeRandom()
  {

   // ------ Vorbereitung
   Configuration cfg = new Configuration();
   // Laden aller eingebetten Mapping-Dateien in dieser Assenly
   cfg.AddAssembly("WWW_NHibernate");
   ISessionFactory factory = cfg.BuildSessionFactory();
   ISession session = factory.OpenSession();
  
   foreach (int FlugNr in GetRandom())
   {
    //Alternative 1
    string SQL = "Select * from FL_Fluege where FL_FlugNr = " + FlugNr;
    // ------ Fluganzahl (SQL Direkt)
    IList<Flug> Menge = session.CreateSQLQuery(
     SQL)
     .AddEntity(typeof(Flug)).List<Flug>();
    Flug f = Menge[0];

    // Alternative 2  ist ein klein wenig schneller (ca. 10%)
    //Flug f = (Flug)session.Get(typeof(Flug), FlugNr);

    //Zugriff auf INT
    ITransaction trans = session.BeginTransaction();
    f.FLFreiePlaetze--;
 trans.Commit();

    //session.Save(f);
    //Console.WriteLine(f.FLFreiePlaetze);

    //session.Refresh(f);
    //Console.WriteLine(f.FLFreiePlaetze);
   }

  

   session.Close();
  }


  public static void ReadAll()
  {
   // ------ Vorbereitung
   Configuration cfg = new Configuration();
   // Laden aller eingebetten Mapping-Dateien in dieser Assenly
   cfg.AddAssembly("WWW_NHibernate");
   ISessionFactory factory = cfg.BuildSessionFactory();
   ISession session = factory.OpenSession();

   // ------ Fluganzahl (SQL Direkt)
   IList<Flug> Menge = session.CreateSQLQuery(
    "Select * from FL_Fluege")
    .AddEntity(typeof(Flug)).List<Flug>();

   //Console.WriteLine("Anzahl Flüge: " + Menge.Count);

   foreach (Flug f in Menge)
   {
    int i = f.FLFlugNr;
   }

   session.Close();
  }

  public static void ChangeMany()
  {
   // ------ Vorbereitung
   Configuration cfg = new Configuration();
   // Laden aller eingebetten Mapping-Dateien in dieser Assenly
   cfg.AddAssembly("WWW_NHibernate");
   ISessionFactory factory = cfg.BuildSessionFactory();
   ISession session = factory.OpenSession();

   // ------ Fluganzahl (SQL Direkt)
   IList<Flug> menge = session.CreateSQLQuery(
    "Select top(1000) * from FL_Fluege")
    .AddEntity(typeof(Flug)).List<Flug>();

   //Console.WriteLine("Anzahl Flüge: " + Menge.Count);
    ITransaction trans = session.BeginTransaction();
   foreach (Flug f in menge)
   {

    f.FLFreiePlaetze--;


   }
    trans.Commit();
   session.Close();
  }

 }
}
