using System;
using System.Collections.Generic;
using System.Text;
using NHibernate.Cfg;
using NHibernate.Mapping;
using NHibernate;
using Console_NHibernate2;

namespace ConsoleApplication1
{
 class Program
 {
  static void Main(string[] args)
  {

   WWWings1();


   //Configuration cfg = new Configuration();
   //// Laden aller eingebetten Mapping-Dateien in dieser Assenly
   //cfg.AddAssembly(System.Reflection.Assembly.GetExecutingAssembly());
   //ISessionFactory factory = cfg.BuildSessionFactory();
   //ISession session = factory.OpenSession();


   //// ------ Fluganzahl (SQL Direkt)
   //IList<FL_Fluege> Menge = session.CreateSQLQuery(
   //  "Select * from FL_Fluege where FL_FlugNr < 111")
   //  .AddEntity(typeof(FL_Fluege)).List<FL_Fluege>();



   Console.ReadLine();
  }

  private static void WWWings1()
  {
   Configuration cfg = new Configuration();
   // Laden aller eingebetten Mapping-Dateien in dieser Assenly
   cfg.AddAssembly(System.Reflection.Assembly.GetExecutingAssembly());
   ISessionFactory factory = cfg.BuildSessionFactory();
   ISession session = factory.OpenSession();

   Print("Einige Flge");
   

   // ------ Alternative 1: Fluganzahl (HQL)
   string q = "from FL_Fluege as f where f.FL_FlugNr < 111";

   // ------ Alternative 2: Fluganzahl (SQL Direkt)
   //IList<FL_Fluege> Menge = session.CreateSQLQuery(
   //  "Select * from FL_Fluege where FL_FlugNr < 111")
   //  .AddEntity(typeof(FL_Fluege)).List<FL_Fluege>();

   IQuery query = session.CreateQuery(q);
   IEnumerable<FL_Fluege> Menge2 = query.Enumerable<FL_Fluege>();

   foreach (FL_Fluege f in Menge2)
   {
    Console.WriteLine(f.FL_FlugNr + ";" + f.FL_Abflugort + ";" + f.FL_Zielort);
    foreach (GF_GebuchteFluege g in f.GF_GebuchteFluege)
    {
     Console.WriteLine("   " + g.GF_Buchungscode);
    }
   }


   // Beispiel 2

   //Print("Rckgabe ist elementarer Typ");
   //q = "Select f.FL_Zielort from FL_Fluege as f where f.FL_FlugNr < 111";
   //query = session.CreateQuery(q);
   //NHibernate.Util.GenericJoinedEnumerable<string> Menge3 = query.Enumerable<string>() as NHibernate.Util.GenericJoinedEnumerable<string>;
   //Print(Menge3);


   Print("Rckgabe mehrerer Spalten");
   q = "Select f.FL_Abflugort, f.FL_Zielort from FL_Fluege as f where f.FL_FlugNr < 111";
   query = session.CreateQuery(q);
   IEnumerable<object[]> Menge4 = query.Enumerable<Object[]>();
   Print(Menge4);

   Print("Rckgabe mehrerer Spalten / Order By");
   q = "Select f.FL_Abflugort, f.FL_Zielort from FL_Fluege as f where f.FL_FlugNr < 111 order by f.FL_Zielort";
   query = session.CreateQuery(q);
   Menge4 = query.Enumerable<Object[]>();
   Print(Menge4);

   Print("Aggregat");
   q = "Select max(f.FL_FreiePlaetze), avg(f.FL_FreiePlaetze) from FL_Fluege as f where f.FL_FlugNr < 111";
   query = session.CreateQuery(q);
   Menge4 = query.Enumerable<Object[]>();
   Print(Menge4);

   Print("Group - eine Spalte");
   q = "Select f.FL_Zielort from FL_Fluege as f group by f.FL_Zielort";
   query = session.CreateQuery(q);
   IEnumerable<string> Menge5 = query.Enumerable<string>();
   Print((IEnumerable<string>)Menge5);

   Print("Group - mit Aggregat");
   q = "Select f.FL_Zielort, avg(f.FL_FreiePlaetze) from FL_Fluege as f group by f.FL_Zielort";
   query = session.CreateQuery(q);
   Menge4 = query.Enumerable<object[]>();
   Print(Menge4);

   Print("Subquery");
   q = "Select f from FL_Fluege as f where f.FL_Abflugort not in (select g.FL_Zielort from FL_Fluege as g where g.FL_FlugNr < 110)";
   query = session.CreateQuery(q);
   Menge2 = query.Enumerable<FL_Fluege>();
   Print(Menge2);
   

   // Dispose
   session.Close();
  }

  private static void Print(IEnumerable<FL_Fluege> Menge2)
  {
   foreach (FL_Fluege f in Menge2)
   {
    Console.WriteLine(f.FL_FlugNr + ";" + f.FL_Abflugort + ";" + f.FL_Zielort);
   }
  }

  private static void Print(IEnumerable<string> Menge3)
  {
   foreach (string f in Menge3)
   {
    Console.WriteLine(f);
   }
  }

  private static void Print(IEnumerable<object[]> Menge4)
  {
   foreach (Object[] obj in Menge4)
   {
    foreach (object prop in obj)
    {
     Console.Write(prop + ";");
    }
    Console.WriteLine();
   }
  }

  private static void Print(string p)
  {
   Console.ForegroundColor = ConsoleColor.Yellow;
   Console.WriteLine(p);
   Console.ForegroundColor = ConsoleColor.Gray;
  }
 }
}
