﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.DirectoryServices.AccountManagement;

namespace VerschiedeneDemos_CS.FCL3
{
 public class ADManagement
 {


  public static void BenutzerSuchen()
  {
   // Stamm für alle weiteren Operationen festlegen
   PrincipalContext ctx = new PrincipalContext(ContextType.Domain, "E02", "DC=IT-Visions,DC=local");

   Console.WriteLine("---- Aktueller Benutzer: ");

   Console.WriteLine("Namen:");
   Console.WriteLine(UserPrincipal.Current.Name);
   Console.WriteLine(UserPrincipal.Current.SamAccountName);
   Console.WriteLine(UserPrincipal.Current.DistinguishedName);
   Console.WriteLine(UserPrincipal.Current.DisplayName);
   Console.WriteLine(UserPrincipal.Current.EmployeeId);
   Console.WriteLine(UserPrincipal.Current.GivenName);
   Console.WriteLine(UserPrincipal.Current.Surname);
   Console.WriteLine(UserPrincipal.Current.Description);
   Console.WriteLine(UserPrincipal.Current.Sid);

   Console.WriteLine("Adressen:");
   Console.WriteLine(UserPrincipal.Current.EmailAddress);
   Console.WriteLine(UserPrincipal.Current.VoiceTelephoneNumber);

   Console.WriteLine("Konfiguration:");
   Console.WriteLine(UserPrincipal.Current.HomeDirectory);
   Console.WriteLine(UserPrincipal.Current.HomeDrive);
   Console.WriteLine(UserPrincipal.Current.Enabled);

   Console.WriteLine("Anmeldungen:");
   Console.WriteLine(UserPrincipal.Current.LastLogon);
   Console.WriteLine(UserPrincipal.Current.BadLogonCount);
   Console.WriteLine(UserPrincipal.Current.LastPasswordSet);
   Console.WriteLine(UserPrincipal.Current.PasswordNeverExpires);
   Console.WriteLine(UserPrincipal.Current.UserCannotChangePassword);

   Console.WriteLine("---- Bestimmter Benutzer: ");
   UserPrincipal u = UserPrincipal.FindByIdentity(ctx, IdentityType.SamAccountName, "hs");
   Console.WriteLine(u.Name);


   Console.WriteLine("Alle Benutzer, die in den letzten 30 Tagen ihr Kennwort falsch eingegeben haben:");
   foreach (var p in UserPrincipal.FindByBadPasswordAttempt(ctx, DateTime.Now.Subtract(TimeSpan.FromDays(30)), MatchType.GreaterThanOrEquals))
   {
    Console.WriteLine(p.Name + ": " + p.LastBadPasswordAttempt);
    // p.ExpirePasswordNow();
   }

   Console.WriteLine("Alle Benutzer, die in den letzten 30 Tagen ihr Kennwort geändert haben:");
   foreach (var p in UserPrincipal.FindByPasswordSetTime(ctx, DateTime.Now.Subtract(TimeSpan.FromDays(30)), MatchType.GreaterThanOrEquals))
   {
    Console.WriteLine(p.Name + ":" + p.LastPasswordSet);
   }

   Console.WriteLine("Alle Benutzer, die in den letzten 24 Stunden angemeldet haben:");
   foreach (var p in UserPrincipal.FindByLogonTime(ctx, DateTime.Now.Subtract(TimeSpan.FromHours(24)), MatchType.GreaterThanOrEquals))
   {
    Console.WriteLine(p.Name + ": " + p.LastLogon);
   }
  }

  public static void BenutzerAendern()
  {
   // Stamm für alle weiteren Operationen festlegen
   PrincipalContext ctx = new PrincipalContext(ContextType.Domain, "E02", "DC=IT-Visions,DC=local");

   Console.WriteLine("--- Benutzer holen: ");
   UserPrincipal u = UserPrincipal.FindByIdentity(ctx, IdentityType.SamAccountName, "hs");
   Console.WriteLine(u.Name);
   Console.WriteLine(u.EmailAddress);

   Console.WriteLine("--- Benutzer verändern: ");
   u.EmailAddress = "hs@IT-Visions.de";

   Console.WriteLine("--- Änderungen speichern: ");
   u.Save();
  }


  public static void BenutzerAnlegen()
  {
   // Stamm für alle weiteren Operationen festlegen
   PrincipalContext ctx = new PrincipalContext(ContextType.Domain, "E02", "cn=Users,DC=IT-Visions,DC=local");
   // Benutzerobjekt erzeugen
   UserPrincipal b = new UserPrincipal(ctx);
   // Daten setzen
   b.Surname = "Schwichtenberg";
   b.GivenName = "Felix";
   b.DisplayName = "Felix Schwichtenberg";
   b.SamAccountName = "FS3";
   b.SetPassword("Sehr+Geheim");
   b.Enabled = true;
   // Speichern
   b.Save();
  }

  public static void BenutzerZuGruppe()
  {
   PrincipalContext ctx = new PrincipalContext(ContextType.Domain, "E02", "DC=IT-Visions,DC=local");
   Console.WriteLine("--- Benutzer holen");
   UserPrincipal b = UserPrincipal.FindByIdentity(ctx, IdentityType.SamAccountName, "FS");
   Console.WriteLine("--- Gruppe holen");
   GroupPrincipal group = GroupPrincipal.FindByIdentity(ctx, "Domain Admins");
   Console.WriteLine("--- Benutzer zuordnen");
   group.Members.Add(b);
   Console.WriteLine("--- Gruppe speichern");
   group.Save();
  }


  public static void KennwortPruefung()
  {
   string Benutzer = "SabineBernd";
   string BenutzerVerzeichnisname = "Sabine Bernd";
   string Kennwort1 = "falschesKennwort";
   string Kennwort2 = "test+123";

   PrincipalContext ctx = new PrincipalContext(ContextType.Domain, null, "DC=IT-Visions,DC=local");
   bool b = ctx.ValidateCredentials(Benutzer, Kennwort1);
   if (!b)
    Console.WriteLine("falsches Kennwort");

   
   // Setzen des Kennwortes
   UserPrincipal u = UserPrincipal.FindByIdentity(ctx, IdentityType.Name, BenutzerVerzeichnisname);
   u.SetPassword(Kennwort2);
   Console.WriteLine("Kennwort gesetzt!");

   b = ctx.ValidateCredentials(Benutzer, Kennwort2);
   if (b)
    Console.WriteLine("richtiges Kennwort!");
  }


 }
}
