﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO.Pipes;
using System.IO;

namespace VerschiedeneDemos_CS.FCL3
{
 public class PipeDemo
 {

  /// <summary>
  /// Named Pipe Server
  /// </summary>
  public static void RunServer()
  {
   Console.WriteLine("Starte Server...");
   using (var p = new NamedPipeServerStream("WWWingsPipe3"))
   {
    p.WaitForConnection();

    using (var r = new StreamReader(p))
    {
     while (true)
     {
      string Daten = r.ReadLine();
      if (Daten == null) break;
      Console.WriteLine("Daten empfangen: " + Daten);
     }
    }
    Console.WriteLine("Beende Server...");
   }
  }

  /// <summary>
  /// Named Pipe Client
  /// </summary>
  public static void RunClient()
  {
   Console.WriteLine("Starte Client...");
   NamedPipeClientStream p = new NamedPipeClientStream("WWWingsPipe3");
   p.Connect();
   StreamWriter w = new StreamWriter(p);
   //w.AutoFlush = true;
   Console.WriteLine("Sende Daten...");
   w.WriteLine("Daten...Daten...Daten...");
   w.WriteLine("Daten...Daten...Daten...");
   w.Close();
   p.Close();
   Console.WriteLine("Client beendet!");
  }






 }
}
