﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics.Contracts;

namespace NET4_GL.Code_Contracts
{
  public class Account
  {
   [ContractPublicPropertyName("Balance")]
    protected int balance;

    public int Balance { get { return balance; } }
    public void Deposite(int amount)
    {
      Contract.Requires(amount > 0);
      balance += amount;
    }

    public void Withdraw(int amount)
    {
      Contract.Requires(amount > 0);
      if (balance - amount >= 0)
        balance -= amount;
      else
        throw new ApplicationException("balance < amount");
    }

    [ContractInvariantMethod()]
    private void InvariantMethod()
    {
      Contract.Invariant(balance >= 0);
    }

  }

}
