﻿

Imports System
Imports System.Collections.Generic
Imports de.WWWings.Library
Imports Microsoft.VisualBasic


Namespace NET3.SpracheVB.Demo_Sprachfeatures
 Partial Friend Class Vorstandsmitglied
  Private privateName As String
  Public Property Name() As String
   Get
    Return privateName
   End Get
   Set(ByVal value As String)
    privateName = value
   End Set
  End Property
  Private privateAufgabengebiet As String
  Public Property Aufgabengebiet() As String
   Get
    Return privateAufgabengebiet
   End Get
   Set(ByVal value As String)
    privateAufgabengebiet = value
   End Set
  End Property
  Private privateAlter As Integer
  Public Property Alter() As Integer
   Get
    Return privateAlter
   End Get
   Set(ByVal value As Integer)
    privateAlter = value
   End Set
  End Property
  Private privateOrt As String
  Public Property Ort() As String
   Get
    Return privateOrt
   End Get
   Set(ByVal value As String)
    privateOrt = value
   End Set
  End Property

  Public Overrides Function ToString() As String
   ' Partielle Methode - Verwendung
   OnToString()
   Return Me.Name
  End Function

  ' Partielle Methode - Deklaration
  Partial Private Sub OnToString()

  End Sub
 End Class


 Partial Class Vorstandsmitglied
  ' Partielle Methode - Implementierung
  Private Sub OnToString()
   Console.WriteLine("ToString aufgerufen!")
  End Sub
 End Class




 Public Class Fluggesellschaft_Client



  ''' <summary>
  ''' Testmethode
  ''' </summary>
  ''' <remarks></remarks>
  Public Sub Test()

  End Sub


  Public Shared Sub RunLambda()

   ' Lambda-Ausdrücke deklarieren
   Dim f1 As Func(Of Integer, Integer) = Function(x) x + 1
   Dim f2 As Func(Of String, String) = Function(s) s.ToUpper()
   Dim f3 As Func(Of String, Integer) = Function(s) s.Length
   Dim f4 As Func(Of String, Integer, String) = Function(s, i) s.Substring(0, i)

   ' Laut der Doku soll es so gehen, geht aber nicht!
   Dim f5 = Function(num As Integer) num + 1
   ' Const so geht es
   Dim f6 As Func(Of Integer, Integer) = Function(num As Integer) num + 1
   Console.WriteLine(f5(10)) ' ergibt 11


   ' Lambda-Ausdrücke verwenden
   Console.WriteLine(f1(10)) ' ergibt 11
   Console.WriteLine(f2("World Wide Wings")) ' ergibt "HALLO"
   Console.WriteLine(f3("World Wide Wings")) '  ergibt WORLD WIDE WINGS
   Console.WriteLine(f4("World Wide Wings", 10)) ' ergibt "World Wide"

  End Sub

  Public Shared Sub run()


   ' Object Initializer
   Dim MM As New Vorstandsmitglied() With {.Name = "Max Müller", .Aufgabengebiet = "Flugbetrieb", .Alter = 33}
   Dim HM As New Vorstandsmitglied() With {.Name = "Hans Meier", .Aufgabengebiet = "Personal", .Alter = 42}
   Dim HS As New Vorstandsmitglied() With {.Name = "Hubert Schmidt", .Aufgabengebiet = "Marketing", .Alter = 35, .Ort = "Essen"}

   ' Collection Initializer sind nicht vorhanden in VB 9.0!
   Dim Vorstandsmitglieder As New List(Of Vorstandsmitglied)
   Vorstandsmitglieder.Add(MM)
   Vorstandsmitglieder.Add(HM)
   Vorstandsmitglieder.Add(HS)

   ' Verwendung einer Erweiterungsmethode
   Vorstandsmitglieder.Print(ConsoleColor.DarkYellow)


   ' Local Variable Type Inference für String
   Dim Heimatflughafen = "Essen/Mülheim"
   Console.WriteLine(Heimatflughafen.GetType().FullName)

   ' Local Variable Type Inference für Int32
   Dim Anzahl = Vorstandsmitglieder.Count
   Console.WriteLine(Anzahl.GetType().FullName)

   ' Local Variable Type Inference für die Klasse Vorstandsmitglied
   Dim Vorstandvorsitzender = Vorstandsmitglieder(0)
   Console.WriteLine(Vorstandvorsitzender.GetType().FullName)

   ' Anonyme Typen
   Dim Fluggesellschaft = New With {Key .Name = "World Wide Wings", .Gruendungsdatum = New DateTime(2005, 1, 1), .Vorstand = Vorstandsmitglieder}
   Console.WriteLine(Fluggesellschaft.GetType().FullName)

   '  2., gleich aufgebauter anonymer Typ
   Dim Flugzeugbauer = New With {Key .Name = "Strong Winds Corp.", .Gruendungsdatum = New DateTime(1972, 8, 1), .Vorstand = Nothing}
   Console.WriteLine(Flugzeugbauer.GetType().FullName)




   ' If-Operator
   Dim StellvertretenderVorstandsvorsitzer As Vorstandsmitglied

   ' Besetzung des Vorstandes
   StellvertretenderVorstandsvorsitzer = MM
   Vorstandvorsitzender = Nothing

   ' Ausgabe des amtierenden Chefs (alte Variante, führt zu Laufzeitehler  "Object variable or With block variable not set."
   '  Dim NameDesAmtierendenChefs_Alt As String = IIf(Vorstandvorsitzender IsNot Nothing, Vorstandvorsitzender.Name, StellvertretenderVorstandsvorsitzer.Name)

   ' Ausgabe des amtierenden Chefs (neu ab 2008 mit echtem IF-Operator)
   Dim NameDesAmtierendenChefs_Neu As String = If(Vorstandvorsitzender IsNot Nothing, Vorstandvorsitzender.Name, StellvertretenderVorstandsvorsitzer.Name)






   'Dim add1 = Function(num As Integer) num + 1

   'Console.WriteLine(add1(5))


  End Sub

  Public Shared Sub NullableTypes_Buchversion()
   ' Werttyp ohne Null
   Dim a As Integer = 1
   Dim b As Integer = 0
   ' Werttyp mit Null erlaubt
   Dim x As Nullable(Of Integer) = Nothing ' oder 2
   Dim y As Integer? = 6

   Dim s1 As String = x.HasValue.ToString()
   'Dim s2 As String = x
   'Dim s3 As String = x.Value.ToString()
   Dim s4 As String = x.ToString()
   Dim z As System.Nullable(Of Integer) = x + 10
   'Dim a1 As Integer = x
   Dim a2 As Integer = CType(x, Integer)

   Console.WriteLine(s1)
   'Console.WriteLine(s2)

   'Console.WriteLine(s3)

   Console.WriteLine(s4)

   Console.WriteLine(z)

   'Console.WriteLine(a1)

   Console.WriteLine(a2)




  End Sub


  Public Shared Sub NullableTypes_Ausfuehrlich()

   ' Werttyp ohne Null
   Dim a As Integer = 1
   Dim b As Integer = 0
   ' Werttyp mit Null erlaubt
   Dim x As Nullable(Of Integer) = 2
   Dim y As Integer? = 6

   ' a = null; // verboten!
   x = Nothing ' Erlaubt
   '    y = x.Value; // verboten, wenn x = null
   Console.WriteLine("a=" & a)
   Console.WriteLine("b=" & b)
   Console.WriteLine("x=" & x & " Wert? " & x.HasValue)
   Console.WriteLine("x=" + x.Value + " Wert? " + x.HasValue)
   Console.WriteLine("y=" & y.Value & " Wert? " & y.HasValue)

   ' erlaubt
   a = b
   x = y
   y = x + 10 ' null + Zahl = null
   x = a
   Dim s2 As String = x.ToString()
   Dim s3 As String = x.HasValue.ToString()
   ' nicht erlaubt
   '  a = x; --> Error	49	Cannot implicitly convert type 'int?' to 'int'. An explicit conversion exists (are you missing a cast?)
   '    b = x + 10;
   ' erlaubt, aber Laufzeitfehler, falls x = null
   x = Nothing
   a = CInt(x)
   Dim s4 As String = x.Value.ToString()

   'besser:
   If x.HasValue Then
    a = x
   Else
    a = 0
   End If

   ' Explizite Deklaration

   Console.WriteLine(y.HasValue.ToString())
   Console.WriteLine(y.Value.ToString()) ' Achtung: Geht nur, wenn c tatsächlich einen Wert hat!

   ' Besser: "Null" abfangen
   If x.HasValue Then
    Console.WriteLine("b = " & (x.Value.ToString()))
   Else
    Console.WriteLine("b = " & ("null"))
   End If

   ' Neuer ?? Operator
   ' --------------------------

   ' Umwandlung eines Nullable Int in einen Int
   Dim d As Nullable(Of Integer) = Nothing
   Dim e As Integer
   If d.HasValue Then
    e = d
   Else
    e = -1
   End If

   ' Behandlung eines Strings
   Dim s As String = Nothing
   If s Is Nothing Then
    Console.WriteLine("s = " & (s))
   Else
    Console.WriteLine("s = " & ("(kein Inhalt)"))
   End If

   ' geht nicht Demo.Print("d = " + (d ?? "null"));

   ' Demo.Print("d = " + (d ?? "null"));
  End Sub
 End Class


End Namespace
